(function () {
  'use strict';
  window.qTestExplorer = angular.module('qTesteXplorer', ['ngRoute', 'ui.bootstrap', 'rx']).config(['$routeProvider', function ($routeProvider) { }]);

}).call(this);

(function () {
  qTestExplorer.sizeUtils = (function () {
    return {
      centerCanvas: function (canvasHeight) {
        var container, difHeight, element;
        container = $("#editor");
        element = $("#canvas");
        if (canvasHeight < container.height()) {
          difHeight = container.height() - canvasHeight;
          return element.css("margin-top", (difHeight / 2) + "px");
        } else {
          return element.css("margin-top", "0");
        }
      },
      editorWidth: function () {
        var container;
        container = $("#editor");
        return container.width();
      },
      editorHeight: function () {
        var container;
        container = $("#editor");
        return container.height();
      }
    };
  })();

  qTestExplorer.colorUtils = (function () {
    return {
      getColor: function (hex) {
        if (hex == null) {
          return "";
        }
        if (hex.length <= 7) {
          return hex;
        }
        if (hex.indexOf("#00") === 0) {
          return "";
        }
        return "#" + hex.substring(3);
      },
      isHexaColor: (function (_this) {
        return function (sNum) {
          return (typeof sNum === "string") && (sNum.length === 6) && !isNaN(parseInt(sNum, 16));
        };
      })(this),
      hexToRgb: (function (_this) {
        return function (hex) {
          var result, rgb;
          result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
          rgb = {
            r: parseInt(result[1], 16),
            g: parseInt(result[2], 16),
            b: parseInt(result[3], 16)
          };
          return rgb;
        };
      })(this)
    };
  })();

  qTestExplorer.GuidUtils = (function () {
    return {
      generateGuid: function () {
        var d, uuid;
        d = new Date().getTime();
        uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
          var r;
          r = (d + Math.random() * 16) % 16 | 0;
          d = Math.floor(d / 16);
          return (c === 'x' ? r : r & 0x3 | 0x8).toString(16);
        });
        return uuid;
      }
    };
  })();

}).call(this);

(function () {
  var ToolbarController,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; };

  ToolbarController = (function () {
    ToolbarController.$inject = ['$scope', 'toolbarMessageChannel', 'dialogService'];

    function ToolbarController($scope, messageChannel, dialogService) {
      this.$scope = $scope;
      this.messageChannel = messageChannel;
      this.dialogService = dialogService;
      this.getToolFormatSettings = bind(this.getToolFormatSettings, this);
      this.getDefaultFormatAnnotationSettings = bind(this.getDefaultFormatAnnotationSettings, this);
      this.close = bind(this.close, this);
      this.save = bind(this.save, this);
      this.redo = bind(this.redo, this);
      this.undo = bind(this.undo, this);
      this.selectFontName = bind(this.selectFontName, this);
      this.selectFontSize = bind(this.selectFontSize, this);
      this.selectBorderSize = bind(this.selectBorderSize, this);
      this.selectTextColor = bind(this.selectTextColor, this);
      this.selectBackgroundColor = bind(this.selectBackgroundColor, this);
      this.selectBorderColor = bind(this.selectBorderColor, this);
      this.updateToolSetting = bind(this.updateToolSetting, this);
      this.selectTool = bind(this.selectTool, this);
      this.popultateToolData = bind(this.popultateToolData, this);
      this.populateFormatTools = bind(this.populateFormatTools, this);
      this.getActiveToolSetting = bind(this.getActiveToolSetting, this);
      this.keyEventHandler = bind(this.keyEventHandler, this);
      this.$scope.COLOR_OPTIONS = ['#00688B', '#1C86EE', '#75A1D0', '#0FDDAF', '#00C957', '#99CC32', '#ff0000', '#FF3E96', '#E47833', '#EEC900', '#f3ec00', '#B35AFF', '#000000', '#483000', '#987654', '#808080', '#DEDEDE', '#ffffff'];
      this.$scope.SIZE_OPTIONS = [2, 4, 6, 8, 10, 12];
      this.$scope.FONT_NAMES_OPTIONS = ["Arial", "Arial Black", "Comic Sans MS", "Courier New", "Georgia", "Impact", "Lucida Console", "Palatino Linotype", "Palatino", "Tahoma", "Times New Roman", "Trebuchet MS", "Verdana"];
      this.$scope.FONT_SIZE_OPTIONS = [10, 12, 18, 24, 32, 72];
      this.$scope.selectedTool = 'select';
      this.$scope.selectedBorderColor = '#ff0000';
      this.$scope.selectedTextColor = '#ff0000';
      this.$scope.selectedBackgroundColor = '';
      this.$scope.selectedBorderSize = 4;
      this.$scope.selectedFontName = "Arial";
      this.$scope.selectedFontSize = 18;
      this.$scope.selectTool = this.selectTool;
      this.$scope.selectBorderColor = (function (_this) {
        return function (borderColor) {
          _this.updateToolSetting('borderColor', borderColor);
          return _this.selectBorderColor(borderColor);
        };
      })(this);
      this.$scope.selectBackgroundColor = (function (_this) {
        return function (backgroundColor) {
          _this.updateToolSetting('backgroundColor', backgroundColor);
          return _this.selectBackgroundColor(backgroundColor);
        };
      })(this);
      this.$scope.selectTextColor = (function (_this) {
        return function (textColor) {
          _this.updateToolSetting('textColor', textColor);
          return _this.selectTextColor(textColor);
        };
      })(this);
      this.$scope.selectMoreBorderColor = (function (_this) {
        return function () {
          return _this.dialogService.showColorPicker(function (color) {
            if (color != null) {
              _this.updateToolSetting('borderColor', color);
              return _this.selectBorderColor(color);
            }
          });
        };
      })(this);
      this.$scope.selectMoreBackgroundColor = (function (_this) {
        return function () {
          return _this.dialogService.showColorPicker(function (color) {
            if (color != null) {
              _this.updateToolSetting('backgroundColor', color);
              return _this.selectBackgroundColor(color);
            }
          });
        };
      })(this);
      this.$scope.selectMoreTextColor = (function (_this) {
        return function () {
          return _this.dialogService.showColorPicker(function (color) {
            if (color != null) {
              _this.updateToolSetting('textColor', color);
              return _this.selectTextColor(color);
            }
          });
        };
      })(this);
      this.$scope.selectBorderSize = (function (_this) {
        return function (borderSize) {
          _this.updateToolSetting('borderSize', borderSize);
          return _this.selectBorderSize(borderSize);
        };
      })(this);
      this.$scope.selectFontSize = (function (_this) {
        return function (fontSize) {
          _this.updateToolSetting('fontSize', fontSize);
          return _this.selectFontSize(fontSize);
        };
      })(this);
      this.$scope.selectFontName = (function (_this) {
        return function (fontName) {
          _this.updateToolSetting('fontName', fontName);
          return _this.selectFontName(fontName);
        };
      })(this);
      this.$scope.undo = this.undo;
      this.$scope.redo = this.redo;
      this.$scope.save = this.save;
      this.$scope.close = this.close;
      this.$scope.$on('screen.loadedqTestVersion', (function (_this) {
        return function (event, version) {
          return _this.$scope.qTestVersion = version;
        };
      })(this));
      this.$scope.$on('toolbar.toolSelected', (function (_this) {
        return function (event, name) {
          if (_this.$scope.selectedTool !== name) {
            _this.$scope.selectedTool = name;
            return _this.populateFormatTools();
          }
        };
      })(this));
      this.$scope.$on('editor.created', (function (_this) {
        return function (event, editor) {
          return _this.$scope.editor = editor;
        };
      })(this));
      this.$scope.$on('screen.actionAdded', (function (_this) {
        return function (event, action) {
          return _this.selectTool('select');
        };
      })(this));
      this.$scope.$on('toolbar.annotationSelected', (function (_this) {
        return function (event, annotation) {
          _this.$scope.selectedAnnotation = annotation;
          return _this.populateFormatTools();
        };
      })(this));
      this.keyEventHandler();
      this.formatAnnotationSettings = this.getDefaultFormatAnnotationSettings();
    }

    ToolbarController.prototype.keyEventHandler = function () {
      window.key('command+z,ctrl+z', (function (_this) {
        return function () {
          if ($("#undo").hasClass("disabled")) {
            return;
          }
          $("#undo").click();
          return false;
        };
      })(this));
      window.key('command+y,ctrl+y', (function (_this) {
        return function () {
          if ($("#redo").hasClass("disabled")) {
            return;
          }
          $("#redo").click();
          return false;
        };
      })(this));
      return window.key('command+alt+s,ctrl+alt+s', (function (_this) {
        return function () {
          _this.save();
          return false;
        };
      })(this));
    };

    ToolbarController.prototype.getActiveToolSetting = function () {
      if (this.$scope.selectedTool == null) {
        return null;
      }
      return this.getToolFormatSettings(this.$scope.selectedTool);
    };

    ToolbarController.prototype.populateFormatTools = function () {
      var e, toolSetting;
      if (this.$scope.selectedAnnotation != null) {
        this.popultateToolData(this.$scope.selectedAnnotation);
        try {
          this.$scope.$apply();
        } catch (error) {
          e = error;
        }
        return;
      }
      toolSetting = this.getActiveToolSetting();
      if (toolSetting == null) {
        return;
      }
      return this.popultateToolData(toolSetting);
    };

    ToolbarController.prototype.popultateToolData = function (data) {
      if (data.borderSize != null) {
        this.selectBorderSize(data.borderSize);
      }
      if (data.backgroundColor != null) {
        this.selectBackgroundColor(data.backgroundColor);
      }
      if (data.borderColor != null) {
        this.selectBorderColor(data.borderColor);
      }
      if (data.fontName != null) {
        this.selectFontName(data.fontName);
      }
      if (data.fontSize != null) {
        this.selectFontSize(data.fontSize);
      }
      if (data.textColor != null) {
        return this.selectTextColor(data.textColor);
      }
    };

    ToolbarController.prototype.selectTool = function (name) {
      if (this.$scope.selectedTool !== name) {
        this.$scope.selectedTool = name;
        this.messageChannel.toolSelected(name);
        return this.populateFormatTools();
      }
    };

    ToolbarController.prototype.updateToolSetting = function (name, data) {
      var toolSetting;
      if (this.$scope.selectedTool == null) {
        return null;
      }
      toolSetting = this.formatAnnotationSettings[this.$scope.selectedTool];
      if (toolSetting == null) {
        return;
      }
      if (toolSetting[name] != null) {
        return toolSetting[name] = data;
      }
    };

    ToolbarController.prototype.selectBorderColor = function (borderColor) {
      if (this.$scope.selectedBorderColor !== borderColor) {
        this.$scope.selectedBorderColor = borderColor;
        return this.messageChannel.borderColorSelected(borderColor);
      }
    };

    ToolbarController.prototype.selectBackgroundColor = function (backgroundColor) {
      if (this.$scope.selectedBackgroundColor !== backgroundColor) {
        this.$scope.selectedBackgroundColor = backgroundColor;
        return this.messageChannel.backgroundColorSelected(backgroundColor);
      }
    };

    ToolbarController.prototype.selectTextColor = function (textColor) {
      if (this.$scope.selectedTextColor !== textColor) {
        this.$scope.selectedTextColor = textColor;
        return this.messageChannel.textColorSelected(textColor);
      }
    };

    ToolbarController.prototype.selectBorderSize = function (borderSize) {
      if (this.$scope.selectedBorderSize !== borderSize) {
        this.$scope.selectedBorderSize = borderSize;
        return this.messageChannel.borderSizeSelected(borderSize);
      }
    };

    ToolbarController.prototype.selectFontSize = function (fontSize) {
      if (this.$scope.selectedFontSize !== fontSize) {
        this.$scope.selectedFontSize = fontSize;
        return this.messageChannel.fontSizeSelected(fontSize);
      }
    };

    ToolbarController.prototype.selectFontName = function (fontName) {
      if (this.$scope.selectedFontName !== fontName) {
        this.$scope.selectedFontName = fontName;
        return this.messageChannel.fontNameSelected(fontName);
      }
    };

    ToolbarController.prototype.undo = function () {
      if (this.$scope.editor) {
        this.$scope.editor.undo();
        return this.selectTool('select');
      }
    };

    ToolbarController.prototype.redo = function () {
      if (this.$scope.editor) {
        this.$scope.editor.redo();
        return this.selectTool('select');
      }
    };

    ToolbarController.prototype.save = function () {
      return this.messageChannel.saveClicked();
    };

    ToolbarController.prototype.close = function () {
      return this.messageChannel.closeClicked();
    };

    ToolbarController.prototype.getDefaultFormatAnnotationSettings = function () {
      var backgroundColor, borderColor, borderSize, fontName, fontSize, formatAnnotationSettings, textColor;
      formatAnnotationSettings = {};
      fontSize = 18;
      fontName = 'Arial';
      textColor = '#ff0000';
      borderSize = 4;
      borderColor = '#ff0000';
      backgroundColor = '';
      formatAnnotationSettings['select'] = {};
      formatAnnotationSettings['blackout'] = {};
      formatAnnotationSettings['crop'] = {};
      formatAnnotationSettings['arrow'] = {
        borderSize: borderSize,
        borderColor: borderColor
      };
      formatAnnotationSettings['pencil'] = {
        borderSize: borderSize,
        borderColor: borderColor
      };
      formatAnnotationSettings['rectangle'] = {
        borderSize: borderSize,
        borderColor: borderColor,
        backgroundColor: backgroundColor
      };
      formatAnnotationSettings['ellipse'] = {
        borderSize: borderSize,
        borderColor: borderColor,
        backgroundColor: backgroundColor
      };
      formatAnnotationSettings['callout'] = {
        borderSize: borderSize,
        borderColor: borderColor,
        backgroundColor: backgroundColor,
        fontName: fontName,
        fontSize: fontSize,
        textColor: textColor
      };
      formatAnnotationSettings['squareCallout'] = {
        borderSize: borderSize,
        borderColor: borderColor,
        backgroundColor: backgroundColor,
        fontName: fontName,
        fontSize: fontSize,
        textColor: textColor
      };
      formatAnnotationSettings['ovalCallout'] = {
        borderSize: borderSize,
        borderColor: borderColor,
        backgroundColor: backgroundColor,
        fontName: fontName,
        fontSize: fontSize,
        textColor: textColor
      };
      formatAnnotationSettings['cloudCallout'] = {
        borderSize: borderSize,
        borderColor: borderColor,
        backgroundColor: backgroundColor,
        fontName: fontName,
        fontSize: fontSize,
        textColor: textColor
      };
      formatAnnotationSettings['line1Callout'] = {
        borderSize: borderSize,
        borderColor: borderColor,
        backgroundColor: backgroundColor,
        fontName: fontName,
        fontSize: fontSize,
        textColor: textColor
      };
      formatAnnotationSettings['line2Callout'] = {
        borderSize: borderSize,
        borderColor: borderColor,
        backgroundColor: backgroundColor,
        fontName: fontName,
        fontSize: fontSize,
        textColor: textColor
      };
      formatAnnotationSettings['line3Callout'] = {
        borderSize: borderSize,
        borderColor: borderColor,
        backgroundColor: backgroundColor,
        fontName: fontName,
        fontSize: fontSize,
        textColor: textColor
      };
      formatAnnotationSettings['line1AccentBarCallout'] = {
        borderSize: borderSize,
        borderColor: borderColor,
        backgroundColor: backgroundColor,
        fontName: fontName,
        fontSize: fontSize,
        textColor: textColor
      };
      formatAnnotationSettings['line2AccentBarCallout'] = {
        borderSize: borderSize,
        borderColor: borderColor,
        backgroundColor: backgroundColor,
        fontName: fontName,
        fontSize: fontSize,
        textColor: textColor
      };
      formatAnnotationSettings['line3AccentBarCallout'] = {
        borderSize: borderSize,
        borderColor: borderColor,
        backgroundColor: backgroundColor,
        fontName: fontName,
        fontSize: fontSize,
        textColor: textColor
      };
      formatAnnotationSettings['text'] = {
        fontName: fontName,
        fontSize: fontSize,
        textColor: textColor
      };
      return formatAnnotationSettings;
    };

    ToolbarController.prototype.getToolFormatSettings = function (name) {
      var setting;
      setting = this.formatAnnotationSettings[name];
      return setting;
    };

    return ToolbarController;

  })();

  qTestExplorer.controller('toolbarController', ToolbarController);

}).call(this);

(function () {
  var LeftPanelController,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; };

  LeftPanelController = (function () {
    LeftPanelController.$inject = ['$scope', 'leftPanelMessageChannel', 'undoRedoService', 'watchingService', 'dialogService'];

    function LeftPanelController($scope, messageChannel, undoRedoService, watchingService, dialogService) {
      this.$scope = $scope;
      this.messageChannel = messageChannel;
      this.undoRedoService = undoRedoService;
      this.watchingService = watchingService;
      this.dialogService = dialogService;
      this.close = bind(this.close, this);
      this.save = bind(this.save, this);
      this.deleteAnnotation = bind(this.deleteAnnotation, this);
      this.moveAnnotationDown = bind(this.moveAnnotationDown, this);
      this.moveAnnotationUp = bind(this.moveAnnotationUp, this);
      this.addNote = bind(this.addNote, this);
      this.addAction = bind(this.addAction, this);
      this.selectScreen = bind(this.selectScreen, this);
      this.onBeforUnload = bind(this.onBeforUnload, this);
      this.bindBeforUnload = bind(this.bindBeforUnload, this);
      this.onMessage = bind(this.onMessage, this);
      this.onDataChanged = bind(this.onDataChanged, this);
      this.$scope.screen = null;
      var self = this;
      var sendMessage = function () {
        console.log((new Date().toString()) + " editor ready!");
        return window.setTimeout(function () {
          self.messageChanel = new window.MessageChannel(self.onMessage);
          return self.messageChanel.sendMessage("editorReady");
        }, 200);
      };
      if (document.readyState === "complete") {
        sendMessage();
      } else {
        window.addEventListener("load", sendMessage);
      }
      this.dialogService.showSpinner();
      this.$scope.addAction = this.addAction;
      this.$scope.addNote = this.addNote;
      this.$scope.moveAnnotationUp = this.moveAnnotationUp;
      this.$scope.moveAnnotationDown = this.moveAnnotationDown;
      this.$scope.deleteAnnotation = this.deleteAnnotation;
      this.bindBeforUnload();
      this.$scope.$on('toolbar.closeClicked', (function (_this) {
        return function (event) {
          return _this.close();
        };
      })(this));
      this.$scope.$on('screen.dataChanged', (function (_this) {
        return function (event) {
          return _this.onDataChanged();
        };
      })(this));
    }

    LeftPanelController.prototype.onDataChanged = function () {
      $('#save-btn-group>button').removeClass("disabled");
      return this.$scope.screen.isDirty = true;
    };

    LeftPanelController.prototype.onMessage = function (message) {
      var blob, byteArray, screen;
      switch (message.name) {
        case "currentScreen":
          screen = new qTestExplorer.Screen(message.data.screen);
          screen.selectScreen = this.selectScreen;
          this.$scope.screen = screen;
          byteArray = new Uint8Array(screen.screenShotBinary);
          blob = new Blob([byteArray], {
            type: "image/jpeg"
          });
          screen.imageUrl = window.URL.createObjectURL(blob);
          this.$scope.noteTypes = message.data.noteTypes;
          this.$scope.qTestVersion = message.data.qTestVersion;
          this.selectScreen();
          this.$scope.$apply();
          this.watchingService.watchScreen(this.$scope);
          this.dialogService.hideSpinner();
          this.messageChannel.loadedqTestVersion(this.$scope.qTestVersion);
          return this.$scope.$on('toolbar.saveClicked', (function (_this) {
            return function (event) {
              return _this.save();
            };
          })(this));
        case "savedCurrentScreen":
          return this.$scope.screen.isDirty = false;
      }
    };

    LeftPanelController.prototype.bindBeforUnload = function () {
      return $(window).bind("beforeunload", this.onBeforUnload);
    };

    LeftPanelController.prototype.onBeforUnload = function (e) {
      if (this.$scope.screen.isDirty === true) {
        return "Data you have entered may not be saved.";
      }
      window.URL.revokeObjectURL(this.$scope.screen.imageUrl);
    };

    LeftPanelController.prototype.selectScreen = function () {
      this.messageChannel.screenSelected(this.$scope.screen);
      return this.undoRedoService.clear();
    };

    LeftPanelController.prototype.addAction = function (screen) {
      var action, centerPoint, index, redoAction, undoAction;
      if (screen != null) {
        centerPoint = screen.getCenterPoint();
        action = {
          id: qTestExplorer.GuidUtils.generateGuid(),
          desc: "New action",
          annotationType: "Action",
          zIndex: screen.annotations.length + 1,
          hotspotx: centerPoint.x,
          hotspoty: centerPoint.y
        };
        screen.annotations.push(action);
        screen.updateTraceStepNumbers();
        index = screen.annotations.indexOf(action);
        screen.update();
        this.messageChannel.actionAdded(action);
        undoAction = (function (_this) {
          return function (screen, index) {
            return function () {
              if (index > -1) {
                screen.annotations.splice(index, 1);
                screen.updateTraceStepNumbers();
                return screen.update();
              }
            };
          };
        })(this)(screen, index);
        redoAction = (function (_this) {
          return function (a, screen, index) {
            return function () {
              if (index > -1) {
                screen.annotations.splice(index, 0, a);
                screen.updateTraceStepNumbers();
                return screen.update();
              }
            };
          };
        })(this)(action, screen, index);
        return this.undoRedoService.get(this.$scope.screen).register(undoAction, redoAction);
      }
    };

    LeftPanelController.prototype.addNote = function (screen) {
      var index, note, noteType, noteTypes, redoAction, undoAction;
      if (screen != null) {
        noteTypes = this.$scope.noteTypes;
        noteType = noteTypes.length > 0 ? noteTypes[0] : null;
        if (noteType != null) {
          note = {
            id: qTestExplorer.GuidUtils.generateGuid(),
            annotationType: "Note",
            noteType: noteType,
            desc: "New note"
          };
          screen.annotations.push(note);
          index = screen.annotations.indexOf(note);
          undoAction = (function (_this) {
            return function (screen, index) {
              return function () {
                if (index > -1) {
                  return screen.annotations.splice(index, 1);
                }
              };
            };
          })(this)(screen, index);
          redoAction = (function (_this) {
            return function (a, screen, index) {
              return function () {
                if (index > -1) {
                  return screen.annotations.splice(index, 0, a);
                }
              };
            };
          })(this)(note, screen, index);
          return this.undoRedoService.get(this.$scope.screen).register(undoAction, redoAction);
        } else {
          return this.dialogService.showMessage("NoteTypes setting is empty");
        }
      }
    };

    LeftPanelController.prototype.moveAnnotationUp = function (screen, annotation) {
      var downAnnotation, downIndex, i, item, len, listIndex, listItems, redoAction, ref, undoAction, upIndex;
      listItems = [];
      ref = screen.annotations;
      for (i = 0, len = ref.length; i < len; i++) {
        item = ref[i];
        if (item.isListItem === true) {
          listItems.push(item);
        }
      }
      listIndex = listItems.indexOf(annotation);
      if (listIndex <= 0) {
        return;
      }
      upIndex = screen.annotations.indexOf(annotation);
      downIndex = screen.annotations.indexOf(listItems[listIndex - 1]);
      downAnnotation = screen.annotations[downIndex];
      screen.annotations[upIndex] = downAnnotation;
      screen.annotations[downIndex] = annotation;
      this.onDataChanged();
      if (annotation.annotationType === "Action") {
        screen.updateTraceStepNumbers();
        screen.update();
      }
      undoAction = (function (_this) {
        return function (screen, upIndex, downIndex) {
          return function () {
            var upAnnotation;
            upAnnotation = screen.annotations[upIndex];
            downAnnotation = screen.annotations[downIndex];
            screen.annotations[upIndex] = downAnnotation;
            screen.annotations[downIndex] = upAnnotation;
            screen.updateTraceStepNumbers();
            return screen.update();
          };
        };
      })(this)(screen, upIndex, downIndex);
      redoAction = (function (_this) {
        return function (screen, upIndex, downIndex) {
          return function () {
            var upAnnotation;
            upAnnotation = screen.annotations[upIndex];
            downAnnotation = screen.annotations[downIndex];
            screen.annotations[upIndex] = downAnnotation;
            screen.annotations[downIndex] = upAnnotation;
            screen.updateTraceStepNumbers();
            return screen.update();
          };
        };
      })(this)(screen, upIndex, downIndex);
      return this.undoRedoService.get(this.$scope.screen).register(undoAction, redoAction);
    };

    LeftPanelController.prototype.moveAnnotationDown = function (screen, annotation) {
      var downIndex, i, item, len, listIndex, listItems, redoAction, ref, undoAction, upAnnotation, upIndex;
      listItems = [];
      ref = screen.annotations;
      for (i = 0, len = ref.length; i < len; i++) {
        item = ref[i];
        if (item.isListItem === true) {
          listItems.push(item);
        }
      }
      listIndex = listItems.indexOf(annotation);
      if (listIndex >= listItems.length - 1) {
        return;
      }
      downIndex = screen.annotations.indexOf(annotation);
      upIndex = screen.annotations.indexOf(listItems[listIndex + 1]);
      upAnnotation = screen.annotations[upIndex];
      screen.annotations[upIndex] = annotation;
      screen.annotations[downIndex] = upAnnotation;
      screen.updateTraceStepNumbers();
      screen.update();
      this.onDataChanged();
      undoAction = (function (_this) {
        return function (screen, upIndex, downIndex) {
          return function () {
            var downAnnotation;
            upAnnotation = screen.annotations[upIndex];
            downAnnotation = screen.annotations[downIndex];
            screen.annotations[upIndex] = downAnnotation;
            screen.annotations[downIndex] = upAnnotation;
            screen.updateTraceStepNumbers();
            return screen.update();
          };
        };
      })(this)(screen, upIndex, downIndex);
      redoAction = (function (_this) {
        return function (screen, upIndex, downIndex) {
          return function () {
            var downAnnotation;
            upAnnotation = screen.annotations[upIndex];
            downAnnotation = screen.annotations[downIndex];
            screen.annotations[upIndex] = downAnnotation;
            screen.annotations[downIndex] = upAnnotation;
            screen.updateTraceStepNumbers();
            return screen.update();
          };
        };
      })(this)(screen, upIndex, downIndex);
      return this.undoRedoService.get(this.$scope.screen).register(undoAction, redoAction);
    };

    LeftPanelController.prototype.deleteAnnotation = function (screen, annotation) {
      var index, redoAction, undoAction;
      index = screen.annotations.indexOf(annotation);
      screen.annotations.splice(index, 1);
      if (annotation.annotationType === "Action") {
        screen.updateTraceStepNumbers();
        screen.update();
      }
      undoAction = (function (_this) {
        return function (a, screen, index) {
          return function () {
            if (index > -1) {
              screen.annotations.splice(index, 0, a);
            }
            if (a.annotationType === "Action") {
              screen.updateTraceStepNumbers();
              return screen.update();
            }
          };
        };
      })(this)(annotation, screen, index);
      redoAction = (function (_this) {
        return function (a, screen, index) {
          return function () {
            if (index > -1) {
              screen.annotations.splice(index, 1);
            }
            if (a.annotationType === "Action") {
              screen.updateTraceStepNumbers();
              return screen.update();
            }
          };
        };
      })(this)(annotation, screen, index);
      return this.undoRedoService.get(this.$scope.screen).register(undoAction, redoAction);
    };

    LeftPanelController.prototype.save = function () {
      var savedScreen;
      if (this.$scope.screen == null) {
        return;
      }
      savedScreen = this.$scope.screen.getSaveData();
      return this.messageChanel.sendMessage("saveCurrentScreen", savedScreen);
    };

    LeftPanelController.prototype.close = function () {
      this.messageChanel.sendMessage("cancelEditCurrentScreen");
      return $(window).unbind("beforeunload", this.onBeforUnload);
    };

    return LeftPanelController;

  })();

  qTestExplorer.controller('leftPanelController', LeftPanelController);

}).call(this);

(function () {
  var EditorController,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; };

  EditorController = (function () {
    EditorController.$inject = ['$scope', 'editorMessageChannel'];

    function EditorController($scope, editorMessageChannel) {
      this.$scope = $scope;
      this.editorMessageChannel = editorMessageChannel;
      this.zoomChanged = bind(this.zoomChanged, this);
      this.fitContent = bind(this.fitContent, this);
      this.calculateFitZoom = bind(this.calculateFitZoom, this);
      this.resetZoom = bind(this.resetZoom, this);
      this.contentFit = bind(this.contentFit, this);
      this.zoomFit = bind(this.zoomFit, this);
      this.zoomOut = bind(this.zoomOut, this);
      this.zoomIn = bind(this.zoomIn, this);
      this.$scope.name = 'Editor';
      this.$scope.zoomIn = this.zoomIn;
      this.$scope.zoomOut = this.zoomOut;
      this.$scope.zoomFit = this.zoomFit;
      this.$scope.zoom = 1.0;
      this.$scope.zoomMode = qTestExplorer.zoomMode.fit;
      this.$scope.$on('screen.screenSelected', (function (_this) {
        return function (event, screen) {
          _this.$scope.screen = screen;
          _this.calculateFitZoom();
          _this.$scope.screen.zoomChanged(_this.$scope.zoom);
          return _this.zoomChanged(_this.$scope.zoom);
        };
      })(this));
    }

    EditorController.prototype.zoomIn = function () {
      var zoomConfig;
      zoomConfig = qTestExplorer.zoomConfig;
      if (this.$scope.zoom > zoomConfig.maximumZoom) {
        return;
      }
      this.$scope.zoom += zoomConfig.zoomFactor;
      if (this.$scope.screen) {
        this.zoomChanged(this.$scope.zoom);
        return this.$scope.zoomMode = qTestExplorer.zoomMode.normal;
      }
    };

    EditorController.prototype.zoomOut = function () {
      var zoomConfig;
      zoomConfig = qTestExplorer.zoomConfig;
      if (this.$scope.zoom < zoomConfig.minimumZoom) {
        return;
      }
      this.$scope.zoom -= zoomConfig.zoomFactor;
      if (this.$scope.screen) {
        this.zoomChanged(this.$scope.zoom);
        return this.$scope.zoomMode = qTestExplorer.zoomMode.normal;
      }
    };

    EditorController.prototype.zoomFit = function () {
      var zoomMode;
      zoomMode = qTestExplorer.zoomMode;
      switch (this.$scope.zoomMode) {
        case zoomMode.normal:
          this.$scope.zoomMode = zoomMode.fit;
          return this.fitContent();
        case zoomMode.fit:
          this.$scope.zoomMode = zoomMode.full;
          return this.resetZoom();
        case zoomMode.full:
          this.$scope.zoomMode = zoomMode.fit;
          return this.fitContent();
      }
    };

    EditorController.prototype.contentFit = function () {
      var containerHeight, containerWidth, screen, sizeUtils;
      if (!this.$scope.screen) {
        return true;
      }
      sizeUtils = qTestExplorer.sizeUtils;
      containerWidth = sizeUtils.editorWidth();
      containerHeight = sizeUtils.editorHeight();
      screen = this.$scope.screen;
      if (containerWidth > screen.width && containerHeight > screen.height) {
        return true;
      }
      return false;
    };

    EditorController.prototype.resetZoom = function () {
      if (!this.$scope.screen) {
        return;
      }
      this.$scope.zoom = 1.0;
      if (this.$scope.screen) {
        return this.zoomChanged(this.$scope.zoom);
      }
    };

    EditorController.prototype.calculateFitZoom = function () {
      var containerHeight, containerWidth, screen, sizeUtils, zoomX, zoomY;
      if (this.contentFit()) {
        return this.$scope.zoom = 1.0;
      } else {
        sizeUtils = qTestExplorer.sizeUtils;
        containerWidth = sizeUtils.editorWidth();
        containerHeight = sizeUtils.editorHeight();
        screen = this.$scope.screen;
        zoomX = containerWidth / screen.width;
        zoomY = containerHeight / screen.height;
        return this.$scope.zoom = zoomX < zoomY ? zoomX : zoomY;
      }
    };

    EditorController.prototype.fitContent = function () {
      if (!this.$scope.screen) {
        return;
      }
      this.calculateFitZoom();
      return this.zoomChanged(this.$scope.zoom);
    };

    EditorController.prototype.zoomChanged = function (zoom) {
      return this.editorMessageChannel.zoomChanged(zoom);
    };

    return EditorController;

  })();

  qTestExplorer.zoomMode = {
    normal: "Normal",
    fit: "Fit",
    full: "Full"
  };

  qTestExplorer.zoomConfig = {
    zoomFactor: 0.1,
    minimumZoom: 0.3,
    maximumZoom: 3.0
  };

  qTestExplorer.controller('editorController', EditorController);

}).call(this);

(function () {
  var ModalConfirmController, ModalInstanceController, ModalMediaPlayBackController, SpinnerInstanceController;

  ModalInstanceController = (function () {
    ModalInstanceController.$inject = ['$scope', '$sce', '$modalInstance', 'data'];

    function ModalInstanceController($scope, $sce, $modalInstance, data) {
      $scope.title = data.title;
      $scope.message = $sce.trustAsHtml(data.message);
      $scope.ok = (function (_this) {
        return function () {
          return $modalInstance.close();
        };
      })(this);
    }

    return ModalInstanceController;

  })();

  ModalConfirmController = (function () {
    ModalConfirmController.$inject = ['$scope', '$sce', '$modalInstance', 'data'];

    function ModalConfirmController($scope, $sce, $modalInstance, data) {
      $scope.title = data.title;
      $scope.message = $sce.trustAsHtml(data.message);
      $scope.ok = (function (_this) {
        return function () {
          return $modalInstance.close(true);
        };
      })(this);
      $scope.cancel = (function (_this) {
        return function () {
          return $modalInstance.close(false);
        };
      })(this);
    }

    return ModalConfirmController;

  })();

  SpinnerInstanceController = (function () {
    SpinnerInstanceController.$inject = ['$scope', '$modalInstance'];

    function SpinnerInstanceController($scope, $modalInstance) { }

    return SpinnerInstanceController;

  })();

  ModalMediaPlayBackController = (function () {
    ModalMediaPlayBackController.$inject = ['$scope', '$modalInstance', 'data'];

    function ModalMediaPlayBackController($scope, $modalInstance, data) {
      $scope.title = data.title;
      $scope.annotation = data.annotation;
      $modalInstance.bindData = (function (_this) {
        return function () {
          window.setTimeout(function () {
            var a, jMedia, jsource;
            a = data.annotation;
            jsource = "<source src=\"" + a.blobUrl + "\" type=\"" + a.mimeType + "\"/>";
            jMedia = "";
            if (a.annotationType === "Audio") {
              jMedia = "<audio controls autoPlay=\"true\" style=\"width: 100%;\">" + jsource + "</audio>";
            } else if (a.annotationType === "Video") {
              jMedia = "<video controls autoPlay=\"true\" style=\"width: 100%;\">" + jsource + "</video>";
            }
            return $("#mediaContainer").html(jMedia);
          }, 100);
        };
      })(this);
      $scope.close = (function (_this) {
        return function () {
          return $modalInstance.close({
            result: false
          });
        };
      })(this);
    }

    return ModalMediaPlayBackController;

  })();

  qTestExplorer.controller('modalInstanceController', ModalInstanceController);

  qTestExplorer.controller('modalConfirmController', ModalConfirmController);

  qTestExplorer.controller('spinnerInstanceController', SpinnerInstanceController);

  qTestExplorer.controller('modalMediaPlayBackController', ModalMediaPlayBackController);

}).call(this);

(function () {
  var ColorPickerController;

  ColorPickerController = (function () {
    ColorPickerController.$inject = ['$scope', '$sce', '$modalInstance', 'data'];

    function ColorPickerController($scope, $sce, $modalInstance, data) {
      $scope.result = {
        r: 255,
        g: 255,
        b: 255,
        hex: 'FFFFFF'
      };
      $scope.$watch("result.hex", (function (_this) {
        return function (hex) {
          var pixelColor, rgb;
          rgb = qTestExplorer.colorUtils.hexToRgb(hex);
          $scope.result.r = rgb.r;
          $scope.result.g = rgb.g;
          $scope.result.b = rgb.b;
          pixelColor = "rgb(" + rgb.r + ", " + rgb.g + ", " + rgb.b + ")";
          $('.preview').css('backgroundColor', pixelColor);
        };
      })(this));
      $scope.ok = (function (_this) {
        return function () {
          if (qTestExplorer.colorUtils.isHexaColor($scope.result.hex) === true) {
            $modalInstance.close("#" + $scope.result.hex);
          }
          return $scop.isError = true;
        };
      })(this);
      $scope.close = (function (_this) {
        return function () {
          return $modalInstance.close(null);
        };
      })(this);
    }

    return ColorPickerController;

  })();

  qTestExplorer.controller('colorPickerController', ColorPickerController);

}).call(this);

(function () {
  var Entity;

  Entity = (function () {
    function Entity(data) {
      if (data != null) {
        angular.extend(this, data);
      }
    }

    return Entity;

  })();

  qTestExplorer.Entity = Entity;

}).call(this);

(function () {
  var Screen,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Screen = (function (superClass) {
    extend(Screen, superClass);

    function Screen(data) {
      this.getSaveData = bind(this.getSaveData, this);
      this.applyCrop = bind(this.applyCrop, this);
      this.applyNewImage = bind(this.applyNewImage, this);
      this.getCroppedImage = bind(this.getCroppedImage, this);
      this.update = bind(this.update, this);
      this.updateTraceStepNumbers = bind(this.updateTraceStepNumbers, this);
      this.createResolutionRect = bind(this.createResolutionRect, this);
      this.createBorderRect = bind(this.createBorderRect, this);
      this.removeChild = bind(this.removeChild, this);
      this.addChild = bind(this.addChild, this);
      this.createCalloutShape = bind(this.createCalloutShape, this);
      this.createAnnotationShape = bind(this.createAnnotationShape, this);
      this.setUpAnnotations = bind(this.setUpAnnotations, this);
      this.disableMouseEvent = bind(this.disableMouseEvent, this);
      this.enableMouseEvent = bind(this.enableMouseEvent, this);
      this.zoomChanged = bind(this.zoomChanged, this);
      this.setupStage = bind(this.setupStage, this);
      this.loadImage = bind(this.loadImage, this);
      var annotation, j, len, ref;
      this.isLoaded = false;
      this.isDirty = false;
      this.annotationUpdated = 0;
      Screen.__super__.constructor.call(this, data);
      ref = this.annotations;
      for (j = 0, len = ref.length; j < len; j++) {
        annotation = ref[j];
        if (annotation.id == null) {
          annotation.id = qTestExplorer.GuidUtils.generateGuid();
        }
      }
      this.zoom = 1.0;
    }

    Screen.prototype.loadImage = function (textBox, canvas, bindEvent) {
      var img;
      if (this.isLoaded) {
        return;
      }
      this.canvas = canvas;
      this.textBox = textBox;
      img = new Image;
      img.onload = (function (_this) {
        return function () {
          _this.canvas.width = _this.width * _this.zoom;
          _this.canvas.height = _this.height * _this.zoom;
          _this.setupStage(img, textBox, canvas);
          bindEvent(_this.stage);
          return _this.isLoaded = true;
        };
      })(this);
      return img.src = this.imageUrl;
    };

    Screen.prototype.setupStage = function (img, textBox, canvas) {
      var bitmap, oldUpdate, stage;
      this.backgroundImage = img;
      stage = new createjs.Stage(this.canvas);
      stage.scaleX = this.zoom;
      stage.scaleY = this.zoom;
      bitmap = new createjs.Bitmap(img);
      this.bitmap = bitmap;
      this.scaleX = this.width / img.width;
      this.scaleY = this.height / img.height;
      bitmap.scaleX = this.scaleX;
      bitmap.scaleY = this.scaleY;
      stage.addChild(bitmap);
      this.setUpAnnotations(stage, this.annotations);
      this.backgroundRects = null;
      oldUpdate = _.bind(stage.update, stage);
      stage.update = (function (_this) {
        return function () {
          var childrenCount, rect;
          if (_this.backgroundRects != null) {
            _this.backgroundRects.removeAllChildren();
          } else {
            _this.backgroundRects = new createjs.Container();
            childrenCount = stage.children.length;
            if (childrenCount > 0 && stage.children[childrenCount - 1] instanceof qTestExplorer.Crop) {
              stage.addChildAt(_this.backgroundRects, childrenCount - 2);
            } else {
              stage.addChild(_this.backgroundRects);
            }
          }
          if ((_this.cropRectangle != null) && _this.cropRectangle.width > 0 && _this.cropRectangle.height > 0) {
            rect = _this.cropRectangle;
            _this.backgroundRects.addChild(_this.createBorderRect(0, 0, _this.width, rect.y));
            _this.backgroundRects.addChild(_this.createBorderRect(0, rect.y, rect.x, _this.height - rect.y));
            _this.backgroundRects.addChild(_this.createBorderRect(rect.x + rect.width, rect.y, _this.width - (rect.x + rect.width), _this.height - rect.y));
            _this.backgroundRects.addChild(_this.createBorderRect(rect.x, rect.y + rect.height, rect.width, _this.height - (rect.y + rect.height)));
            _this.backgroundRects.addChild(_this.createResolutionRect(rect));
          }
          return oldUpdate();
        };
      })(this);
      qTestExplorer.sizeUtils.centerCanvas(this.canvas.height);
      stage.update();
      this.stage = stage;
      return this.enableMouseEvent();
    };

    Screen.prototype.zoomChanged = function (zoom) {
      var child, j, len, ref;
      if (this.stage) {
        this.canvas.width = this.width * zoom;
        this.canvas.height = this.height * zoom;
        qTestExplorer.sizeUtils.centerCanvas(this.canvas.height);
        this.stage.scaleX = zoom;
        this.stage.scaleY = zoom;
        ref = this.stage.children;
        for (j = 0, len = ref.length; j < len; j++) {
          child = ref[j];
          if (child instanceof qTestExplorer.Shape) {
            child.repaint();
          }
        }
        this.stage.update();
      }
      return this.zoom = zoom;
    };

    Screen.prototype.enableMouseEvent = function () {
      if (this.stage) {
        return this.stage.enableMouseOver(10);
      }
    };

    Screen.prototype.disableMouseEvent = function () {
      if (this.stage) {
        return this.stage.enableMouseOver(0);
      }
    };

    Screen.prototype.setUpAnnotations = function (stage, annotations) {
      var annotation, j, len, shape;
      for (j = 0, len = annotations.length; j < len; j++) {
        annotation = annotations[j];
        shape = this.createAnnotationShape(annotation);
        if (shape != null) {
          if (annotation.annotationType === 'Blackout') {
            stage.addChildAt(shape, 1);
          } else {
            stage.addChild(shape);
          }
          shape.repaint();
        }
      }
      return stage.update();
    };

    Screen.prototype.createAnnotationShape = function (annotation) {
      var type;
      if (!annotation) {
        throw new Error('Annotation is null');
      }
      type = annotation.annotationType;
      switch (type) {
        case 'Action':
          return new qTestExplorer.Action(annotation);
        case 'Rectangle':
          return new qTestExplorer.Rectangle(annotation);
        case 'Ellipse':
          return new qTestExplorer.Ellipse(annotation);
        case 'Arrow':
          return new qTestExplorer.Arrow(annotation);
        case 'Pencil':
          return new qTestExplorer.Pencil(annotation);
        case 'Callout':
          return this.createCalloutShape(annotation);
        case 'TextBox':
          return new qTestExplorer.ShapeText(annotation, this.textBox);
        case 'Blackout':
          return new qTestExplorer.Blackout(annotation, new createjs.Bitmap(this.backgroundImage));
      }
      return null;
    };

    Screen.prototype.createCalloutShape = function (callout) {
      switch (callout.type) {
        case 'round':
          return new qTestExplorer.RoundedRectangularCallout(callout, this.textBox);
        case 'square':
          return new qTestExplorer.RectangularCallout(callout, this.textBox);
        case 'oval':
          return new qTestExplorer.OvalCallout(callout, this.textBox);
        case 'cloud':
          return new qTestExplorer.CloudCallout(callout, this.textBox);
        case 'line1':
          return new qTestExplorer.Line1Callout(callout, this.textBox, false);
        case 'line2':
          return new qTestExplorer.Line2Callout(callout, this.textBox, false);
        case 'line3':
          return new qTestExplorer.Line3Callout(callout, this.textBox, false);
        case 'line1AccentBar':
          return new qTestExplorer.Line1Callout(callout, this.textBox, true);
        case 'line2AccentBar':
          return new qTestExplorer.Line2Callout(callout, this.textBox, true);
        case 'line3AccentBar':
          return new qTestExplorer.Line3Callout(callout, this.textBox, true);
      }
    };

    Screen.prototype.addChild = function (shape) {
      if (this.stage != null) {
        this.stage.addChild(shape);
        return this.stage.update();
      }
    };

    Screen.prototype.removeChild = function (shape) {
      var index;
      index = this.annotations.indexOf(shape.annotation);
      if (index > -1) {
        this.annotations.splice(index, 1);
      }
      if (this.stage != null) {
        this.stage.removeChild(shape);
        return this.stage.update();
      }
    };

    Screen.prototype.createBorderRect = function (x, y, w, h) {
      var rect;
      rect = new createjs.Shape();
      rect.graphics.beginFill(createjs.Graphics.getRGB(30, 30, 30, 0.5)).setStrokeStyle(0).drawRect(x, y, w, h);
      return rect;
    };

    Screen.prototype.createResolutionRect = function (r) {
      var background, h, message, resolutionRect, selectCrop, sx, sy, text, w, x, y;
      x = r.x;
      y = r.y - 25;
      resolutionRect = new createjs.Container();
      background = new createjs.Shape();
      selectCrop = this.selectCrop != null ? this.selectCrop : false;
      w = selectCrop ? 80 : 260;
      h = 20;
      sx = Math.round(r.width).toString();
      if (sx.indexOf(".") > 0) {
        sx = sx.substring(0, sx.indexOf("."));
      }
      sy = Math.round(r.height).toString();
      if (sy.indexOf(".") > 0) {
        sy = sy.substring(0, sy.indexOf("."));
      }
      message = selectCrop ? "" : " - Select crop tool to edit crop area.";
      text = new createjs.Text(sx + " x " + sy + message, 'normal 11px Arial', '#fff');
      if (y < 0) {
        x = r.x + 5;
        y = r.y + 5;
      }
      background.graphics.setStrokeStyle(1).beginStroke("#000000").beginFill("#000000").drawRoundRect(x, y, w, h, 10);
      background.alpha = 0.8;
      resolutionRect.addChild(background);
      text.x = x + w / 2 - text.getMeasuredWidth() / 2;
      text.y = y + h / 2 - text.getMeasuredHeight() / 2;
      resolutionRect.addChild(text);
      return resolutionRect;
    };

    Screen.prototype.updateTraceStepNumbers = function () {
      var annotation, j, len, orderNumber, ref, results;
      orderNumber = 1;
      if ((this.annotations != null) && this.annotations.length > 0) {
        ref = this.annotations;
        results = [];
        for (j = 0, len = ref.length; j < len; j++) {
          annotation = ref[j];
          if (annotation.annotationType === "Action") {
            annotation.orderNumber = orderNumber;
            results.push(orderNumber++);
          } else {
            results.push(void 0);
          }
        }
        return results;
      }
    };

    Screen.prototype.update = function () {
      if (this.stage != null) {
        this.stage.removeAllChildren();
        this.stage.addChild(this.bitmap);
        this.setUpAnnotations(this.stage, this.annotations);
        this.backgroundRects = null;
        this.enableMouseEvent();
        return this.stage.update();
      }
    };

    Screen.prototype.getCenterPoint = function () {
      var isCrop;
      isCrop = (this.cropRectangle != null) && this.cropRectangle.width > 0 && this.cropRectangle.height > 0;
      return {
        x: isCrop ? this.cropRectangle.x + this.cropRectangle.width / 2 : this.width / 2,
        y: isCrop ? this.cropRectangle.y + this.cropRectangle.height / 2 : this.height / 2
      };
    };

    Screen.prototype.getCroppedImage = function () {
      var bufferCtx, byteCharacters, byteNumbers, canvas, i, imageFormat, imgStr, j, rect, ref;
      rect = this.cropRectangle;
      if (rect == null) {
        rect = new createjs.Rectangle(0, 0, height, width);
      }
      imageFormat = 'image/jpeg';
      canvas = document.createElement('canvas');
      canvas.width = rect.width;
      canvas.height = rect.height;
      bufferCtx = canvas.getContext('2d');
      bufferCtx.drawImage(this.backgroundImage, rect.x / this.scaleX, rect.y / this.scaleY, rect.width / this.scaleX, rect.height / this.scaleY, 0, 0, rect.width, rect.height);
      imgStr = canvas.toDataURL(imageFormat, 1);
      byteCharacters = atob(imgStr.substring("data:image/jpeg;base64,".length));
      byteNumbers = new Array(byteCharacters.length);
      for (i = j = 0, ref = byteCharacters.length; 0 <= ref ? j <= ref : j >= ref; i = 0 <= ref ? ++j : --j) {
        byteNumbers[i] = byteCharacters.charCodeAt(i);
      }
      return byteNumbers;
    };

    Screen.prototype.applyNewImage = function () {
      return this.screenShotBinary = this.getCroppedImage();
    };

    Screen.prototype.applyCrop = function () {
      var annotation, isCrop, j, k, len, len1, point, points, rect, ref, ref1;
      isCrop = (this.cropRectangle != null) && this.cropRectangle.width > 0 && this.cropRectangle.height > 0;
      if (isCrop === false) {
        return;
      }
      this.applyNewImage();
      rect = this.cropRectangle;
      this.width = rect.width;
      this.height = rect.height;
      ref = this.annotations;
      for (j = 0, len = ref.length; j < len; j++) {
        annotation = ref[j];
        if ((annotation.hotspotx != null) && (annotation.hotspoty != null)) {
          annotation.hotspotx = annotation.hotspotx - rect.x;
          annotation.hotspoty = annotation.hotspoty - rect.y;
        }
        if ((annotation.left != null) && (annotation.top != null)) {
          annotation.left = annotation.left - rect.x;
          annotation.top = annotation.top - rect.y;
        }
        if ((annotation.startPoint != null) && (annotation.endPoint != null)) {
          annotation.startPoint.x = annotation.startPoint.x - rect.x;
          annotation.startPoint.y = annotation.startPoint.y - rect.y;
          annotation.endPoint.x = annotation.endPoint.x - rect.x;
          annotation.endPoint.y = annotation.endPoint.y - rect.y;
        }
        if (annotation.anchorPoint != null) {
          annotation.anchorPoint.x = annotation.anchorPoint.x - rect.x;
          annotation.anchorPoint.y = annotation.anchorPoint.y - rect.y;
        }
        if (annotation.points != null) {
          points = [];
          ref1 = annotation.points;
          for (k = 0, len1 = ref1.length; k < len1; k++) {
            point = ref1[k];
            points.push({
              x: point.x - rect.x,
              y: point.y - rect.y
            });
          }
          annotation.points = points;
        }
      }
      screen.isDirty = true;
      return this.cropRectangle = null;
    };

    Screen.prototype.mapModelToData = function (model, excludes) {
      var objData;
      if (excludes == null) {
        excludes = [];
      }
      objData = {};
      $.each(model, (function (_this) {
        return function (key, value) {
          var j, len, results, valItem;
          if (excludes.length === 0 || excludes.indexOf(key.toString()) < 0) {
            if (value instanceof Array) {
              objData[key] = [];
              results = [];
              for (j = 0, len = value.length; j < len; j++) {
                valItem = value[j];
                if ((valItem instanceof Object) || (valItem instanceof Array)) {
                  results.push(objData[key].push(_this.mapModelToData(valItem)));
                } else {
                  results.push(objData[key].push(valItem));
                }
              }
              return results;
            } else if (value instanceof Object) {
              return objData[key] = _this.mapModelToData(value);
            } else {
              return objData[key] = value;
            }
          }
        };
      })(this));
      return objData;
    };

    Screen.prototype.getSaveData = function () {
      var annotation, data, isCrop, j, len, ref;
      isCrop = (this.cropRectangle != null) && this.cropRectangle.width > 0 && this.cropRectangle.height > 0;
      this.applyCrop();
      data = {
        width: this.width,
        height: this.height,
        screenShotBinary: isCrop ? this.screenShotBinary : null,
        id: this.id,
        sendStatus: this.sendStatus,
        title: this.title,
        order: this.order,
        annotations: []
      };
      ref = this.annotations;
      for (j = 0, len = ref.length; j < len; j++) {
        annotation = ref[j];
        data.annotations.push(this.mapModelToData(annotation, ["$$hashKey", "isListItem"]));
      }
      return data;
    };

    return Screen;

  })(qTestExplorer.Entity);

  qTestExplorer.Screen = Screen;

}).call(this);

(function () {
  var EditorMessageChannel, LeftPanelMessageChannel, ToolbarMessageChannel,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; };

  ToolbarMessageChannel = (function () {
    ToolbarMessageChannel.$inject = ['$rootScope'];

    function ToolbarMessageChannel($rootScope) {
      this.$rootScope = $rootScope;
    }

    ToolbarMessageChannel.prototype.toolSelected = function (name) {
      return this.$rootScope.$broadcast('toolbar.toolSelected', name);
    };

    ToolbarMessageChannel.prototype.borderColorSelected = function (borderColor) {
      return this.$rootScope.$broadcast('toolbar.borderColorSelected', borderColor);
    };

    ToolbarMessageChannel.prototype.textColorSelected = function (textColor) {
      return this.$rootScope.$broadcast('toolbar.textColorSelected', textColor);
    };

    ToolbarMessageChannel.prototype.backgroundColorSelected = function (backgroundColor) {
      return this.$rootScope.$broadcast('toolbar.backgroundColorSelected', backgroundColor);
    };

    ToolbarMessageChannel.prototype.borderSizeSelected = function (borderSize) {
      return this.$rootScope.$broadcast('toolbar.borderSizeSelected', borderSize);
    };

    ToolbarMessageChannel.prototype.fontSizeSelected = function (fontSize) {
      return this.$rootScope.$broadcast('toolbar.fontSizeSelected', fontSize);
    };

    ToolbarMessageChannel.prototype.fontNameSelected = function (fontName) {
      return this.$rootScope.$broadcast('toolbar.fontNameSelected', fontName);
    };

    ToolbarMessageChannel.prototype.saveClicked = function () {
      return this.$rootScope.$broadcast('toolbar.saveClicked');
    };

    ToolbarMessageChannel.prototype.closeClicked = function () {
      return this.$rootScope.$broadcast('toolbar.closeClicked');
    };

    ToolbarMessageChannel.prototype.annotationSelected = function (annotation) {
      return this.$rootScope.$broadcast('toolbar.annotationSelected', annotation);
    };

    return ToolbarMessageChannel;

  })();

  LeftPanelMessageChannel = (function () {
    LeftPanelMessageChannel.$inject = ['$rootScope'];

    function LeftPanelMessageChannel($rootScope) {
      this.$rootScope = $rootScope;
    }

    LeftPanelMessageChannel.prototype.screenSelected = function (screen) {
      return this.$rootScope.$broadcast('screen.screenSelected', screen);
    };

    LeftPanelMessageChannel.prototype.actionAdded = function (action) {
      return this.$rootScope.$broadcast('screen.actionAdded', action);
    };

    LeftPanelMessageChannel.prototype.dataChanged = function () {
      return this.$rootScope.$broadcast('screen.dataChanged');
    };

    LeftPanelMessageChannel.prototype.loadedqTestVersion = function (version) {
      return this.$rootScope.$broadcast('screen.loadedqTestVersion', version);
    };

    return LeftPanelMessageChannel;

  })();

  EditorMessageChannel = (function () {
    EditorMessageChannel.$inject = ['$rootScope'];

    function EditorMessageChannel($rootScope) {
      this.$rootScope = $rootScope;
      this.zoomChanged = bind(this.zoomChanged, this);
    }

    EditorMessageChannel.prototype.created = function (editor) {
      return this.$rootScope.$broadcast('editor.created', editor);
    };

    EditorMessageChannel.prototype.zoomChanged = function (zoom) {
      return this.$rootScope.$broadcast('editor.zoomChanged', zoom);
    };

    return EditorMessageChannel;

  })();

  qTestExplorer.service('toolbarMessageChannel', ToolbarMessageChannel);

  qTestExplorer.service('leftPanelMessageChannel', LeftPanelMessageChannel);

  qTestExplorer.service('editorMessageChannel', EditorMessageChannel);

}).call(this);

(function () {
  var UndoRedo, UndoRedoService,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; };

  UndoRedo = (function () {
    function UndoRedo(rootScope) {
      this.rootScope = rootScope;
      this.redoCount = bind(this.redoCount, this);
      this.undoCount = bind(this.undoCount, this);
      this.clear = bind(this.clear, this);
      this.redo = bind(this.redo, this);
      this.undo = bind(this.undo, this);
      this.register = bind(this.register, this);
      this.undoStack = [];
      this.redoStack = [];
    }

    UndoRedo.prototype.register = function (undoAction, redoAction) {
      this.undoStack.push({
        u: undoAction,
        r: redoAction
      });
      this.redoStack = [];
      this.rootScope.$broadcast('undoRedo.changed', 'register', this.undoCount(), this.redoCount());
      return this;
    };

    UndoRedo.prototype.undo = function () {
      var actions;
      if (this.undoStack.length === 0) {
        throw new Error('Undo stack is empty');
      }
      actions = this.undoStack.pop();
      this.redoStack.push(actions);
      actions.u();
      this.rootScope.$broadcast('undoRedo.changed', 'undo', this.undoCount(), this.redoCount());
      return this;
    };

    UndoRedo.prototype.redo = function () {
      var actions;
      if (this.redoStack.length === 0) {
        throw new Error('Redo stack is empty');
      }
      actions = this.redoStack.pop();
      this.undoStack.push(actions);
      actions.r();
      this.rootScope.$broadcast('undoRedo.changed', 'redo', this.undoCount(), this.redoCount());
      return this;
    };

    UndoRedo.prototype.clear = function () {
      this.undoStack = [];
      this.redoStack = [];
      return this.rootScope.$broadcast('undoRedo.changed', 'clear', 0, 0);
    };

    UndoRedo.prototype.undoCount = function () {
      return this.undoStack.length;
    };

    UndoRedo.prototype.redoCount = function () {
      return this.redoStack.length;
    };

    return UndoRedo;

  })();

  qTestExplorer.UndoRedo = UndoRedo;

  UndoRedoService = (function () {
    UndoRedoService.$inject = ['$rootScope'];

    function UndoRedoService($rootScope) {
      this.$rootScope = $rootScope;
      this.clear = bind(this.clear, this);
      this.remove = bind(this.remove, this);
      this.get = bind(this.get, this);
      this.instances = [];
    }

    UndoRedoService.prototype.get = function (context) {
      var instance, j, len, ref, undoRedo;
      if (!context) {
        throw new Error('A valid context must be provided');
      }
      ref = this.instances;
      for (j = 0, len = ref.length; j < len; j++) {
        instance = ref[j];
        if (instance[0] === context) {
          return instance[1];
        }
      }
      undoRedo = new qTestExplorer.UndoRedo(this.$rootScope);
      this.instances.push([context, undoRedo]);
      return undoRedo;
    };

    UndoRedoService.prototype.remove = function (context) {
      var i, j, ref;
      if (!context) {
        throw new Error('A valid context must be provided');
      }
      for (i = j = 0, ref = this.instances.length - 1; 0 <= ref ? j <= ref : j >= ref; i = 0 <= ref ? ++j : --j) {
        if (this.instances[i][0] === context) {
          this.instances.splice(i, 1);
          return;
        }
      }
      throw new Error('No UndoRedo instance is associated with the provided context');
    };

    UndoRedoService.prototype.clear = function () {
      this.instances = [];
      return this.$rootScope.$broadcast('undoRedo.changed', 'clear', 0, 0);
    };

    return UndoRedoService;

  })();

  qTestExplorer.service('undoRedoService', UndoRedoService);

}).call(this);

(function () {
  var WatchingService,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; };

  WatchingService = (function () {
    WatchingService.$inject = ['observeOnScope', 'leftPanelMessageChannel'];

    function WatchingService(observeOnScope, leftPanelMessageChannel) {
      this.observeOnScope = observeOnScope;
      this.leftPanelMessageChannel = leftPanelMessageChannel;
      this.unbindAllWatching = bind(this.unbindAllWatching, this);
      this.watchScreen = bind(this.watchScreen, this);
      this.watchingList = [];
    }

    WatchingService.prototype.watchScreen = function (scope) {
      var expression, watching;
      expression = "screen.title, screen.annotations.length, screen.annotationUpdated";
      watching = this.observeOnScope(scope, "[" + expression + "]").throttle(100).subscribe((function (_this) {
        return function (change) {
          var dataChanged, i, j, length, ref;
          length = change.oldValue.length;
          dataChanged = false;
          for (i = j = 0, ref = length; 0 <= ref ? j <= ref : j >= ref; i = 0 <= ref ? ++j : --j) {
            if (change.oldValue[i] !== change.newValue[i]) {
              dataChanged = true;
              break;
            }
          }
          if (dataChanged === true) {
            scope.screen.isDirty = true;
            return _this.leftPanelMessageChannel.dataChanged();
          }
        };
      })(this));
      return this.watchingList.push(watching);
    };

    WatchingService.prototype.unbindAllWatching = function () {
      var j, len, ref, results, watching;
      ref = this.watchingList;
      results = [];
      for (j = 0, len = ref.length; j < len; j++) {
        watching = ref[j];
        results.push((function (_this) {
          return function (w) {
            return w.dispose();
          };
        })(this)(watching));
      }
      return results;
    };

    return WatchingService;

  })();

  qTestExplorer.service('watchingService', WatchingService);

}).call(this);

(function () {
  var DialogService,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; };

  DialogService = (function () {
    DialogService.$inject = ['$modal'];

    DialogService.spinning = false;

    DialogService.spinner = null;

    function DialogService($modal) {
      this.$modal = $modal;
      this.showColorPicker = bind(this.showColorPicker, this);
      this.showMediaPlayBack = bind(this.showMediaPlayBack, this);
      this.showConfirm = bind(this.showConfirm, this);
      this.showMessage = bind(this.showMessage, this);
      this.hideSpinner = bind(this.hideSpinner, this);
      this.showSpinner = bind(this.showSpinner, this);
    }

    DialogService.prototype.showSpinner = function () {
      if (this.spinning === true) {
        return;
      }
      this.spinning = true;
      return this.spinner = this.$modal.open({
        templateUrl: "spinnerContent.html",
        controller: 'spinnerInstanceController',
        windowClass: "spinner",
        backdrop: "static",
        keyboard: false
      });
    };

    DialogService.prototype.hideSpinner = function () {
      if (this.spinning && (this.spinner != null)) {
        this.spinner.close();
        return this.spinning = false;
      }
    };

    DialogService.prototype.showMessage = function (message) {
      var modalInstance;
      modalInstance = this.$modal.open({
        templateUrl: "modalContent.html",
        controller: 'modalInstanceController',
        size: 'sm',
        resolve: {
          data: (function (_this) {
            return function () {
              return {
                title: "qTest eXplorer",
                message: message
              };
            };
          })(this)
        }
      });
      return modalInstance;
    };

    DialogService.prototype.showConfirm = function (message, cb) {
      var modalInstance;
      modalInstance = this.$modal.open({
        templateUrl: "confirmContent.html",
        controller: 'modalConfirmController',
        size: 'sm',
        resolve: {
          data: (function (_this) {
            return function () {
              return {
                title: "qTest eXplorer",
                message: message
              };
            };
          })(this)
        }
      });
      modalInstance.result.then((function (_this) {
        return function (result) {
          return cb(result);
        };
      })(this));
      return modalInstance;
    };

    DialogService.prototype.showMediaPlayBack = function (annotation, cb) {
      var modalInstance;
      modalInstance = this.$modal.open({
        templateUrl: "mediaPlayBackContent.html",
        controller: "modalMediaPlayBackController",
        size: "md",
        resolve: {
          data: (function (_this) {
            return function () {
              var a, data;
              a = annotation;
              data = {
                annotation: a
              };
              if (a.annotationType === "Audio") {
                data.title = "Audio player";
              } else if (a.annotationType === "Video") {
                data.title = "Video player";
              }
              return data;
            };
          })(this)
        }
      });
      modalInstance.opened.then((function (_this) {
        return function () {
          return modalInstance.bindData();
        };
      })(this));
      return modalInstance.result.then((function (_this) {
        return function (result) {
          return cb(result);
        };
      })(this));
    };

    DialogService.prototype.showColorPicker = function (cb) {
      var modalInstance;
      modalInstance = this.$modal.open({
        templateUrl: "colorPickerContent.html",
        controller: "colorPickerController",
        size: "md",
        backdrop: "static",
        keyboard: false,
        resolve: {
          data: (function (_this) {
            return function () {
              var data;
              data = {};
              return data;
            };
          })(this)
        }
      });
      return modalInstance.result.then((function (_this) {
        return function (result) {
          return cb(result);
        };
      })(this));
    };

    return DialogService;

  })();

  qTestExplorer.service('dialogService', DialogService);

}).call(this);

(function () {
  var styleColor;

  styleColor = function () {
    var link;
    link = function (scope, element, attrs) {
      var styleName;
      styleName = attrs.styleName;
      return scope.$watch(attrs.styleColor, (function (_this) {
        return function (value) {
          switch (styleName) {
            case "border":
              return element.css("border", "2px Solid " + value);
            case "background":
              return element.css("background", "" + value);
            case "color":
              return element.css("color", "" + value);
          }
        };
      })(this));
    };
    return {
      link: link
    };
  };

  qTestExplorer.directive('styleColor', styleColor);

}).call(this);

(function () {
  var resizer;

  resizer = function (document) {
    var link;
    link = function (scope, element, attrs) {
      var listWidth, mousemove, mouseup, screenList;
      element.on('mousedown', (function (_this) {
        return function (event) {
          event.preventDefault();
          document.on('mousemove', mousemove);
          return document.on('mouseup', mouseup);
        };
      })(this));
      screenList = $("#ScreenList");
      listWidth = screenList.width();
      mousemove = (function (_this) {
        return function (event) {
          var x;
          if (attrs.resizer === 'vertical') {
            x = event.pageX;
            if (attrs.resizerMax && x > attrs.resizerMax) {
              x = parseInt(attrs.resizerMax);
            }
            if (attrs.resizerMin && x < attrs.resizerMin) {
              x = parseInt(attrs.resizerMin);
            }
            element.css({
              left: x + 'px'
            });
            $(attrs.resizerLeft).css({
              width: x + 'px'
            });
            return $(attrs.resizerRight).css({
              "margin-left": (x + parseInt(attrs.resizerWidth)) + 'px'
            });
          }
        };
      })(this);
      return mouseup = (function (_this) {
        return function () {
          document.unbind('mousemove', mousemove);
          return document.unbind('mouseup', mouseup);
        };
      })(this);
    };
    return {
      link: link
    };
  };

  qTestExplorer.directive('resizer', ["$document", resizer]);

}).call(this);

(function () {
  var editorCanvas;

  editorCanvas = function (toolbarMessageChannel, editorMessageChannel, undoRedoService) {
    var link;
    link = function (scope, element, attrs) {
      var editor, sizeUtils, tools;
      sizeUtils = qTestExplorer.sizeUtils;
      $(window).resize((function (_this) {
        return function () {
          return sizeUtils.centerCanvas(element.height());
        };
      })(this));
      editor = new qTestExplorer.Editor(element, attrs, toolbarMessageChannel, undoRedoService, scope);
      tools = [new qTestExplorer.SelectTool(editor), new qTestExplorer.RectangleTool(editor), new qTestExplorer.EllipseTool(editor), new qTestExplorer.ArrowTool(editor), new qTestExplorer.TextTool(editor), new qTestExplorer.CalloutTool(editor), new qTestExplorer.SquareCalloutTool(editor), new qTestExplorer.OvalCalloutTool(editor), new qTestExplorer.CloudCalloutTool(editor), new qTestExplorer.Line1CalloutTool(editor), new qTestExplorer.Line2CalloutTool(editor), new qTestExplorer.Line3CalloutTool(editor), new qTestExplorer.Line1AccentBarCalloutTool(editor), new qTestExplorer.Line2AccentBarCalloutTool(editor), new qTestExplorer.Line3AccentBarCalloutTool(editor), new qTestExplorer.PencilTool(editor), new qTestExplorer.BlackoutTool(editor), new qTestExplorer.CropTool(editor)];
      editor.tools = tools;
      editor.selectTool('select');
      editorMessageChannel.created(editor);
      scope.$on('screen.screenSelected', function (event, screen) {
        return editor.loadScreen(screen);
      });
      scope.$on('toolbar.toolSelected', function (event, name) {
        return editor.selectTool(name);
      });
      scope.$on('toolbar.borderColorSelected', function (event, borderColor) {
        return editor.selectBorderColor(borderColor);
      });
      scope.$on('toolbar.backgroundColorSelected', function (event, background) {
        return editor.selectBackgroundColor(background);
      });
      scope.$on('toolbar.textColorSelected', function (event, textColor) {
        return editor.selectTextColor(textColor);
      });
      scope.$on('toolbar.borderSizeSelected', function (event, borderSize) {
        return editor.selectBorderSize(borderSize);
      });
      scope.$on('toolbar.fontSizeSelected', function (event, fontSize) {
        return editor.selectFontSize(fontSize);
      });
      scope.$on('toolbar.fontNameSelected', function (event, fontName) {
        return editor.selectFontName(fontName);
      });
      return scope.$on('editor.zoomChanged', function (event, zoom) {
        return editor.zoomChanged(zoom);
      });
    };
    return {
      link: link
    };
  };

  qTestExplorer.directive('editorCanvas', ["toolbarMessageChannel", "editorMessageChannel", "undoRedoService", editorCanvas]);

}).call(this);

(function () {
  var annotationItem;

  annotationItem = function (undoRedoService, dialogService) {
    var link;
    link = function (scope, element, attrs) {
      var addAction, addAudio, addEditable, addNote, addVideo, annotationContent, buildNoteTypeList, desEditor, desSpan;
      annotationContent = element.find(".annotation-content");
      desSpan = annotationContent.find("span");
      desEditor = annotationContent.find("input");
      addEditable = function (annotation) {
        var cancelText, submitText;
        submitText = function () {
          var e, newVal, oldVal, redoAction, undoAction;
          newVal = desEditor.val();
          if (newVal !== annotation.desc) {
            oldVal = annotation.desc;
            annotation.desc = desEditor.val();
            scope.screen.annotationUpdated++;
            try {
              scope.$apply();
            } catch (error) {
              e = error;
            }
            undoAction = (function (_this) {
              return function (oldText, annotation, screen) {
                return function () {
                  var span;
                  span = $("#" + annotation.id + ">.annotation-content>.content").find("span");
                  annotation.desc = oldText;
                  span.html((annotation.desc != null) && annotation.desc !== "" ? annotation.desc : "Double click to edit");
                  return screen.annotationUpdated++;
                };
              };
            })(this)(oldVal, annotation, scope.screen);
            redoAction = (function (_this) {
              return function (newText, annotation, span, screen) {
                return function () {
                  span = $("#" + annotation.id + ">.annotation-content>.content").find("span");
                  annotation.desc = newText;
                  span.html((annotation.desc != null) && annotation.desc !== "" ? annotation.desc : "Double click to edit");
                  return screen.annotationUpdated++;
                };
              };
            })(this)(newVal, annotation, desSpan, scope.screen);
            undoRedoService.get(scope.screen).register(undoAction, redoAction);
          }
          desSpan.show();
          desSpan.html((annotation.desc != null) && annotation.desc !== "" ? annotation.desc : "Double click to edit");
          return desEditor.hide();
        };
        cancelText = (function (_this) {
          return function () {
            desSpan.show();
            return desEditor.hide();
          };
        })(this);
        desSpan.dblclick((function (_this) {
          return function () {
            desSpan.hide();
            desEditor.show();
            desEditor.val(annotation.desc);
            return desEditor.focus();
          };
        })(this));
        desEditor.blur((function (_this) {
          return function () {
            return submitText();
          };
        })(this));
        return desEditor.keydown((function (_this) {
          return function (e) {
            if (e.keyCode === 13) {
              e.preventDefault();
              return submitText();
            } else if (e.keyCode === 27) {
              e.preventDefault();
              return cancelText();
            }
          };
        })(this));
      };
      addAction = function (annotation) {
        element.addClass("action");
        element.find(".annotation-action").css("top", "7px");
        annotationContent.attr("id", annotation.id);
        desSpan.html(annotation.desc != null ? annotation.desc : "Double click to edit");
        annotationContent.prepend("<div class=\"action-circle\" style=\"float: left\"> <div class=\"action-number\"><span>" + annotation.orderNumber + "</span></div></div>");
        scope.$watch("annotation.orderNumber", (function (_this) {
          return function (number) {
            return annotationContent.find(".action-number>span").html(number);
          };
        })(this));
        return addEditable(annotation);
      };
      buildNoteTypeList = function () {
        var i, len, listString, noteType, noteTypes;
        listString = "<ul class=\"dropdown-menu note-type-option\">";
        noteTypes = scope.noteTypes;
        for (i = 0, len = noteTypes.length; i < len; i++) {
          noteType = noteTypes[i];
          listString += "<li><a style=\"color: " + noteType.color + ";\" href=\"#\" data-type-id=\"" + noteType.id + "\" data-type-name=\"" + noteType.name + "\" data-color=\"" + noteType.color + "\">" + noteType.name + "</a></li>";
        }
        listString += "</ul>";
        return listString;
      };
      addNote = function (annotation) {
        var context, listStr, noteType;
        element.addClass("note");
        element.find(".annotation-action").css("top", "3px");
        desSpan = annotationContent.find("span");
        desSpan.html((annotation.desc != null) && annotation.desc !== "" ? annotation.desc : "Double click to edit");
        noteType = annotation.noteType;
        listStr = buildNoteTypeList();
        context = $("<div class=\"note-menu\"> <div class=\"btn-group menu-button-group\"> <button title=\"" + noteType.name + "\" type=\"button\" class=\"btn btn-default dropdown-toggle\" data-toggle=\"dropdown\" style=\"height: 16px; margin-top: 5px;\"> <div style=\"background: " + noteType.color + "; height: 16px; width: 16px; float: left;border: 1px solid #cccccc;\"></div> <i class=\"caret\" style=\"position: absolute; left: 18px; top: 7px;\"></i> </button> " + listStr + " </div> </div>");
        context.find("a").click(function () {
          var color, id, name, newType, oldType, redoAction, undoAction;
          color = $(this).data("color");
          name = $(this).data("type-name");
          id = $(this).data("type-id");
          oldType = annotation.noteType;
          newType = {
            color: color,
            name: name,
            id: id
          };
          annotation.noteType = newType;
          context.find("button>div").css("background", color);
          context.find("button").attr("title", name);
          scope.screen.annotationUpdated++;
          undoAction = (function (_this) {
            return function (a, oldType, screen) {
              return function () {
                var c;
                a.noteType = oldType;
                screen.annotationUpdated++;
                c = $("#" + annotation.id + ">.annotation-content>.note-menu");
                c.find("button>div").css("background", oldType.color);
                return c.find("button").attr("title", oldType.name);
              };
            };
          })(this)(annotation, oldType, scope.screen);
          redoAction = (function (_this) {
            return function (a, newType, screen) {
              return function () {
                var c;
                a.noteType = newType;
                screen.annotationUpdated++;
                c = $("#" + annotation.id + ">.annotation-content>.note-menu");
                c.find("button>div").css("background", newType.color);
                return c.find("button").attr("title", newType.name);
              };
            };
          })(this)(annotation, newType, scope.screen);
          return undoRedoService.get(scope.screen).register(undoAction, redoAction);
        });
        annotationContent.prepend(context);
        return addEditable(annotation);
      };
      addAudio = function (annotation) {
        var audioIcon, viewMode;
        viewMode = attrs.mode;
        element.addClass("media-annotation");
        element.find(".annotation-action").css("top", "2px");
        desSpan.html(annotation.desc != null ? annotation.desc : "Double click to edit");
        audioIcon = $("<div class=\"media-icon\" style=\"float: left\"><i class=\"eicon eicon-audio-playback\"/><i class=\"eicon eicon-playback\"/></div>");
        annotationContent.prepend(audioIcon);
        audioIcon.click((function (_this) {
          return function () {
            return dialogService.showMediaPlayBack(annotation, function () { });
          };
        })(this));
        return addEditable(annotation);
      };
      addVideo = function (annotation) {
        var videoIcon, viewMode;
        viewMode = attrs.mode;
        element.addClass("media-annotation");
        element.find(".annotation-action").css("top", "2px");
        desSpan.html(annotation.desc != null ? annotation.desc : "Double click to edit");
        videoIcon = $("<div class=\"media-icon\" style=\"float: left\"><i class=\"eicon eicon-video-playback\"/><i class=\"eicon eicon-playback\"/></div>");
        annotationContent.prepend(videoIcon);
        videoIcon.click((function (_this) {
          return function () {
            return dialogService.showMediaPlayBack(annotation, function () { });
          };
        })(this));
        return addEditable(annotation);
      };
      return scope.$watch(attrs.annotationItem, (function (_this) {
        return function (annotation) {
          if (annotation != null) {
            annotation.isListItem = true;
            switch (annotation.annotationType) {
              case 'Action':
                return addAction(annotation);
              case 'Note':
                return addNote(annotation);
              case 'Audio':
                return addAudio(annotation);
              case 'Video':
                return addVideo(annotation);
              default:
                annotation.isListItem = false;
                return element.hide();
            }
          }
        };
      })(this));
    };
    return {
      link: link
    };
  };

  qTestExplorer.directive('annotationItem', ['undoRedoService', 'dialogService', annotationItem]);

}).call(this);

(function () {
  var collapseButton;

  collapseButton = function (document) {
    var link;
    link = function (scope, element, attrs) {
      var collapse, expand, isCollapsed;
      element.css("right", 5);
      element.css("top", 5);
      element.css("background", "white");
      isCollapsed = false;
      element.find("a").click((function (_this) {
        return function (event) {
          event.preventDefault();
          if (isCollapsed) {
            return expand();
          } else {
            return collapse();
          }
        };
      })(this));
      collapse = (function (_this) {
        return function () {
          $(attrs.targetPanel).animate({
            width: "toggle"
          }, {
              complete: function () {
                element.css("right", "");
                element.css("top", 66);
                element.css("left", 10);
                element.css("border", "1px solid gray;");
                element.css("background", "");
                element.removeClass("eicon-left");
                element.find("i").addClass("eicon-right");
                return document.find("body").append(element);
              }
            });
          $(attrs.rightPanel).animate({
            "margin-left": 0
          });
          $(attrs.resizerBar).hide();
          return isCollapsed = true;
        };
      })(this);
      return expand = (function (_this) {
        return function () {
          $(attrs.targetPanel).animate({
            width: "toggle"
          }, {
              complete: function () {
                $(attrs.resizerBar).show();
                return $(attrs.rightPanel).css({
                  "margin-left": $(attrs.targetPanel).width()
                });
              }
            });
          isCollapsed = false;
          $(attrs.targetPanel).append(element);
          element.css("right", 5);
          element.css("left", "");
          element.css("top", 5);
          element.css("background", "white");
          element.find("i").removeClass("eicon-right");
          return element.find("i").addClass("eicon-left");
        };
      })(this);
    };
    return {
      link: link
    };
  };

  qTestExplorer.directive('collapseButton', ["$document", collapseButton]);

}).call(this);

(function () {
  var toolbarActive;

  toolbarActive = function (undoRedoService) {
    var active, link;
    active = "select";
    link = function (scope, element, attrs) {
      var adjustMenu, setEditMode, setUndoRedo, setViewMode;
      adjustMenu = (function (_this) {
        return function () {
          var headerHeight;
          headerHeight = element.height();
          if (headerHeight <= 0) {
            return;
          }
          if (headerHeight > 51) {
            $("#main").css("top", headerHeight + 8);
            $("#" + attrs.container).css("min-height", headerHeight + 8);
            element.css("margin-top", -40);
            return element.find("button").css("margin-top", 3);
          } else {
            $("#main").css("top", "");
            $("#" + attrs.container).css("min-height", "");
            element.css("margin-top", "");
            return element.find("button").css("margin-top", "");
          }
        };
      })(this);
      setUndoRedo = function (undoCount, redoCount) {
        if (undoCount > 0) {
          element.find("[id='undo']").removeClass('disabled');
        } else {
          element.find("[id='undo']").addClass('disabled');
        }
        if (redoCount > 0) {
          return element.find("[id='redo']").removeClass('disabled');
        } else {
          return element.find("[id='redo']").addClass('disabled');
        }
      };
      setViewMode = function () {
        element.find("[id='save-btn-group'] button").addClass('disabled');
        element.find("[id='annotation-btn-group'] button").addClass('disabled');
        element.find("[id='undoredo-btn-group'] button").addClass('disabled');
        return element.find("[id='format-btn-group'] button").addClass('disabled');
      };
      setEditMode = function () {
        element.find("[id='annotation-btn-group'] button").removeClass('disabled');
        element.find("[id='undoredo-btn-group'] button").removeClass('disabled');
        return element.find("[id='format-btn-group'] button").removeClass('disabled');
      };
      $(window).resize((function (_this) {
        return function () {
          return adjustMenu();
        };
      })(this));
      $.ready(function () {
        return adjustMenu();
      });
      setViewMode();
      scope.$on('toolbar.toolSelected', (function (_this) {
        return function (event, annotation) {
          if (annotation != null) {
            element.find("[type*='annotation']").removeClass('active');
            element.find("[id=" + active + "]").removeClass('active');
            element.find("[id=" + annotation + "]").addClass('active');
            return active = annotation;
          }
        };
      })(this));
      scope.$on('undoRedo.changed', (function (_this) {
        return function (event, action, undoCount, redoCount) {
          return setUndoRedo(undoCount, redoCount);
        };
      })(this));
      return scope.$on('screen.screenSelected', (function (_this) {
        return function (event, screen) {
          if (!screen) {
            return;
          }
          return setEditMode();
        };
      })(this));
    };
    return {
      link: link
    };
  };

  qTestExplorer.directive('toolbarActive', ['undoRedoService', toolbarActive]);

}).call(this);

(function () {
  var screenAttached;

  screenAttached = function (watchingService, undoRedoService) {
    var link;
    link = function (scope, element, attrs) {
      var descriptionToView, enableEdit, screen, titleEditor, titleSpan, viewToDescription;
      titleSpan = element.find(".title>span");
      titleEditor = element.find(".title>textarea");
      screen = {};
      scope.$watch(attrs.screenAttached, (function (_this) {
        return function (value) {
          var viewMode;
          if (value != null) {
            screen = value;
            viewMode = attrs.mode;
            titleSpan.html(screen.title != null ? descriptionToView(screen.title) : "Double click to edit");
            screen.annotationUpdated = 0;
            watchingService.watchScreen(scope);
            return enableEdit();
          }
        };
      })(this));
      enableEdit = (function (_this) {
        return function () {
          var cancelText, submitText;
          submitText = function () {
            var e, newVal, oldVal, redoAction, undoAction;
            newVal = titleEditor.val();
            if (newVal !== screen.title) {
              oldVal = screen.title;
              screen.title = titleEditor.val();
              try {
                scope.$apply();
              } catch (error) {
                e = error;
              }
              undoAction = (function (oldText, screen, span) {
                return function () {
                  screen.title = oldText;
                  return span.html(screen.title != null ? descriptionToView(screen.title) : "Double click to edit");
                };
              })(oldVal, screen, titleSpan);
              redoAction = (function (newText, screen, span) {
                return function () {
                  screen.title = newText;
                  return span.html(screen.title != null ? descriptionToView(screen.title) : "Double click to edit");
                };
              })(newVal, screen, titleSpan);
              undoRedoService.get(scope.screen).register(undoAction, redoAction);
            }
            titleSpan.show();
            titleSpan.html(screen.title != null ? descriptionToView(screen.title) : "Double click to edit");
            return titleEditor.hide();
          };
          cancelText = function () {
            titleSpan.show();
            return titleEditor.hide();
          };
          titleSpan.dblclick(function () {
            titleSpan.hide();
            titleEditor.show();
            titleEditor.val(viewToDescription(screen.title));
            return titleEditor.focus();
          });
          titleEditor.blur(function () {
            return submitText();
          });
          return titleEditor.keydown(function (e) {
            if (e.keyCode === 13) {
              e.preventDefault();
              return submitText();
            } else if (e.keyCode === 27) {
              e.preventDefault();
              return cancelText();
            }
          });
        };
      })(this);
      descriptionToView = function (des) {
        var temp;
        temp = des.replace(new RegExp('\n', 'g'), '<br>');
        return temp;
      };
      return viewToDescription = function (viewDes) {
        var temp;
        temp = viewDes.replace(new RegExp('<br>', 'g'), '\n');
        temp = temp.replace(/<(?:.|\n)*?>/gm, '');
        return temp;
      };
    };
    return {
      link: link
    };
  };

  qTestExplorer.directive('screenAttached', ["watchingService", "undoRedoService", screenAttached]);

}).call(this);

(function () {
  var pickerCanvas;

  pickerCanvas = function ($timeout) {
    var link;
    return link = function (scope, element, attrs) {
      var bCanPreview, canvas, ctx, image;
      bCanPreview = true;
      canvas = element[0];
      ctx = canvas.getContext('2d');
      image = new Image();
      image.onload = (function (_this) {
        return function () {
          return ctx.drawImage(image, 0, 0, image.width, image.height);
        };
      })(this);
      image.src = chrome.runtime.getURL("common/assets/img/colorwheel.png");
      element.mousemove((function (_this) {
        return function (e) {
          var canvasOffset, canvasX, canvasY, dColor, error, imageData, pixel;
          if (bCanPreview) {
            canvasOffset = $(canvas).offset();
            canvasX = Math.floor(e.pageX - canvasOffset.left);
            canvasY = Math.floor(e.pageY - canvasOffset.top);
            imageData = ctx.getImageData(canvasX, canvasY, 1, 1);
            pixel = imageData.data;
            dColor = pixel[2] + 256 * pixel[1] + 65536 * pixel[0];
            scope.result.hex = ('0000' + dColor.toString(16)).substr(-6);
            try {
              return scope.$apply();
            } catch (error1) {
              error = error1;
            }
          }
        };
      })(this));
      return element.click((function (_this) {
        return function (e) {
          return bCanPreview = !bCanPreview;
        };
      })(this));
    };
  };

  qTestExplorer.directive('pickerCanvas', ["$timeout", pickerCanvas]);

}).call(this);

(function () {
  var showHideTool;

  showHideTool = function () {
    var link;
    link = function (scope, element, attrs) {
      var hideTools;
      hideTools = (function (_this) {
        return function (tools) {
          var i, len, results, tool;
          results = [];
          for (i = 0, len = tools.length; i < len; i++) {
            tool = tools[i];
            results.push(element.find("#" + tool).hide());
          }
          return results;
        };
      })(this);
      return scope.$watch(attrs.showHideTool, (function (_this) {
        return function (version) {
          if (version == null) {
            return;
          }
          if (version.major < 7) {
            hideTools(["cloudCalloutTool", "line1CalloutTool", "line2CalloutTool", "line3CalloutTool", "line1AccentBarCalloutTool", "line2AccentBarCalloutTool", "line3AccentBarCalloutTool"]);
          }
          if (version.major === 7 && version.minor < 5) {
            return hideTools(["cloudCalloutTool", "line1CalloutTool", "line2CalloutTool", "line3CalloutTool", "line1AccentBarCalloutTool", "line2AccentBarCalloutTool", "line3AccentBarCalloutTool"]);
          }
        };
      })(this));
    };
    return {
      link: link
    };
  };

  qTestExplorer.directive('showHideTool', showHideTool);

}).call(this);

(function () {
  var Editor,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; };

  Editor = (function () {
    function Editor(element, attrs, messageChannel, undoRedoService, scope) {
      this.element = element;
      this.attrs = attrs;
      this.messageChannel = messageChannel;
      this.undoRedoService = undoRedoService;
      this.scope = scope;
      this.annotationSelected = bind(this.annotationSelected, this);
      this.redo = bind(this.redo, this);
      this.undo = bind(this.undo, this);
      this.cursor = bind(this.cursor, this);
      this.selectFontName = bind(this.selectFontName, this);
      this.selectFontSize = bind(this.selectFontSize, this);
      this.selectBorderSize = bind(this.selectBorderSize, this);
      this.selectTextColor = bind(this.selectTextColor, this);
      this.selectBackgroundColor = bind(this.selectBackgroundColor, this);
      this.selectBorderColor = bind(this.selectBorderColor, this);
      this.toolChanging = bind(this.toolChanging, this);
      this.screenChanging = bind(this.screenChanging, this);
      this.toolChanged = bind(this.toolChanged, this);
      this.screenChanged = bind(this.screenChanged, this);
      this.onSelectTool = bind(this.onSelectTool, this);
      this.repaint = bind(this.repaint, this);
      this.removeChild = bind(this.removeChild, this);
      this.addChild = bind(this.addChild, this);
      this.onKeyUp = bind(this.onKeyUp, this);
      this.onKeyDown = bind(this.onKeyDown, this);
      this.onPressUp = bind(this.onPressUp, this);
      this.onPressMove = bind(this.onPressMove, this);
      this.onMouseDown = bind(this.onMouseDown, this);
      this.onMouseMove = bind(this.onMouseMove, this);
      this.getActualRect = bind(this.getActualRect, this);
      this.getActualPoint = bind(this.getActualPoint, this);
      this.zoomChanged = bind(this.zoomChanged, this);
      this.loadScreen = bind(this.loadScreen, this);
      this.selectTool = bind(this.selectTool, this);
      this.canvas = this.element[0];
      this.drawingShape = null;
      this.currentScreen = null;
      this.textBox = $('<textarea style="position: absolute;"><textarea>').hide();
      $('#editor').append(this.textBox);
      $('#editor').keydown((function (_this) {
        return function (e) {
          return _this.onKeyDown(e);
        };
      })(this));
      $('#editor').keyup((function (_this) {
        return function (e) {
          return _this.onKeyUp(e);
        };
      })(this));
      this.canEdit = true;
    }

    Editor.prototype.selectTool = function (name) {
      var i, len, ref, ref1, selectedTool, tool;
      if (((ref = this.selectedTool) != null ? ref.name : void 0) === name) {
        return;
      }
      if (this.selectedTool != null) {
        this.toolChanging(this.selectedTool);
        this.selectedTool.isSelected = false;
      }
      selectedTool = null;
      ref1 = this.tools;
      for (i = 0, len = ref1.length; i < len; i++) {
        tool = ref1[i];
        if (tool.name === name) {
          selectedTool = tool;
          selectedTool.isSelected = true;
          break;
        }
      }
      this.selectedTool = selectedTool;
      if (name === "select") {
        this.cursor("default");
      } else {
        this.cursor("crosshair");
      }
      return this.toolChanged(this.selectedTool);
    };

    Editor.prototype.loadScreen = function (screen) {
      var bindEvent, load;
      bindEvent = (function (_this) {
        return function (stage) {
          stage.addEventListener("stagemousemove", _this.onMouseMove);
          stage.addEventListener('mousedown', _this.onMouseDown);
          stage.addEventListener('pressmove', _this.onPressMove);
          return stage.addEventListener('pressup', _this.onPressUp);
        };
      })(this);
      load = (function (_this) {
        return function (s) {
          _this.canvas.width = screen.width;
          _this.canvas.height = screen.height;
          if (s.stage == null) {
            return s.loadImage(_this.textBox, _this.canvas, bindEvent);
          }
        };
      })(this);
      if (screen != null) {
        this.currentScreen = screen;
        load(this.currentScreen);
      }
      return this.screenChanged(this.currentScreen);
    };

    Editor.prototype.zoomChanged = function (zoom) {
      var i, len, ref, results, tool;
      this.zoom = zoom;
      if (this.currentScreen != null) {
        this.currentScreen.zoomChanged(zoom);
      }
      if (this.tools != null) {
        ref = this.tools;
        results = [];
        for (i = 0, len = ref.length; i < len; i++) {
          tool = ref[i];
          results.push(tool.onZoomChanged(zoom));
        }
        return results;
      }
    };

    Editor.prototype.getActualPoint = function (point) {
      return {
        x: point.x / this.zoom,
        y: point.y / this.zoom
      };
    };

    Editor.prototype.getActualRect = function (rect) {
      return {
        x: rect.x / this.zoom,
        y: rect.y / this.zoom,
        w: rect.w / this.zoom,
        h: rect.h / this.zoom
      };
    };

    Editor.prototype.onMouseMove = function (e) {
      if ((this.selectedTool != null) && this.canEdit === true) {
        return this.selectedTool.onMouseMove(e);
      }
    };

    Editor.prototype.onMouseDown = function (e) {
      if ((this.selectedTool != null) && this.canEdit === true) {
        return this.selectedTool.onMouseDown(e);
      }
    };

    Editor.prototype.onPressMove = function (e) {
      if ((this.selectedTool != null) && this.canEdit === true) {
        return this.selectedTool.onPressMove(e);
      }
    };

    Editor.prototype.onPressUp = function (e) {
      var shape;
      if ((this.selectedTool != null) && this.canEdit === true) {
        this.selectedTool.onPressUp(e);
        shape = this.selectedTool.completedShape;
        if (this.selectedTool.name === 'text') {
          this.selectTool('select');
          this.onSelectTool('select');
        }
        if (shape) {
          this.selectedTool.select(shape);
        }
        return this.selectedTool.completedShape = null;
      }
    };

    Editor.prototype.onKeyDown = function (e) {
      if (e.target.nodeName === "INPUT" || e.target.nodeName === "TEXTAREA") {
        return;
      }
      if ((this.selectedTool != null) && this.canEdit === true) {
        return this.selectedTool.onKeyDown(e);
      }
    };

    Editor.prototype.onKeyUp = function (e) {
      if (e.target.nodeName === "INPUT" || e.target.nodeName === "TEXTAREA") {
        return;
      }
      if ((this.selectedTool != null) && this.canEdit === true) {
        return this.selectedTool.onKeyUp(e);
      }
    };

    Editor.prototype.addChild = function (shape) {
      if ((this.currentScreen != null) && this.canEdit === true) {
        return this.currentScreen.addChild(shape);
      }
    };

    Editor.prototype.removeChild = function (shape) {
      if ((this.currentScreen != null) && this.canEdit === true) {
        this.currentScreen.removeChild(shape);
        if (this.currentScreen != null) {
          return this.currentScreen.updateTraceStepNumbers();
        }
      }
    };

    Editor.prototype.repaint = function () {
      var ref;
      if ((ref = this.currentScreen) != null ? ref.stage : void 0) {
        return this.currentScreen.stage.update();
      }
    };

    Editor.prototype.onSelectTool = function (name) {
      this.messageChannel.toolSelected(name);
      return this.selectTool(name);
    };

    Editor.prototype.screenChanged = function (screen) {
      var i, len, ref, results, tool;
      if (this.tools == null) {
        return;
      }
      ref = this.tools;
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        tool = ref[i];
        results.push(tool.onScreenChanged(screen));
      }
      return results;
    };

    Editor.prototype.toolChanged = function (tool) {
      var i, len, ntool, ref, results;
      if (this.tools == null) {
        return;
      }
      ref = this.tools;
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        ntool = ref[i];
        results.push(ntool.onToolChanged(tool));
      }
      return results;
    };

    Editor.prototype.screenChanging = function (screen) {
      var i, len, ref, results, tool;
      if (this.tools == null) {
        return;
      }
      ref = this.tools;
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        tool = ref[i];
        results.push(tool.onScreenChanging(screen));
      }
      return results;
    };

    Editor.prototype.toolChanging = function (tool) {
      var i, len, ref, results;
      if (this.tools == null) {
        return;
      }
      ref = this.tools;
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        tool = ref[i];
        results.push(tool.onToolChanging(tool));
      }
      return results;
    };

    Editor.prototype.selectBorderColor = function (color) {
      var i, len, ntool, ref, results;
      if (this.tools == null) {
        return;
      }
      ref = this.tools;
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        ntool = ref[i];
        results.push(ntool.onStrokeColorChanged(color));
      }
      return results;
    };

    Editor.prototype.selectBackgroundColor = function (color) {
      var i, len, ntool, ref, results;
      if (this.tools == null) {
        return;
      }
      ref = this.tools;
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        ntool = ref[i];
        results.push(ntool.onBackgroundColorChanged(color));
      }
      return results;
    };

    Editor.prototype.selectTextColor = function (color) {
      var i, len, ntool, ref, results;
      if (this.tools == null) {
        return;
      }
      ref = this.tools;
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        ntool = ref[i];
        results.push(ntool.onTextColorChanged(color));
      }
      return results;
    };

    Editor.prototype.selectBorderSize = function (size) {
      var i, len, ref, results, tool;
      if (this.tools == null) {
        return;
      }
      ref = this.tools;
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        tool = ref[i];
        results.push(tool.onStrokeSizeChanged(size));
      }
      return results;
    };

    Editor.prototype.selectFontSize = function (size) {
      var i, len, ref, results, tool;
      if (this.tools == null) {
        return;
      }
      ref = this.tools;
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        tool = ref[i];
        results.push(tool.onFontSizeChanged(size));
      }
      return results;
    };

    Editor.prototype.selectFontName = function (name) {
      var i, len, ref, results, tool;
      if (this.tools == null) {
        return;
      }
      ref = this.tools;
      results = [];
      for (i = 0, len = ref.length; i < len; i++) {
        tool = ref[i];
        results.push(tool.onFontNameChanged(name));
      }
      return results;
    };

    Editor.prototype.cursor = function (cursor) {
      var ref;
      if (((ref = this.currentScreen) != null ? ref.stage : void 0)) {
        return this.currentScreen.stage.cursor = cursor;
      }
    };

    Editor.prototype.undo = function (undoAction, redoAction) {
      if (!this.currentScreen) {
        return;
      }
      if (!undoAction) {
        if (this.selectedTool instanceof qTestExplorer.SelectTool) {
          this.selectedTool.deselect();
        }
        return this.undoRedoService.get(this.currentScreen).undo();
      } else {
        return this.undoRedoService.get(this.currentScreen).register(undoAction, redoAction);
      }
    };

    Editor.prototype.redo = function () {
      if (!this.currentScreen) {
        return;
      }
      return this.undoRedoService.get(this.currentScreen).redo();
    };

    Editor.prototype.annotationSelected = function (annotation) {
      return this.messageChannel.annotationSelected(annotation);
    };

    return Editor;

  })();

  qTestExplorer.Editor = Editor;

}).call(this);

(function () {
  var DrawingHelper;

  DrawingHelper = (function () {
    function DrawingHelper() { }

    DrawingHelper.getAnchorArea = function (annotation) {
      var anchorX, anchorY, centerX, centerY, t, ta;
      anchorX = annotation.anchorPoint.x;
      anchorY = annotation.anchorPoint.y;
      centerX = annotation.left + annotation.width / 2;
      centerY = annotation.top + annotation.height / 2;
      t = annotation.height / annotation.width;
      ta = Math.abs(anchorY - centerY) / Math.abs(anchorX - centerX);
      if (anchorX < centerX && anchorY < centerY) {
        if (ta < t) {
          return 1;
        } else {
          return 2;
        }
      } else if (anchorX > centerX && anchorY < centerY) {
        if (ta > t) {
          return 3;
        } else {
          return 4;
        }
      } else if (anchorX > centerX && anchorY > centerY) {
        if (ta < t) {
          return 5;
        } else {
          return 6;
        }
      } else if (anchorX < centerX && anchorY > centerY) {
        if (ta > t) {
          return 7;
        } else {
          return 8;
        }
      }
    };

    DrawingHelper.drawInvertOval = function (graphics, fromAngle, toAngele, cx, cy, width, height) {
      var i, j, ref, ref1, results, xPos, yPos;
      results = [];
      for (i = j = ref = fromAngle, ref1 = toAngele; j <= ref1; i = j += 0.01) {
        xPos = cx - width * Math.cos(i);
        yPos = cy + height * Math.sin(i);
        results.push(graphics.lineTo(xPos, yPos));
      }
      return results;
    };

    DrawingHelper.drawOval = function (graphics, fromAngle, toAngele, cx, cy, width, height) {
      var i, j, ref, ref1, results, xPos, yPos;
      results = [];
      for (i = j = ref = fromAngle, ref1 = toAngele; j <= ref1; i = j += 0.01) {
        xPos = cx + width * Math.cos(i);
        yPos = cy + height * Math.sin(i);
        results.push(graphics.lineTo(xPos, yPos));
      }
      return results;
    };

    DrawingHelper.getAnchorAngleOfCallout = function (annotation) {
      var anchorX, anchorY, angle, cx, cy;
      cx = annotation.left + annotation.width / 2;
      cy = annotation.top + annotation.height / 2;
      anchorX = annotation.anchorPoint.x;
      anchorY = annotation.anchorPoint.y;
      angle = Math.atan((anchorY - cy) / (cx - anchorX));
      angle = anchorX > cx ? angle + Math.PI : angle;
      if (angle < 0) {
        return 2 * Math.PI + angle;
      } else {
        return angle;
      }
    };

    DrawingHelper.getInvertOvalPointFromAngle = function (angle, cx, cy, width, height) {
      var x, y;
      x = cx - width * Math.cos(angle);
      y = cy + height * Math.sin(angle);
      return {
        x: x,
        y: y
      };
    };

    DrawingHelper.getOvalPointFromAngle = function (angle, cx, cy, width, height) {
      var x, y;
      x = cx + width * Math.cos(angle);
      y = cy + height * Math.sin(angle);
      return {
        x: x,
        y: y
      };
    };

    DrawingHelper.lineLength = function (start, end) {
      var dx, dy;
      dx = end.x - start.x;
      dy = end.y - start.y;
      if (dx === 0 && dy === 0) {
        return 0;
      }
      return Math.sqrt(dx * dx + dy * dy);
    };

    DrawingHelper.distance = function (pt, start, end) {
      var dx, dy, t;
      dx = end.x - start.x;
      dy = end.y - start.y;
      if (dx === 0 && dy === 0) {
        dx = pt.x - start.x;
        dy = pt.y - start.y;
        Math.sqrt(dx * dx + dy * dy);
      }
      t = ((pt.x - start.x) * dx + (pt.y - start.y) * dy) / (dx * dx + dy * dy);
      if (t < 0) {
        dx = pt.x - start.x;
        dy = pt.y - start.y;
      } else if (t > 1) {
        dx = pt.x - end.x;
        dy = pt.y - end.y;
      } else {
        dx = pt.x - (start.x + t * dx);
        dy = pt.y - (start.y + t * dy);
      }
      return Math.sqrt(dx * dx + dy * dy);
    };

    return DrawingHelper;

  })();

  qTestExplorer.DrawingHelper = DrawingHelper;

}).call(this);

(function () {
  var CloudCalloutDrawingHelper;

  CloudCalloutDrawingHelper = (function () {
    var DrawingHelper;

    function CloudCalloutDrawingHelper() { }

    DrawingHelper = qTestExplorer.DrawingHelper;

    CloudCalloutDrawingHelper.drawCloudCallout = function (grapics, annotation) {
      var anchorX, anchorY, cx, cy, h, w, x, y;
      x = annotation.left;
      y = annotation.top;
      w = annotation.width;
      h = annotation.height;
      anchorX = annotation.anchorPoint.x;
      anchorY = annotation.anchorPoint.y;
      cx = x + w / 2;
      cy = y + h / 2;
      CloudCalloutDrawingHelper.draw1stEllipse(grapics, x, y, w, h, cx, cy);
      CloudCalloutDrawingHelper.draw2ndEllipse(grapics, x, y, w, h, cx, cy);
      CloudCalloutDrawingHelper.draw3rdEllipse(grapics, x, y, w, h, cx, cy);
      CloudCalloutDrawingHelper.draw4thEllipse(grapics, x, y, w, h, cx, cy);
      CloudCalloutDrawingHelper.draw5thEllipse(grapics, x, y, w, h, cx, cy);
      CloudCalloutDrawingHelper.draw6thEllipse(grapics, x, y, w, h, cx, cy);
      CloudCalloutDrawingHelper.draw7thEllipse(grapics, x, y, w, h, cx, cy);
      CloudCalloutDrawingHelper.draw8thEllipse(grapics, x, y, w, h, cx, cy);
      CloudCalloutDrawingHelper.draw9thEllipse(grapics, x, y, w, h, cx, cy);
      CloudCalloutDrawingHelper.draw10thEllipse(grapics, x, y, w, h, cx, cy);
      CloudCalloutDrawingHelper.draw11stEllipse(grapics, x, y, w, h, cx, cy);
      return CloudCalloutDrawingHelper.drawAnchor(grapics, annotation);
    };

    CloudCalloutDrawingHelper.getCloudCalloutTextableArea = function (rect) {
      var bottom, h, left, r, right, top, w, x, y;
      w = rect.w;
      h = rect.h;
      x = rect.x;
      y = rect.y;
      r = CloudCalloutDrawingHelper.getEllipseRect(x, y, w, h, 0.09, 0.08, 0.3, 0.4);
      left = DrawingHelper.getOvalPointFromAngle(0.85 * Math.PI, r.x + r.w / 2, r.y + r.h / 2, r.w / 2, r.h / 2).x;
      top = DrawingHelper.getOvalPointFromAngle(1.75 * Math.PI, r.x + r.w / 2, r.y + r.h / 2, r.w / 2, r.h / 2).y;
      r = CloudCalloutDrawingHelper.getEllipseRect(x, y, w, h, 0.51, 0.49, 0.35, 0.40);
      right = DrawingHelper.getOvalPointFromAngle(1.79 * Math.PI, r.x + r.w / 2, r.y + r.h / 2, r.w / 2, r.h / 2).x;
      r = CloudCalloutDrawingHelper.getEllipseRect(x, y, w, h, 0.02, 0.55, 0.2, 0.27);
      bottom = DrawingHelper.getOvalPointFromAngle(0.4 * Math.PI, r.x + r.w / 2, r.y + r.h / 2, r.w / 2, r.h / 2).y;
      return {
        x: left,
        y: top,
        w: right - left,
        h: bottom - top
      };
    };

    CloudCalloutDrawingHelper.drawAnchor = function (grapics, annotation) {
      var anchor, anchorArea, anchorLength, angle, cx, cy, h, h1, h2, isSpecialAngle, j, len, length, minSize, newAngle, ovalPoint, p1x, p1y, p2x, p2y, s0, s1, s2, sa, space, specialAngle, w, x, y;
      x = annotation.left;
      y = annotation.top;
      w = annotation.width;
      h = annotation.height;
      anchor = annotation.anchorPoint;
      cx = x + w / 2;
      cy = y + h / 2;
      minSize = Math.min(w, h) / 2;
      s2 = 0.18 * minSize;
      s1 = 0.12 * minSize;
      s0 = 0.06 * minSize;
      anchorArea = DrawingHelper.getAnchorArea(annotation);
      specialAngle = [0, 0.5 * Math.PI, 1 * Math.PI, 1.5 * Math.PI, 2 * Math.PI];
      angle = DrawingHelper.getAnchorAngleOfCallout(annotation);
      isSpecialAngle = false;
      for (j = 0, len = angle.length; j < len; j++) {
        sa = angle[j];
        if (sa === angle) {
          isSpecialAngle = true;
        }
      }
      if (!isSpecialAngle === true) {
        newAngle = CloudCalloutDrawingHelper.getAngleWithArea(anchorArea, {
          x: cx,
          y: cx
        }, anchor);
        if (newAngle !== 0) {
          angle = newAngle;
        }
      }
      ovalPoint = DrawingHelper.getInvertOvalPointFromAngle(angle, cx, cy, w / 2, h / 2);
      length = DrawingHelper.lineLength(anchor, ovalPoint);
      anchorLength = DrawingHelper.lineLength(anchor, {
        x: cx,
        y: cy
      });
      space = (length - s0 - (2 * s1) - (2 * s2)) / 3;
      h1 = s0 + space + s1;
      h2 = s0 + 2 * (s1 + space) + s2;
      p1x = cx - (anchorLength - h1) * Math.cos(angle);
      p1y = cy + (anchorLength - h1) * Math.sin(angle);
      p2x = cx - (anchorLength - h2) * Math.cos(angle);
      p2y = cy + (anchorLength - h2) * Math.sin(angle);
      grapics.moveTo(anchor.x + s0, anchor.y);
      DrawingHelper.drawOval(grapics, 0, 2 * Math.PI, anchor.x, anchor.y, s0, s0);
      grapics.moveTo(p2x + s2, p2y);
      DrawingHelper.drawOval(grapics, 0, 2 * Math.PI, p2x, p2y, s2, s2);
      grapics.moveTo(p1x + s1, p1y);
      return DrawingHelper.drawOval(grapics, 0, 2 * Math.PI, p1x, p1y, s1, s1);
    };

    CloudCalloutDrawingHelper.draw1stEllipse = function (grapics, x, y, w, h, cx, cy) {
      var p1, r;
      r = CloudCalloutDrawingHelper.getEllipseRect(x, y, w, h, 0, 0.36, 0.2, 0.27);
      p1 = DrawingHelper.getOvalPointFromAngle(0.68 * Math.PI, r.x + r.w / 2, r.y + r.h / 2, r.w / 2, r.h / 2);
      grapics.moveTo(p1.x, p1.y);
      return DrawingHelper.drawOval(grapics, 0.68 * Math.PI, 1.51 * Math.PI, r.x + r.w / 2, r.y + r.h / 2, r.w / 2, r.h / 2);
    };

    CloudCalloutDrawingHelper.draw2ndEllipse = function (grapics, x, y, w, h, cx, cy) {
      var r;
      r = CloudCalloutDrawingHelper.getEllipseRect(x, y, w, h, 0.09, 0.08, 0.3, 0.4);
      return DrawingHelper.drawOval(grapics, 0.85 * Math.PI, 1.75 * Math.PI, r.x + r.w / 2, r.y + r.h / 2, r.w / 2, r.h / 2);
    };

    CloudCalloutDrawingHelper.draw3rdEllipse = function (grapics, x, y, w, h, cx, cy) {
      var r;
      r = CloudCalloutDrawingHelper.getEllipseRect(x, y, w, h, 0.3, 0.02, 0.27, 0.45);
      return DrawingHelper.drawOval(grapics, 1.2 * Math.PI, 1.75 * Math.PI, r.x + r.w / 2, r.y + r.h / 2, r.w / 2, r.h / 2);
    };

    CloudCalloutDrawingHelper.draw4thEllipse = function (grapics, x, y, w, h, cx, cy) {
      var r;
      r = CloudCalloutDrawingHelper.getEllipseRect(x, y, w, h, 0.51, 0, 0.2, 0.27);
      return DrawingHelper.drawOval(grapics, 1.15 * Math.PI, 1.8 * Math.PI, r.x + r.w / 2, r.y + r.h / 2, r.w / 2, r.h / 2);
    };

    CloudCalloutDrawingHelper.draw5thEllipse = function (grapics, x, y, w, h, cx, cy) {
      var r;
      r = CloudCalloutDrawingHelper.getEllipseRect(x, y, w, h, 0.65, 0, 0.25, 0.40);
      return DrawingHelper.drawOval(grapics, 1.24 * Math.PI, 1.9 * Math.PI, r.x + r.w / 2, r.y + r.h / 2, r.w / 2, r.h / 2);
    };

    CloudCalloutDrawingHelper.draw6thEllipse = function (grapics, x, y, w, h, cx, cy) {
      var r;
      r = CloudCalloutDrawingHelper.getEllipseRect(x, y, w, h, 0.63, 0.09, 0.35, 0.40);
      DrawingHelper.drawOval(grapics, 1.65 * Math.PI, 2 * Math.PI, r.x + r.w / 2, r.y + r.h / 2, r.w / 2, r.h / 2);
      return DrawingHelper.drawOval(grapics, 0, 0.2 * Math.PI, r.x + r.w / 2, r.y + r.h / 2, r.w / 2, r.h / 2);
    };

    CloudCalloutDrawingHelper.draw7thEllipse = function (grapics, x, y, w, h, cx, cy) {
      var r;
      r = CloudCalloutDrawingHelper.getEllipseRect(x, y, w, h, 0.7, 0.29, 0.3, 0.4);
      DrawingHelper.drawOval(grapics, 1.79 * Math.PI, 2 * Math.PI, r.x + r.w / 2, r.y + r.h / 2, r.w / 2, r.h / 2);
      return DrawingHelper.drawOval(grapics, 0, 0.48 * Math.PI, r.x + r.w / 2, r.y + r.h / 2, r.w / 2, r.h / 2);
    };

    CloudCalloutDrawingHelper.draw8thEllipse = function (grapics, x, y, w, h, cx, cy) {
      var p1, r;
      r = CloudCalloutDrawingHelper.getEllipseRect(x, y, w, h, 0.51, 0.49, 0.35, 0.40);
      p1 = DrawingHelper.getOvalPointFromAngle(1.79 * Math.PI, r.x + r.w / 2, r.y + r.h / 2, r.w / 2, r.h / 2);
      grapics.moveTo(p1.x, p1.y);
      DrawingHelper.drawOval(grapics, 1.79 * Math.PI, 2 * Math.PI, r.x + r.w / 2, r.y + r.h / 2, r.w / 2, r.h / 2);
      return DrawingHelper.drawOval(grapics, 0, 0.57 * Math.PI, r.x + r.w / 2, r.y + r.h / 2, r.w / 2, r.h / 2);
    };

    CloudCalloutDrawingHelper.draw9thEllipse = function (grapics, x, y, w, h, cx, cy) {
      var r;
      r = CloudCalloutDrawingHelper.getEllipseRect(x, y, w, h, 0.36, 0.60, 0.30, 0.40);
      return DrawingHelper.drawOval(grapics, 0.1 * Math.PI, 0.89 * Math.PI, r.x + r.w / 2, r.y + r.h / 2, r.w / 2, r.h / 2);
    };

    CloudCalloutDrawingHelper.draw10thEllipse = function (grapics, x, y, w, h, cx, cy) {
      var r;
      r = CloudCalloutDrawingHelper.getEllipseRect(x, y, w, h, 0.12, 0.54, 0.35, 0.40);
      return DrawingHelper.drawOval(grapics, 0.33 * Math.PI, 0.87 * Math.PI, r.x + r.w / 2, r.y + r.h / 2, r.w / 2, r.h / 2);
    };

    CloudCalloutDrawingHelper.draw11stEllipse = function (grapics, x, y, w, h, cx, cy) {
      var r;
      r = CloudCalloutDrawingHelper.getEllipseRect(x, y, w, h, 0.02, 0.55, 0.2, 0.27);
      return DrawingHelper.drawOval(grapics, 0.4 * Math.PI, 1.2 * Math.PI, r.x + r.w / 2, r.y + r.h / 2, r.w / 2, r.h / 2);
    };

    CloudCalloutDrawingHelper.getEllipseRect = function (x, y, w, h, leftRatio, topRatio, withRatio, heightRatio) {
      var cph, cpw, cx, cy, sh, sw;
      sw = w * withRatio;
      sh = h * heightRatio;
      cpw = w * leftRatio;
      cph = h * topRatio;
      cx = x + cpw + sw / 2;
      cy = y + cph + sh / 2;
      return {
        x: cx - sw / 2,
        y: cy - sh / 2,
        w: sw,
        h: sh
      };
    };

    CloudCalloutDrawingHelper.getAngleWithArea = function (area, cp, anchor) {
      var d, fromAngle, i, j, l, point, ref, ref1, toAngle;
      fromAngle = 0.0;
      toAngle = 0.0;
      if (area > 4) {
        fromAngle = 0.25 * Math.PI * (area - 5);
      } else {
        fromAngle = 0.25 * Math.PI * (area + 3);
      }
      toAngle = fromAngle + 0.25 * Math.PI;
      l = DrawingHelper.lineLength(cp, anchor);
      for (i = j = ref = fromAngle, ref1 = toAngle; j <= ref1; i = j += 0.0001) {
        point = DrawingHelper.getOvalPointFromAngle(cp.x - l, cp.y - l, l, l);
        d = DrawingHelper.distance(point, anchor, cp);
        if (d < 1) {
          return i;
        }
      }
      return 0;
    };

    return CloudCalloutDrawingHelper;

  })();

  qTestExplorer.CloudCalloutDrawingHelper = CloudCalloutDrawingHelper;

}).call(this);

(function () {
  var HitResult, Shape,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  HitResult = (function () {
    function HitResult(status, cursor, handle1) {
      this.status = status;
      this.cursor = cursor;
      this.handle = handle1;
    }

    return HitResult;

  })();

  Shape = (function (superClass) {
    extend(Shape, superClass);

    Shape.HANDLE_SIZE = 6;

    Shape.HANDLE_STROKE_COLOR = '#000';

    Shape.HANDLE_FILL_COLOR = '#fff';

    function Shape(shape, annotation) {
      this.shape = shape;
      this.annotation = annotation;
      this.getHandleSize = bind(this.getHandleSize, this);
      this.setState = bind(this.setState, this);
      this.getState = bind(this.getState, this);
      this.move = bind(this.move, this);
      this.moveBy = bind(this.moveBy, this);
      this.getHandleAtPoint = bind(this.getHandleAtPoint, this);
      this.checkHit = bind(this.checkHit, this);
      this.deselect = bind(this.deselect, this);
      this.select = bind(this.select, this);
      this.setStrokeSize = bind(this.setStrokeSize, this);
      this.setBackgroundColor = bind(this.setBackgroundColor, this);
      this.setStrokeColor = bind(this.setStrokeColor, this);
      this.paintOutline = bind(this.paintOutline, this);
      this.endDraw = bind(this.endDraw, this);
      this.drawTo = bind(this.drawTo, this);
      this.startDraw = bind(this.startDraw, this);
      this.createShadow = bind(this.createShadow, this);
      this.getParentStage = bind(this.getParentStage, this);
      this.repaint = bind(this.repaint, this);
      this.isVisible = bind(this.isVisible, this);
      this.draw = bind(this.draw, this);
      Shape.__super__.constructor.call(this);
      this.selected = false;
      this.cursor = 'move';
    }

    Shape.prototype.draw = function (ctx, ignoreCache) {
      if (ignoreCache == null) {
        ignoreCache = false;
      }
      return this.shape.draw(ctx, ignoreCache);
    };

    Shape.prototype.isVisible = function () {
      return this.shape.isVisible();
    };

    Shape.prototype.repaint = function () {
      if (this.selected) {
        this.paintOutline();
        this.shadow = new createjs.Shadow('#FF1414', 0, 0, 10);
      } else {
        this.shadow = this.createShadow();
      }
      if (this.getStage()) {
        return this.getStage().update();
      }
    };

    Shape.prototype.getParentStage = function () {
      return this.getStage();
    };

    Shape.prototype.createShadow = function () {
      return new createjs.Shadow('#000', 3, 3, 10);
    };

    Shape.prototype.startDraw = function (x, y) { };

    Shape.prototype.drawTo = function (x, y) { };

    Shape.prototype.endDraw = function () { };

    Shape.prototype.paintOutline = function () { };

    Shape.prototype.setStrokeColor = function (color) {
      if ((this.annotation.borderColor != null) && this.annotation.borderColor !== color) {
        this.annotation.borderColor = color;
        return this.repaint();
      }
    };

    Shape.prototype.setBackgroundColor = function (color) {
      if ((this.annotation.backgroundColor != null) && this.annotation.backgroundColor !== color) {
        this.annotation.backgroundColor = color;
        return this.repaint();
      }
    };

    Shape.prototype.setStrokeSize = function (size) {
      if ((this.annotation.borderSize != null) && this.annotation.borderSize !== size) {
        this.annotation.borderSize = size;
        return this.repaint();
      }
    };

    Shape.prototype.select = function () {
      this.selected = true;
      this.outline = new createjs.Container();
      this.getStage().addChild(this.outline);
      return this.repaint();
    };

    Shape.prototype.deselect = function () {
      var stage;
      if (!this.selected) {
        return;
      }
      stage = this.getStage();
      if (stage == null) {
        return;
      }
      this.selected = false;
      this.getStage().removeChild(this.outline);
      this.outline = null;
      return this.repaint();
    };

    Shape.prototype.checkHit = function (x, y) {
      var handle;
      handle = this.getHandleAtPoint(x, y);
      if (handle) {
        return new HitResult(true, handle.cursor, handle);
      }
      return new HitResult(this.hitTest(x, y), 'move');
    };

    Shape.prototype.getHandleAtPoint = function (x, y) {
      var child, hit, i, j, num, ref;
      if (!this.selected) {
        return null;
      }
      num = this.outline.getNumChildren() - 1;
      if (num > 0) {
        for (i = j = ref = num; ref <= 0 ? j <= 0 : j >= 0; i = ref <= 0 ? ++j : --j) {
          child = this.outline.getChildAt(i);
          if (!child.name || child.name.indexOf('handle_') < 0) {
            continue;
          }
          hit = child.hitTest(x, y);
          if (hit) {
            return child;
          }
        }
      }
      return null;
    };

    Shape.prototype.moveBy = function (x, y, deltaX, deltaY, handle) {
      return null;
    };

    Shape.prototype.move = function (deltaX, deltaY) { };

    Shape.prototype.getState = function () {
      return {
        strokeColor: this.annotation.borderColor,
        strokeSize: this.annotation.borderSize
      };
    };

    Shape.prototype.setState = function (state) {
      this.annotation.borderColor = state.strokeColor;
      this.annotation.borderSize = state.strokeSize;
      return this.repaint();
    };

    Shape.prototype.getHandleSize = function () {
      var scaleX, stage;
      stage = this.getStage();
      scaleX = stage != null ? stage.scaleX : 1;
      return qTestExplorer.Shape.HANDLE_SIZE / scaleX;
    };

    Shape.prototype.getColor = function (hex) {
      return hex;
    };

    return Shape;

  })(createjs.Shape);

  qTestExplorer.HitResult = HitResult;

  qTestExplorer.Shape = Shape;

}).call(this);

(function () {
  var Action,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Action = (function (superClass) {
    extend(Action, superClass);

    function Action(annotation) {
      this.annotation = annotation;
      this.setState = bind(this.setState, this);
      this.getState = bind(this.getState, this);
      this.moveBy = bind(this.moveBy, this);
      this.repaint = bind(this.repaint, this);
      Action.__super__.constructor.call(this, new createjs.Container(), this.annotation);
      this.circle = new createjs.Shape();
      this.shape.addChild(this.circle);
      this.label = new createjs.Text('', 'normal ' + 14 + 'px Arial', "#ffffff");
      this.label.textAlign = "center";
      this.label.text = this.annotation.orderNumber;
      this.shape.addChild(this.label);
    }

    Action.prototype.repaint = function () {
      var fillColor, fontSize, hotspotx, hotspoty, size, stage;
      this.label.text = this.annotation.orderNumber;
      hotspotx = this.annotation.hotspotx;
      hotspoty = this.annotation.hotspoty;
      fillColor = this.selected ? "#1E90FF" : "#ff0000";
      stage = this.getStage();
      size = 15;
      if (stage != null) {
        size = 15 / stage.scaleX;
      }
      this.circle.graphics.clear().setStrokeStyle(2).beginStroke("#ffffff").beginFill(fillColor).drawCircle(hotspotx, hotspoty, size);
      this.label.x = hotspotx;
      this.label.y = hotspoty - size / 2;
      this.label.lineWidth = size * 2;
      if (stage != null) {
        fontSize = 14 / stage.scaleX;
      }
      this.label.font = "normal " + fontSize + "px Arial";
      return Action.__super__.repaint.call(this);
    };

    Action.prototype.moveBy = function (x, y, deltaX, deltaY, handle) {
      this.annotation.hotspotx += deltaX;
      this.annotation.hotspoty += deltaY;
      this.repaint();
      return null;
    };

    Action.prototype.getState = function () {
      var state;
      state = {
        hotspotx: this.annotation.hotspotx,
        hotspoty: this.annotation.hotspoty
      };
      return state;
    };

    Action.prototype.setState = function (state) {
      this.annotation.hotspotx = state.hotspotx;
      this.annotation.hotspoty = state.hotspoty;
      return this.repaint();
    };

    return Action;

  })(qTestExplorer.Shape);

  qTestExplorer.Action = Action;

}).call(this);

(function () {
  var BoundedShape,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  BoundedShape = (function (superClass) {
    extend(BoundedShape, superClass);

    function BoundedShape() {
      this.setState = bind(this.setState, this);
      this.getState = bind(this.getState, this);
      this.move = bind(this.move, this);
      this.moveBy = bind(this.moveBy, this);
      this.paintOutline = bind(this.paintOutline, this);
      this.setBound = bind(this.setBound, this);
      return BoundedShape.__super__.constructor.apply(this, arguments);
    }

    BoundedShape.prototype.setBound = function (x, y, w, h) {
      this.annotation.left = x;
      this.annotation.top = y;
      this.annotation.width = w;
      this.annotation.height = h;
      return this.repaint();
    };

    BoundedShape.prototype.startDraw = function (x, y) {
      this.startX = x;
      this.startY = y;
      return this.setBound(x, y, 0, 0);
    };

    BoundedShape.prototype.drawTo = function (x, y) {
      return this.setBound(Math.min(this.startX, x), Math.min(this.startY, y), Math.abs(this.startX - x), Math.abs(this.startY - y));
    };

    BoundedShape.prototype.paintOutline = function () {
      var bound, handlesPos;
      bound = {
        x: this.annotation.left,
        y: this.annotation.top,
        width: this.annotation.width,
        height: this.annotation.height
      };
      handlesPos = [];
      handlesPos[0] = {
        name: 'handle_0',
        cursor: 'nwse-resize',
        x: bound.x,
        y: bound.y
      };
      handlesPos[1] = {
        name: 'handle_1',
        cursor: 'ns-resize',
        x: bound.x + bound.width / 2,
        y: bound.y
      };
      handlesPos[2] = {
        name: 'handle_2',
        cursor: 'nesw-resize',
        x: bound.x + bound.width,
        y: bound.y
      };
      handlesPos[3] = {
        name: 'handle_3',
        cursor: 'ew-resize',
        x: bound.x,
        y: bound.y + bound.height / 2
      };
      handlesPos[4] = {
        name: 'handle_4',
        cursor: 'ew-resize',
        x: bound.x + bound.width,
        y: bound.y + bound.height / 2
      };
      handlesPos[5] = {
        name: 'handle_5',
        cursor: 'nesw-resize',
        x: bound.x,
        y: bound.y + bound.height
      };
      handlesPos[6] = {
        name: 'handle_6',
        cursor: 'ns-resize',
        x: bound.x + bound.width / 2,
        y: bound.y + bound.height
      };
      handlesPos[7] = {
        name: 'handle_7',
        cursor: 'nwse-resize',
        x: bound.x + bound.width,
        y: bound.y + bound.height
      };
      return handlesPos.forEach((function (_this) {
        return function (handlePos) {
          var handle, shape;
          handle = _this.outline[handlePos.name];
          if (!handle) {
            handle = _this.outline[handlePos.name] = new createjs.Shape();
            handle.name = handlePos.name;
            handle['cursor'] = handlePos.cursor;
            _this.outline.addChild(handle);
          }
          handle['center'] = {
            x: handlePos.x,
            y: handlePos.y
          };
          handle.cursor = handlePos.cursor;
          shape = qTestExplorer.Shape;
          return handle.graphics.clear().setStrokeStyle(1).beginStroke(shape.HANDLE_STROKE_COLOR).beginFill(shape.HANDLE_FILL_COLOR).drawCircle(handlePos.x, handlePos.y, _this.getHandleSize());
        };
      })(this));
    };

    BoundedShape.prototype.moveBy = function (x, y, deltaX, deltaY, handle) {
      var endX, endY, startX, startY;
      startX = this.annotation.left;
      startY = this.annotation.top;
      endX = startX + this.annotation.width;
      endY = startY + this.annotation.height;
      if (handle != null) {
        switch (handle.name) {
          case 'handle_0':
            startX += deltaX;
            startY += deltaY;
            if (startX >= endX && startY >= endY) {
              handle = this.outline['handle_7'];
            } else if (startX >= endX) {
              handle = this.outline['handle_2'];
            } else if (startY >= endY) {
              handle = this.outline['handle_5'];
            }
            break;
          case 'handle_1':
            startY += deltaY;
            if (startY >= endY) {
              handle = this.outline['handle_6'];
            }
            break;
          case 'handle_2':
            endX += deltaX;
            startY += deltaY;
            if (endX <= startX && startY >= endY) {
              handle = this.outline['handle_5'];
            } else if (endX <= startX) {
              handle = this.outline['handle_0'];
            } else if (startY >= endY) {
              handle = this.outline['handle_7'];
            }
            break;
          case 'handle_3':
            startX += deltaX;
            if (startX >= endX) {
              handle = this.outline['handle_4'];
            }
            break;
          case 'handle_4':
            endX += deltaX;
            if (endX <= startX) {
              handle = this.outline['handle_3'];
            }
            break;
          case 'handle_5':
            startX += deltaX;
            endY += deltaY;
            if (startX >= endX && endY <= startY) {
              handle = this.outline['handle_2'];
            } else if (startX >= endX) {
              handle = this.outline['handle_7'];
            } else if (endY <= startY) {
              handle = this.outline['handle_0'];
            }
            break;
          case 'handle_6':
            endY += deltaY;
            if (endY <= startY) {
              handle = this.outline['handle_1'];
            }
            break;
          case 'handle_7':
            endX += deltaX;
            endY += deltaY;
            if (endX <= startX && endY <= startY) {
              handle = this.outline['handle_0'];
            } else if (endX <= startX) {
              handle = this.outline['handle_5'];
            } else if (endY <= startY) {
              handle = this.outline['handle_2'];
            }
            break;
        }
      } else {
        startX = this.annotation.left + deltaX;
        startY = this.annotation.top + deltaY;
        endX = startX + this.annotation.width;
        endY = startY + this.annotation.height;
      }
      this.setBound(Math.min(startX, endX), Math.min(startY, endY), Math.abs(endX - startX), Math.abs(endY - startY));
      return handle;
    };

    BoundedShape.prototype.move = function (deltaX, deltaY) {
      this.annotation.left = this.annotation.left + deltaX;
      this.annotation.top = this.annotation.top + deltaY;
      return this.repaint();
    };

    BoundedShape.prototype.getState = function () {
      var state;
      state = BoundedShape.__super__.getState.call(this);
      state.backgroundColor = this.annotation.backgroundColor;
      state.bound = new createjs.Rectangle(this.annotation.left, this.annotation.top, this.annotation.width, this.annotation.height);
      return state;
    };

    BoundedShape.prototype.setState = function (state) {
      this.setBound(state.bound.x, state.bound.y, state.bound.width, state.bound.height);
      this.annotation.backgroundColor = state.backgroundColor;
      return BoundedShape.__super__.setState.call(this, state);
    };

    return BoundedShape;

  })(qTestExplorer.Shape);

  qTestExplorer.BoundedShape = BoundedShape;

}).call(this);

(function () {
  var Rectangle,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Rectangle = (function (superClass) {
    extend(Rectangle, superClass);

    function Rectangle(annotation) {
      this.repaint = bind(this.repaint, this);
      Rectangle.__super__.constructor.call(this, new createjs.Shape(), annotation);
    }

    Rectangle.prototype.repaint = function () {
      var backgroundColor, strokeColor, strokeSize;
      strokeSize = this.annotation.borderSize;
      strokeColor = this.getColor(this.annotation.borderColor);
      backgroundColor = this.getColor(this.annotation.backgroundColor);
      this.shape.graphics.clear().setStrokeStyle(strokeSize).beginStroke(strokeColor);
      if (backgroundColor !== "") {
        this.shape.graphics.beginFill(backgroundColor);
      }
      this.shape.graphics.drawRect(this.annotation.left, this.annotation.top, this.annotation.width, this.annotation.height);
      return Rectangle.__super__.repaint.call(this);
    };

    return Rectangle;

  })(qTestExplorer.BoundedShape);

  qTestExplorer.Rectangle = Rectangle;

}).call(this);

(function () {
  var Ellipse,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Ellipse = (function (superClass) {
    extend(Ellipse, superClass);

    function Ellipse(annotation) {
      this.repaint = bind(this.repaint, this);
      Ellipse.__super__.constructor.call(this, new createjs.Shape(), annotation);
    }

    Ellipse.prototype.repaint = function () {
      var backgroundColor, strokeColor, strokeSize;
      strokeSize = this.annotation.borderSize;
      strokeColor = this.getColor(this.annotation.borderColor);
      backgroundColor = this.getColor(this.annotation.backgroundColor);
      this.shape.graphics.clear().setStrokeStyle(strokeSize).beginStroke(strokeColor);
      if (backgroundColor !== "") {
        this.shape.graphics.beginFill(backgroundColor);
      }
      this.shape.graphics.drawEllipse(this.annotation.left, this.annotation.top, this.annotation.width, this.annotation.height);
      return Ellipse.__super__.repaint.call(this);
    };

    return Ellipse;

  })(qTestExplorer.BoundedShape);

  qTestExplorer.Ellipse = Ellipse;

}).call(this);

(function () {
  var Pencil,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Pencil = (function (superClass) {
    extend(Pencil, superClass);

    function Pencil(annotation) {
      this.setState = bind(this.setState, this);
      this.getState = bind(this.getState, this);
      this.move = bind(this.move, this);
      this.moveBy = bind(this.moveBy, this);
      this.repaint = bind(this.repaint, this);
      Pencil.__super__.constructor.call(this, new createjs.Shape(), annotation);
    }

    Pencil.prototype.repaint = function () {
      var graphics, points, strokeColor, strokeSize;
      strokeSize = this.annotation.borderSize;
      strokeColor = this.getColor(this.annotation.borderColor);
      points = this.annotation.points;
      graphics = this.shape.graphics;
      graphics.clear().setStrokeStyle(strokeSize).beginStroke(strokeColor);
      _.each(points, function (point) {
        return graphics.lineTo(point.x, point.y);
      });
      return Pencil.__super__.repaint.call(this);
    };

    Pencil.prototype.startDraw = function (x, y) {
      return this.annotation.points.push({
        x: x,
        y: y
      });
    };

    Pencil.prototype.drawTo = function (x, y) {
      this.annotation.points.push({
        x: x,
        y: y
      });
      return this.repaint();
    };

    Pencil.prototype.endDraw = function () {
      this.annotation.points = simplify(this.annotation.points, 0.1);
      return this.repaint();
    };

    Pencil.prototype.moveBy = function (x, y, deltaX, deltaY, handle) {
      this.move(deltaX, deltaY);
      this.repaint();
      return null;
    };

    Pencil.prototype.move = function (deltaX, deltaY) {
      return _.each(this.annotation.points, (function (_this) {
        return function (point) {
          point.x += deltaX;
          return point.y += deltaY;
        };
      })(this));
    };

    Pencil.prototype.getState = function () {
      var state;
      state = Pencil.__super__.getState.call(this);
      state.points = [];
      _.each(this.annotation.points, (function (_this) {
        return function (p) {
          return state.points.push({
            x: p.x,
            y: p.y
          });
        };
      })(this));
      return state;
    };

    Pencil.prototype.setState = function (state) {
      this.annotation.points = [];
      _.each(state.points, (function (_this) {
        return function (p) {
          return _this.annotation.points.push({
            x: p.x,
            y: p.y
          });
        };
      })(this));
      return Pencil.__super__.setState.call(this, state);
    };

    return Pencil;

  })(qTestExplorer.Shape);

  qTestExplorer.Pencil = Pencil;

}).call(this);

(function () {
  var Arrow,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Arrow = (function (superClass) {
    extend(Arrow, superClass);

    function Arrow(annotation) {
      this.setState = bind(this.setState, this);
      this.getState = bind(this.getState, this);
      this.move = bind(this.move, this);
      this.moveBy = bind(this.moveBy, this);
      this.paintOutline = bind(this.paintOutline, this);
      this.repaint = bind(this.repaint, this);
      Arrow.__super__.constructor.call(this, new createjs.Shape(), annotation);
    }

    Arrow.prototype.startDraw = function (x, y) {
      this.annotation.startPoint.x = x;
      return this.annotation.startPoint.y = y;
    };

    Arrow.prototype.drawTo = function (x, y) {
      this.annotation.endPoint.x = x;
      this.annotation.endPoint.y = y;
      return this.repaint();
    };

    Arrow.prototype.repaint = function () {
      var angle, strokeColor, strokeSize, x1, x2, y1, y2;
      x1 = this.annotation.startPoint.x;
      x2 = this.annotation.endPoint.x;
      y1 = this.annotation.startPoint.y;
      y2 = this.annotation.endPoint.y;
      strokeSize = this.annotation.borderSize;
      strokeColor = this.getColor(this.annotation.borderColor);
      angle = Math.atan2(y2 - y1, x2 - x1) * 180 / Math.PI;
      this.shape.graphics.clear().setStrokeStyle(strokeSize, 'round', 'round').beginStroke(strokeColor).lineTo(x1, y1).lineTo(x2, y2).setStrokeStyle(1, 'miter', 'miter').beginStroke(strokeColor).beginFill(strokeColor).drawPolyStar(x2, y2, strokeSize * 1.5, 3, 0.6, angle);
      return Arrow.__super__.repaint.call(this);
    };

    Arrow.prototype.paintOutline = function () {
      var handle, i, j, results, shape, x, x1, x2, y, y1, y2;
      x1 = this.annotation.startPoint.x;
      x2 = this.annotation.endPoint.x;
      y1 = this.annotation.startPoint.y;
      y2 = this.annotation.endPoint.y;
      results = [];
      for (i = j = 0; j <= 1; i = ++j) {
        x = i === 0 ? x1 : x2;
        y = i === 0 ? y1 : y2;
        handle = this.outline['handle_' + i];
        if (!handle) {
          handle = this.outline['handle_' + i] = new createjs.Shape();
          handle.name = 'handle_' + i;
          handle['cursor'] = 'move';
          this.outline.addChild(handle);
        }
        handle['center'] = {
          x: x,
          y: y
        };
        handle.cursor = 'move';
        shape = qTestExplorer.Shape;
        results.push(handle.graphics.clear().setStrokeStyle(1).beginStroke(shape.HANDLE_STROKE_COLOR).beginFill(shape.HANDLE_FILL_COLOR).drawCircle(x, y, this.getHandleSize()));
      }
      return results;
    };

    Arrow.prototype.moveBy = function (x, y, deltaX, deltaY, handle) {
      if (!handle || handle.name === 'handle_0') {
        this.annotation.startPoint.x = this.annotation.startPoint.x + deltaX;
        this.annotation.startPoint.y = this.annotation.startPoint.y + deltaY;
      }
      if (!handle || handle.name === 'handle_1') {
        this.annotation.endPoint.x = this.annotation.endPoint.x + deltaX;
        this.annotation.endPoint.y = this.annotation.endPoint.y + deltaY;
      }
      this.repaint();
      return handle;
    };

    Arrow.prototype.move = function (deltaX, deltaY) {
      this.annotation.startPoint.x = this.annotation.startPoint.x + deltaX;
      this.annotation.startPoint.y = this.annotation.startPoint.y + deltaY;
      this.annotation.endPoint.x = this.annotation.endPoint.x + deltaX;
      this.annotation.endPoint.y = this.annotation.endPoint.y + deltaY;
      return this.repaint();
    };

    Arrow.prototype.getState = function () {
      var state;
      state = Arrow.__super__.getState.call(this);
      state.x1 = this.annotation.startPoint.x;
      state.y1 = this.annotation.startPoint.y;
      state.x2 = this.annotation.endPoint.x;
      state.y2 = this.annotation.endPoint.y;
      return state;
    };

    Arrow.prototype.setState = function (state) {
      this.startDraw(state.x1, state.y1);
      this.drawTo(state.x2, state.y2);
      return Arrow.__super__.setState.call(this, state);
    };

    return Arrow;

  })(qTestExplorer.Shape);

  qTestExplorer.Arrow = Arrow;

}).call(this);

(function () {
  var TextBoundedShape,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  TextBoundedShape = (function (superClass) {
    extend(TextBoundedShape, superClass);

    function TextBoundedShape(annotation, textBox, textboxStyle) {
      this.textBox = textBox;
      this.textboxStyle = textboxStyle;
      this.setState = bind(this.setState, this);
      this.getState = bind(this.getState, this);
      this.setFontName = bind(this.setFontName, this);
      this.setTextColor = bind(this.setTextColor, this);
      this.setFontSize = bind(this.setFontSize, this);
      this.hideTextBox = bind(this.hideTextBox, this);
      this.showTextBox = bind(this.showTextBox, this);
      this.hideText = bind(this.hideText, this);
      this.createLabel = bind(this.createLabel, this);
      this.showText = bind(this.showText, this);
      this.refreshTextboxBound = bind(this.refreshTextboxBound, this);
      this.setTextboxBound = bind(this.setTextboxBound, this);
      this.repaint = bind(this.repaint, this);
      this.deselect = bind(this.deselect, this);
      this.select = bind(this.select, this);
      this.onTextChanged = bind(this.onTextChanged, this);
      TextBoundedShape.__super__.constructor.call(this, new createjs.Container(), annotation);
      this.textBox.on('keydown', (function (_this) {
        return function (e) {
          var keyCode, text;
          if (_this.selected) {
            keyCode = e.keyCode || e.which;
            if (keyCode === 9) {
              e.preventDefault();
              text = _this.textBox.val();
              _this.textBox.val(text + '        ');
              return _this.onTextChanged(_this.textBox.val());
            }
          }
        };
      })(this)).on('keyup', (function (_this) {
        return function (e) {
          if (_this.selected) {
            _this.onTextChanged(_this.textBox.val());
            return e.preventDefault();
          }
        };
      })(this));
      $(window).resize((function (_this) {
        return function () {
          if (_this.selected) {
            return _this.refreshTextboxBound();
          }
        };
      })(this));
    }

    TextBoundedShape.prototype.onTextChanged = function (value) {
      return this.annotation.content = value;
    };

    TextBoundedShape.prototype.select = function () {
      TextBoundedShape.__super__.select.call(this);
      return this.showTextBox();
    };

    TextBoundedShape.prototype.deselect = function () {
      this.hideTextBox();
      return TextBoundedShape.__super__.deselect.call(this);
    };

    TextBoundedShape.prototype.repaint = function () {
      this.textBox.val(this.annotation.content).css("color", this.getColor(this.annotation.textColor));
      if (this.selected) {
        this.showTextBox();
      }
      return TextBoundedShape.__super__.repaint.call(this);
    };

    TextBoundedShape.prototype.setTextboxBound = function (x, y, w, h) {
      var pst, pt, stage, sx, sy, top;
      stage = this.getStage();
      sx = stage != null ? stage.scaleX : 1.0;
      sy = stage != null ? stage.scaleY : 1.0;
      pst = $('#canvas').position();
      pt = this.localToGlobal(x, y);
      top = $('#canvas').css("margin-top");
      if (top != null) {
        top = parseInt(top.replace("px", ""));
      }
      this.textBox.css('left', pt.x + (pst.left > 0 ? pst.left : 0));
      this.textBox.css('top', pt.y + ((top != null) && top > 0 ? top : 0));
      this.textBox.css('width', w * sx);
      return this.textBox.css('height', h * sy);
    };

    TextBoundedShape.prototype.refreshTextboxBound = function () { };

    TextBoundedShape.prototype.showText = function (x, y, w) {
      this.textLabel = this.createLabel(this.annotation.content);
      this.shape.addChild(this.textLabel);
      this.textLabel.x = x;
      this.textLabel.y = y;
      this.textLabel.lineWidth = w;
      return this.textLabel.shadow = new createjs.Shadow('#000', 0, 0, 0);
    };

    TextBoundedShape.prototype.createLabel = function (text) {
      var label;
      label = new createjs.Text('', 'normal ' + this.annotation.fontSize.toString() + 'px ' + this.annotation.fontName, this.getColor(this.annotation.textColor));
      label.text = text;
      return label;
    };

    TextBoundedShape.prototype.hideText = function () {
      if (this.textLabel != null) {
        return this.shape.removeChild(this.textLabel);
      }
    };

    TextBoundedShape.prototype.showTextBox = function () {
      var stage, sx;
      this.textBox.css('background', 'transparent');
      if (this.strokeColor === '#ffffff') {
        this.textBox.css('background', '#cccccc');
      }
      stage = this.getStage();
      sx = stage != null ? stage.scaleX : 1.0;
      return this.textBox.val(this.annotation.content).removeClass().addClass(this.textboxStyle).css("color", this.getColor(this.annotation.textColor)).css("font-size", this.annotation.fontSize * sx).css("font-family", this.annotation.fontName).css("line-height", this.annotation.fontSize * sx + "px").show();
    };

    TextBoundedShape.prototype.hideTextBox = function () {
      return this.textBox.val('').hide();
    };

    TextBoundedShape.prototype.setFontSize = function (size) {
      this.annotation.fontSize = size;
      return this.repaint();
    };

    TextBoundedShape.prototype.setTextColor = function (color) {
      this.annotation.textColor = color;
      return this.repaint();
    };

    TextBoundedShape.prototype.setFontName = function (name) {
      this.annotation.fontName = name;
      return this.repaint();
    };

    TextBoundedShape.prototype.getState = function () {
      var state;
      state = TextBoundedShape.__super__.getState.call(this);
      state.text = this.annotation.content;
      state.fontSize = this.annotation.fontSize;
      state.fontName = this.annotation.fontName;
      state.textColor = this.annotation.textColor;
      return state;
    };

    TextBoundedShape.prototype.setState = function (state) {
      this.annotation.content = state.text;
      this.annotation.fontSize = state.fontSize;
      this.annotation.fontName = state.fontName;
      this.annotation.textColor = state.textColor;
      return TextBoundedShape.__super__.setState.call(this, state);
    };

    return TextBoundedShape;

  })(qTestExplorer.BoundedShape);

  qTestExplorer.TextBoundedShape = TextBoundedShape;

}).call(this);

(function () {
  var Callout,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Callout = (function (superClass) {
    extend(Callout, superClass);

    function Callout(annotation, textBox) {
      this.setState = bind(this.setState, this);
      this.getState = bind(this.getState, this);
      this.move = bind(this.move, this);
      this.moveBy = bind(this.moveBy, this);
      this.refreshTextboxBound = bind(this.refreshTextboxBound, this);
      this.paintOutline = bind(this.paintOutline, this);
      this.drawCallout = bind(this.drawCallout, this);
      this.repaint = bind(this.repaint, this);
      this.getAnchorArea = bind(this.getAnchorArea, this);
      this.calculateAnchorPoints = bind(this.calculateAnchorPoints, this);
      this.setAnchorPoint = bind(this.setAnchorPoint, this);
      this.getTextBounded = bind(this.getTextBounded, this);
      this.setIsDefaultAnchor = bind(this.setIsDefaultAnchor, this);
      Callout.__super__.constructor.call(this, annotation, textBox, 'shape-callout');
      this.calloutShape = new createjs.Shape();
      this.shape.addChild(this.calloutShape);
      this.isDefaultAnchor = false;
    }

    Callout.prototype.setIsDefaultAnchor = function (value) {
      return this.isDefaultAnchor = value;
    };

    Callout.prototype.getTextBounded = function () {
      var h, thickness, w, x, y;
      thickness = this.annotation.borderSize + 10;
      w = this.annotation.width - thickness;
      h = this.annotation.height - thickness;
      x = this.annotation.left + thickness / 2;
      y = this.annotation.top + thickness / 2;
      return {
        x: x,
        y: y,
        w: w > 0 ? w : 1,
        h: h > 0 ? h : 1
      };
    };

    Callout.prototype.setAnchorPoint = function (x, y) {
      this.annotation.anchorPoint.x = x;
      return this.annotation.anchorPoint.y = y;
    };

    Callout.prototype.calculateAnchorPoints = function () {
      var anchorX, anchorY;
      if (this.isDefaultAnchor === true) {
        anchorX = this.annotation.left;
        anchorY = this.annotation.top + this.annotation.height * 1.5;
        this.annotation.anchorPoint.x = anchorX;
        return this.annotation.anchorPoint.y = anchorY;
      }
    };

    Callout.prototype.getAnchorArea = function () {
      var anchorX, anchorY, centerX, centerY, t, ta;
      anchorX = this.annotation.anchorPoint.x;
      anchorY = this.annotation.anchorPoint.y;
      centerX = this.annotation.left + this.annotation.width / 2;
      centerY = this.annotation.top + this.annotation.height / 2;
      t = this.annotation.height / this.annotation.width;
      ta = Math.abs(anchorY - centerY) / Math.abs(anchorX - centerX);
      if (anchorX < centerX && anchorY < centerY) {
        if (ta < t) {
          return 1;
        } else {
          return 2;
        }
      } else if (anchorX > centerX && anchorY < centerY) {
        if (ta > t) {
          return 3;
        } else {
          return 4;
        }
      } else if (anchorX > centerX && anchorY > centerY) {
        if (ta < t) {
          return 5;
        } else {
          return 6;
        }
      } else if (anchorX < centerX && anchorY > centerY) {
        if (ta > t) {
          return 7;
        } else {
          return 8;
        }
      }
    };

    Callout.prototype.repaint = function () {
      var anchorX, anchorY, backgroundColor, r, strokeColor, strokeSize;
      anchorX = this.annotation.anchorPoint.x;
      anchorY = this.annotation.anchorPoint.y;
      strokeSize = this.annotation.borderSize;
      strokeColor = this.getColor(this.annotation.borderColor);
      backgroundColor = this.getColor(this.annotation.backgroundColor);
      this.calculateAnchorPoints();
      this.calloutShape.graphics.clear().setStrokeStyle(strokeSize, 'round', 'round').beginStroke(strokeColor);
      if (backgroundColor !== "") {
        this.calloutShape.graphics.beginFill(backgroundColor);
      }
      this.drawCallout();
      this.hideText();
      if (this.annotation.content && !this.selected) {
        r = this.getTextBounded();
        this.showText(r.x, r.y, r.w);
      }
      return Callout.__super__.repaint.call(this);
    };

    Callout.prototype.drawCallout = function () { };

    Callout.prototype.paintOutline = function () {
      var anchorX, anchorY, handle, i, shape;
      Callout.__super__.paintOutline.call(this);
      anchorX = this.annotation.anchorPoint.x;
      anchorY = this.annotation.anchorPoint.y;
      i = 9;
      handle = this.outline['handle_' + i];
      if (!handle) {
        handle = this.outline['handle_' + i] = new createjs.Shape();
        handle.name = 'handle_' + i;
        handle['cursor'] = 'move';
        this.outline.addChild(handle);
      }
      handle['center'] = {
        x: anchorX,
        y: anchorY
      };
      shape = qTestExplorer.Shape;
      handle.graphics.clear().setStrokeStyle(1).beginStroke(shape.HANDLE_STROKE_COLOR).beginFill(shape.HANDLE_FILL_COLOR).drawCircle(anchorX, anchorY, this.getHandleSize());
      return this.refreshTextboxBound();
    };

    Callout.prototype.refreshTextboxBound = function () {
      var r;
      r = this.getTextBounded();
      return this.setTextboxBound(r.x, r.y, r.w, r.h);
    };

    Callout.prototype.moveBy = function (x, y, deltaX, deltaY, handle) {
      var anchorX, anchorY;
      this.isDefaultAnchor = false;
      anchorX = this.annotation.anchorPoint.x;
      anchorY = this.annotation.anchorPoint.y;
      if (!handle || handle.name !== 'handle_9') {
        return Callout.__super__.moveBy.call(this, x, y, deltaX, deltaY, handle);
      } else {
        this.setAnchorPoint(anchorX + deltaX, anchorY + deltaY);
        this.repaint();
        return handle;
      }
    };

    Callout.prototype.move = function (deltaX, deltaY) {
      var anchorX, anchorY;
      anchorX = this.annotation.anchorPoint.x;
      anchorY = this.annotation.anchorPoint.y;
      this.setAnchorPoint(anchorX + deltaX, anchorY + deltaY);
      return Callout.__super__.move.call(this, deltaX, deltaY);
    };

    Callout.prototype.getState = function () {
      var state;
      state = Callout.__super__.getState.call(this);
      state.anchorX = this.annotation.anchorPoint.x;
      state.anchorY = this.annotation.anchorPoint.y;
      return state;
    };

    Callout.prototype.setState = function (state) {
      this.annotation.anchorPoint.x = state.anchorX;
      this.annotation.anchorPoint.y = state.anchorY;
      this.selected = false;
      return Callout.__super__.setState.call(this, state);
    };

    return Callout;

  })(qTestExplorer.TextBoundedShape);

  qTestExplorer.Callout = Callout;

}).call(this);

(function () {
  var RoundedRectangularCallout,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  RoundedRectangularCallout = (function (superClass) {
    var DrawingHelper;

    extend(RoundedRectangularCallout, superClass);

    DrawingHelper = qTestExplorer.DrawingHelper;

    function RoundedRectangularCallout(annotation, textBox) {
      this.drawCallout = bind(this.drawCallout, this);
      this.drawRoundCallOut = bind(this.drawRoundCallOut, this);
      this.drawAnchorBottom = bind(this.drawAnchorBottom, this);
      this.drawAnchorRight = bind(this.drawAnchorRight, this);
      this.drawAnchorTop = bind(this.drawAnchorTop, this);
      this.drawAnchorLeft = bind(this.drawAnchorLeft, this);
      this.getTextBounded = bind(this.getTextBounded, this);
      this.getCornerRadius = bind(this.getCornerRadius, this);
      RoundedRectangularCallout.__super__.constructor.call(this, annotation, textBox);
    }

    RoundedRectangularCallout.prototype.getCornerRadius = function () {
      return Math.min(this.annotation.width, this.annotation.height) * 0.1;
    };

    RoundedRectangularCallout.prototype.getTextBounded = function () {
      var cornerRadius, h, w, x, y;
      cornerRadius = this.getCornerRadius();
      x = this.annotation.left + (cornerRadius / 2);
      y = this.annotation.top + (cornerRadius / 2);
      w = this.annotation.width - cornerRadius;
      h = this.annotation.height - cornerRadius;
      return {
        x: x,
        y: y,
        w: w > 0 ? w : 1,
        h: h > 0 ? h : 1
      };
    };

    RoundedRectangularCallout.prototype.drawAnchorLeft = function (areaNumber, cornerRadius) {
      var aX1, aX2, aY1, aY2, anchorX, anchorY, h, th, tw, w, x, y;
      anchorX = this.annotation.anchorPoint.x;
      anchorY = this.annotation.anchorPoint.y;
      x = this.annotation.left;
      y = this.annotation.top;
      w = this.annotation.width;
      h = this.annotation.height;
      tw = (w / 2 - cornerRadius) / 3;
      th = (h / 2 - cornerRadius) / 3;
      aX1 = x;
      aY1 = 0;
      aX2 = x;
      aY2 = 0;
      if (areaNumber === 1) {
        aY2 = y + cornerRadius + th;
        aY1 = y + cornerRadius + 2 * th;
      } else {
        aY2 = y + h / 2 + th;
        aY1 = y + h / 2 + 2 * th;
      }
      return this.calloutShape.graphics.moveTo(x + cornerRadius, y).lineTo(x + w - cornerRadius, y).arc(x + w - cornerRadius, y + cornerRadius, cornerRadius, Math.PI * (-0.5), 0, false).lineTo(x + w, y + h - cornerRadius).arc(x + w - cornerRadius, y + h - cornerRadius, cornerRadius, 0, Math.PI * 0.5, false).arc(x + cornerRadius, y + h - cornerRadius, cornerRadius, Math.PI * 0.5, Math.PI, false).lineTo(aX1, aY1).lineTo(anchorX, anchorY).lineTo(aX2, aY2).lineTo(x, y + cornerRadius).arc(x + cornerRadius, y + cornerRadius, cornerRadius, Math.PI, Math.PI * 1.5, false);
    };

    RoundedRectangularCallout.prototype.drawAnchorTop = function (areaNumber, cornerRadius) {
      var aX1, aX2, aY1, aY2, anchorX, anchorY, h, th, tw, w, x, y;
      anchorX = this.annotation.anchorPoint.x;
      anchorY = this.annotation.anchorPoint.y;
      x = this.annotation.left;
      y = this.annotation.top;
      w = this.annotation.width;
      h = this.annotation.height;
      tw = (w / 2 - cornerRadius) / 3;
      th = (h / 2 - cornerRadius) / 3;
      aX1 = 0;
      aY1 = y;
      aX2 = 0;
      aY2 = y;
      if (areaNumber === 2) {
        aX1 = x + cornerRadius + tw;
        aX2 = x + cornerRadius + 2 * tw;
      } else {
        aX1 = x + w / 2 + tw;
        aX2 = x + w / 2 + 2 * tw;
      }
      return this.calloutShape.graphics.moveTo(x + cornerRadius, y).lineTo(aX1, aY1).lineTo(anchorX, anchorY).lineTo(aX2, aY2).lineTo(x + w - cornerRadius, y).arc(x + w - cornerRadius, y + cornerRadius, cornerRadius, Math.PI * (-0.5), 0, false).lineTo(x + w, y + h - cornerRadius).arc(x + w - cornerRadius, y + h - cornerRadius, cornerRadius, 0, Math.PI * 0.5, false).arc(x + cornerRadius, y + h - cornerRadius, cornerRadius, Math.PI * 0.5, Math.PI, false).lineTo(x, y + cornerRadius).arc(x + cornerRadius, y + cornerRadius, cornerRadius, Math.PI, Math.PI * 1.5, false);
    };

    RoundedRectangularCallout.prototype.drawAnchorRight = function (areaNumber, cornerRadius) {
      var aX1, aX2, aY1, aY2, anchorX, anchorY, h, th, tw, w, x, y;
      anchorX = this.annotation.anchorPoint.x;
      anchorY = this.annotation.anchorPoint.y;
      x = this.annotation.left;
      y = this.annotation.top;
      w = this.annotation.width;
      h = this.annotation.height;
      tw = (w / 2 - cornerRadius) / 3;
      th = (h / 2 - cornerRadius) / 3;
      aX1 = x + w;
      aY1 = 0;
      aX2 = x + w;
      aY2 = 0;
      if (areaNumber === 4) {
        aY1 = y + cornerRadius + th;
        aY2 = y + cornerRadius + 2 * th;
      } else {
        aY1 = y + h / 2 + th;
        aY2 = y + h / 2 + 2 * th;
      }
      return this.calloutShape.graphics.moveTo(x + cornerRadius, y).lineTo(x + w - cornerRadius, y).arc(x + w - cornerRadius, y + cornerRadius, cornerRadius, Math.PI * (-0.5), 0, false).lineTo(aX1, aY1).lineTo(anchorX, anchorY).lineTo(aX2, aY2).lineTo(x + w, y + h - cornerRadius).arc(x + w - cornerRadius, y + h - cornerRadius, cornerRadius, 0, Math.PI * 0.5, false).arc(x + cornerRadius, y + h - cornerRadius, cornerRadius, Math.PI * 0.5, Math.PI, false).lineTo(x, y + cornerRadius).arc(x + cornerRadius, y + cornerRadius, cornerRadius, Math.PI, Math.PI * 1.5, false);
    };

    RoundedRectangularCallout.prototype.drawAnchorBottom = function (areaNumber, cornerRadius) {
      var aX1, aX2, aY1, aY2, anchorX, anchorY, h, th, tw, w, x, y;
      anchorX = this.annotation.anchorPoint.x;
      anchorY = this.annotation.anchorPoint.y;
      x = this.annotation.left;
      y = this.annotation.top;
      w = this.annotation.width;
      h = this.annotation.height;
      tw = (w / 2 - cornerRadius) / 3;
      th = (h / 2 - cornerRadius) / 3;
      aX1 = 0;
      aY1 = y + h;
      aX2 = 0;
      aY2 = y + h;
      if (areaNumber === 6) {
        aX1 = x + w - cornerRadius - tw;
        aX2 = x + w - cornerRadius - 2 * tw;
      } else {
        aX1 = x + w / 2 - tw;
        aX2 = x + w / 2 - 2 * tw;
      }
      return this.calloutShape.graphics.moveTo(x + cornerRadius, y).lineTo(x + w - cornerRadius, y).arc(x + w - cornerRadius, y + cornerRadius, cornerRadius, Math.PI * (-0.5), 0, false).lineTo(x + w, y + h - cornerRadius).arc(x + w - cornerRadius, y + h - cornerRadius, cornerRadius, 0, Math.PI * 0.5, false).lineTo(aX1, aY1).lineTo(anchorX, anchorY).lineTo(aX2, aY2).lineTo(x + cornerRadius, y + h).arc(x + cornerRadius, y + h - cornerRadius, cornerRadius, Math.PI * 0.5, Math.PI, false).lineTo(x, y + cornerRadius).arc(x + cornerRadius, y + cornerRadius, cornerRadius, Math.PI, Math.PI * 1.5, false);
    };

    RoundedRectangularCallout.prototype.drawRoundCallOut = function (cornerRadius) {
      var areaNumber;
      areaNumber = this.getAnchorArea();
      if (areaNumber === 2 || areaNumber === 3) {
        return this.drawAnchorTop(areaNumber, cornerRadius);
      } else if (areaNumber === 4 || areaNumber === 5) {
        return this.drawAnchorRight(areaNumber, cornerRadius);
      } else if (areaNumber === 6 || areaNumber === 7) {
        return this.drawAnchorBottom(areaNumber, cornerRadius);
      } else if (areaNumber === 8 || areaNumber === 1) {
        return this.drawAnchorLeft(areaNumber, cornerRadius);
      }
    };

    RoundedRectangularCallout.prototype.drawCallout = function () {
      var cornerRadius;
      cornerRadius = this.getCornerRadius();
      this.drawRoundCallOut(cornerRadius);
      return RoundedRectangularCallout.__super__.drawCallout.call(this);
    };

    return RoundedRectangularCallout;

  })(qTestExplorer.Callout);

  qTestExplorer.RoundedRectangularCallout = RoundedRectangularCallout;

}).call(this);

(function () {
  var RectangularCallout,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  RectangularCallout = (function (superClass) {
    extend(RectangularCallout, superClass);

    function RectangularCallout(annotation, textBox) {
      this.getTextBounded = bind(this.getTextBounded, this);
      this.getCornerRadius = bind(this.getCornerRadius, this);
      RectangularCallout.__super__.constructor.call(this, annotation, textBox);
    }

    RectangularCallout.prototype.getCornerRadius = function () {
      return 0;
    };

    RectangularCallout.prototype.getTextBounded = function () {
      var h, thickness, w, x, y;
      thickness = this.annotation.borderSize + 10;
      w = this.annotation.width - thickness;
      h = this.annotation.height - thickness;
      x = this.annotation.left + thickness / 2;
      y = this.annotation.top + thickness / 2;
      return {
        x: x,
        y: y,
        w: w > 0 ? w : 1,
        h: h > 0 ? h : 1
      };
    };

    return RectangularCallout;

  })(qTestExplorer.RoundedRectangularCallout);

  qTestExplorer.RectangularCallout = RectangularCallout;

}).call(this);

(function () {
  var OvalCallout,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  OvalCallout = (function (superClass) {
    var DrawingHelper;

    extend(OvalCallout, superClass);

    DrawingHelper = qTestExplorer.DrawingHelper;

    function OvalCallout(annotation, textBox) {
      this.drawCallout = bind(this.drawCallout, this);
      this.getTextBounded = bind(this.getTextBounded, this);
      this.drawOvalCallOut = bind(this.drawOvalCallOut, this);
      OvalCallout.__super__.constructor.call(this, annotation, textBox);
    }

    OvalCallout.prototype.drawOvalCallOut = function () {
      var anchorOnTheBottom, anchorOnTheLeftCorner, anchorOnTheRightCorner, anchorX, anchorY, angle, angle1, angle2, cx, cy, delta, fromAngle, h, p2, point0, w, x, y;
      x = this.annotation.left;
      y = this.annotation.top;
      w = this.annotation.width;
      h = this.annotation.height;
      anchorX = this.annotation.anchorPoint.x;
      anchorY = this.annotation.anchorPoint.y;
      cx = x + w / 2;
      cy = y + h / 2;
      delta = 10 * (Math.PI / 180);
      angle = DrawingHelper.getAnchorAngleOfCallout(this.annotation);
      anchorOnTheLeftCorner = angle > 2 * Math.PI - delta || angle < delta;
      anchorOnTheRightCorner = angle > Math.PI - delta && angle < Math.PI + delta;
      anchorOnTheBottom = (angle > 0 && angle < Math.PI || anchorOnTheRightCorner) && !anchorOnTheLeftCorner;
      angle1 = angle - delta;
      angle2 = angle + delta;
      point0 = {
        x: x,
        y: y + (h / 2)
      };
      fromAngle = 0;
      if (angle2 >= 2 * Math.PI) {
        angle2 = angle2 - 2 * Math.PI;
      }
      if (anchorOnTheLeftCorner === true) {
        fromAngle = angle2;
      }
      if (anchorOnTheBottom === true) {
        DrawingHelper.drawInvertOval(this.calloutShape.graphics, fromAngle, angle1, cx, cy, w / 2, h / 2);
        this.calloutShape.graphics.lineTo(anchorX, anchorY);
        fromAngle = angle2;
        if (anchorOnTheRightCorner === false) {
          DrawingHelper.drawInvertOval(this.calloutShape.graphics, fromAngle, Math.PI, cx, cy, w / 2, h / 2);
          fromAngle = Math.PI;
        }
      } else {
        DrawingHelper.drawInvertOval(this.calloutShape.graphics, fromAngle, Math.PI, cx, cy, w / 2, h / 2);
        fromAngle = Math.PI;
      }
      if (anchorOnTheBottom === false) {
        if (angle1 < 0) {
          angle1 = 2 * Math.PI + angle1;
        }
        DrawingHelper.drawInvertOval(this.calloutShape.graphics, fromAngle, angle1, cx, cy, w / 2, h / 2);
        this.calloutShape.graphics.lineTo(anchorX, anchorY);
        fromAngle = angle2;
        if (anchorOnTheLeftCorner === false) {
          return DrawingHelper.drawInvertOval(this.calloutShape.graphics, fromAngle, 2 * Math.PI, cx, cy, w / 2, h / 2);
        } else {
          p2 = DrawingHelper.getInvertOvalPointFromAngle(angle2, cx, cy, w / 2, h / 2);
          return this.calloutShape.graphics.lineTo(p2.x, p2.y);
        }
      } else {
        return DrawingHelper.drawInvertOval(this.calloutShape.graphics, fromAngle, 2 * Math.PI, cx, cy, w / 2, h / 2);
      }
    };

    OvalCallout.prototype.getTextBounded = function () {
      var delta, h, p1, p2, r, w, x, y;
      w = this.annotation.width;
      h = this.annotation.height;
      x = this.annotation.left;
      y = this.annotation.top;
      p1 = DrawingHelper.getOvalPointFromAngle(1.25 * Math.PI, x + w / 2, y + h / 2, w / 2, h / 2);
      p2 = DrawingHelper.getOvalPointFromAngle(0.25 * Math.PI, x + w / 2, y + h / 2, w / 2, h / 2);
      r = {
        x: p1.x,
        y: p1.y,
        w: p2.x - p1.x,
        h: p2.y - p1.y
      };
      delta = this.annotation.borderSize;
      return {
        x: r.x + delta,
        y: r.y + delta,
        w: r.w - 2 * delta,
        h: r.h - 2 * delta
      };
    };

    OvalCallout.prototype.drawCallout = function () {
      return this.drawOvalCallOut();
    };

    return OvalCallout;

  })(qTestExplorer.Callout);

  qTestExplorer.OvalCallout = OvalCallout;

}).call(this);

(function () {
  var CloudCallout,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  CloudCallout = (function (superClass) {
    var CalloutDrawing, DrawingHelper;

    extend(CloudCallout, superClass);

    DrawingHelper = qTestExplorer.DrawingHelper;

    CalloutDrawing = qTestExplorer.CloudCalloutDrawingHelper;

    function CloudCallout(annotation, textBox) {
      this.drawCallout = bind(this.drawCallout, this);
      this.getTextBounded = bind(this.getTextBounded, this);
      CloudCallout.__super__.constructor.call(this, annotation, textBox);
    }

    CloudCallout.prototype.getTextBounded = function () {
      var delta, h, r, w, x, y;
      w = this.annotation.width;
      h = this.annotation.height;
      x = this.annotation.left;
      y = this.annotation.top;
      r = CalloutDrawing.getCloudCalloutTextableArea({
        x: x,
        y: y,
        w: (w > 0 ? w : 1),
        h: (h > 0 ? h : 1)
      });
      delta = Math.max(this.annotation.borderSize, 10);
      return {
        x: r.x + delta,
        y: r.y + delta,
        w: r.w - 2 * delta,
        h: r.h - 2 * delta
      };
    };

    CloudCallout.prototype.drawCallout = function () {
      return CalloutDrawing.drawCloudCallout(this.calloutShape.graphics, this.annotation);
    };

    return CloudCallout;

  })(qTestExplorer.Callout);

  qTestExplorer.CloudCallout = CloudCallout;

}).call(this);

(function () {
  var LineCallout,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  LineCallout = (function (superClass) {
    extend(LineCallout, superClass);

    function LineCallout(annotation, textBox, hasAccentBar) {
      var anchor1, ref;
      this.hasAccentBar = hasAccentBar;
      this.setState = bind(this.setState, this);
      this.getState = bind(this.getState, this);
      this.moveBy = bind(this.moveBy, this);
      this.paintOutline = bind(this.paintOutline, this);
      this.drawAnchorLines = bind(this.drawAnchorLines, this);
      this.drawLineCallout = bind(this.drawLineCallout, this);
      this.setAnchorToList = bind(this.setAnchorToList, this);
      this.getAnchorFromList = bind(this.getAnchorFromList, this);
      this.calculateAnchorPoints = bind(this.calculateAnchorPoints, this);
      this.drawCallout = bind(this.drawCallout, this);
      this.setIsDefaultAnchor = bind(this.setIsDefaultAnchor, this);
      LineCallout.__super__.constructor.call(this, annotation, textBox);
      this.calloutAnchor = new createjs.Shape();
      this.shape.addChild(this.calloutAnchor);
      if (((ref = this.annotation.additionalAnchorPoints) != null ? ref.length : void 0) > 0) {
        anchor1 = this.annotation.additionalAnchorPoints[0];
        this.anchor1WidthRatio = (anchor1.x - this.annotation.left) / this.annotation.width;
        this.anchor1HeightRatio = (anchor1.y - this.annotation.top) / this.annotation.height;
      }
    }

    LineCallout.prototype.setIsDefaultAnchor = function (value) {
      LineCallout.__super__.setIsDefaultAnchor.call(this, value);
      if (this.isDefaultAnchor === true) {
        this.anchor1WidthRatio = -0.06;
        this.anchor1HeightRatio = 0.2;
        this.anchorWidthRatio = -0.38;
        return this.anchorHeightRatio = 1.15;
      }
    };

    LineCallout.prototype.drawCallout = function () {
      return this.drawLineCallout();
    };

    LineCallout.prototype.calculateAnchorPoints = function () {
      var anchor1, h, l, newList, t, w;
      l = this.annotation.left;
      t = this.annotation.top;
      w = this.annotation.width;
      h = this.annotation.height;
      if (this.isDefaultAnchor === true) {
        this.setAnchorPoint(l + w * this.anchorWidthRatio, t + h * this.anchorHeightRatio);
      }
      newList = [];
      anchor1 = {
        x: l + w * this.anchor1WidthRatio,
        y: t + h * this.anchor1HeightRatio
      };
      newList.push(anchor1);
      return this.annotation.additionalAnchorPoints = newList;
    };

    LineCallout.prototype.getAnchorFromList = function (index) {
      var ref;
      if (((ref = this.annotation.additionalAnchorPoints) != null ? ref.length : void 0) > index) {
        return this.annotation.additionalAnchorPoints[index];
      }
      return {
        x: 0,
        y: 0
      };
    };

    LineCallout.prototype.setAnchorToList = function (index, x, y) {
      var ref;
      if (((ref = this.annotation.additionalAnchorPoints) != null ? ref.length : void 0) > index) {
        return this.annotation.additionalAnchorPoints[index] = {
          x: x,
          y: y
        };
      }
    };

    LineCallout.prototype.drawLineCallout = function () {
      var anchor1, graphics, strokeColor, strokeSize;
      graphics = this.calloutShape.graphics;
      graphics.drawRect(this.annotation.left, this.annotation.top, this.annotation.width, this.annotation.height);
      anchor1 = this.getAnchorFromList(0);
      if (this.hasAccentBar === true) {
        graphics.moveTo(anchor1.x, this.annotation.top);
        graphics.lineTo(anchor1.x, this.annotation.top + this.annotation.height);
      }
      strokeSize = this.annotation.borderSize;
      strokeColor = this.getColor(this.annotation.borderColor);
      this.calloutAnchor.graphics.clear().setStrokeStyle(strokeSize, 'round', 'round').beginStroke(strokeColor);
      return this.drawAnchorLines(this.calloutAnchor.graphics);
    };

    LineCallout.prototype.drawAnchorLines = function (graphics) {
      var anchor, anchor1;
      anchor1 = this.getAnchorFromList(0);
      anchor = this.annotation.anchorPoint;
      graphics.moveTo(anchor1.x, anchor1.y);
      return graphics.lineTo(anchor.x, anchor.y);
    };

    LineCallout.prototype.paintOutline = function () {
      var anchor1, handle, i, shape;
      LineCallout.__super__.paintOutline.call(this);
      anchor1 = this.getAnchorFromList(0);
      i = 10;
      handle = this.outline['handle_' + i];
      if (!handle) {
        handle = this.outline['handle_' + i] = new createjs.Shape();
        handle.name = 'handle_' + i;
        handle['cursor'] = 'move';
        this.outline.addChild(handle);
      }
      handle['center'] = {
        x: anchor1.x,
        y: anchor1.y
      };
      shape = qTestExplorer.Shape;
      return handle.graphics.clear().setStrokeStyle(1).beginStroke(shape.HANDLE_STROKE_COLOR).beginFill(shape.HANDLE_FILL_COLOR).drawCircle(anchor1.x, anchor1.y, this.getHandleSize());
    };

    LineCallout.prototype.moveBy = function (x, y, deltaX, deltaY, handle) {
      var anchor1;
      if (!handle || handle.name !== 'handle_10') {
        return LineCallout.__super__.moveBy.call(this, x, y, deltaX, deltaY, handle);
      } else {
        anchor1 = this.getAnchorFromList(0);
        x = anchor1.x + deltaX;
        y = anchor1.y + deltaY;
        this.setAnchorToList(0, x, y);
        this.anchor1WidthRatio = (x - this.annotation.left) / this.annotation.width;
        this.anchor1HeightRatio = (y - this.annotation.top) / this.annotation.height;
        this.repaint();
        return handle;
      }
    };

    LineCallout.prototype.getState = function () {
      var state;
      state = LineCallout.__super__.getState.call(this);
      state.anchor1WidthRatio = this.anchor1WidthRatio;
      state.anchor1HeightRatio = this.anchor1HeightRatio;
      return state;
    };

    LineCallout.prototype.setState = function (state) {
      this.anchor1WidthRatio = state.anchor1WidthRatio;
      this.anchor1HeightRatio = state.anchor1HeightRatio;
      return LineCallout.__super__.setState.call(this, state);
    };

    return LineCallout;

  })(qTestExplorer.Callout);

  qTestExplorer.LineCallout = LineCallout;

}).call(this);

(function () {
  var Line1Callout,
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Line1Callout = (function (superClass) {
    var DrawingHelper;

    extend(Line1Callout, superClass);

    DrawingHelper = qTestExplorer.DrawingHelper;

    function Line1Callout(annotation, textBox, hasAccentBar) {
      Line1Callout.__super__.constructor.call(this, annotation, textBox, hasAccentBar);
    }

    return Line1Callout;

  })(qTestExplorer.LineCallout);

  qTestExplorer.Line1Callout = Line1Callout;

}).call(this);

(function () {
  var Line2Callout,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Line2Callout = (function (superClass) {
    extend(Line2Callout, superClass);

    function Line2Callout(annotation, textBox, hasAccentBar) {
      this.setState = bind(this.setState, this);
      this.getState = bind(this.getState, this);
      this.moveBy = bind(this.moveBy, this);
      this.paintOutline = bind(this.paintOutline, this);
      this.drawAnchorLines = bind(this.drawAnchorLines, this);
      this.calculateAnchorPoints = bind(this.calculateAnchorPoints, this);
      this.setIsDefaultAnchor = bind(this.setIsDefaultAnchor, this);
      var anchor2, ref;
      Line2Callout.__super__.constructor.call(this, annotation, textBox, hasAccentBar);
      if (((ref = this.annotation.additionalAnchorPoints) != null ? ref.length : void 0) > 1) {
        anchor2 = this.annotation.additionalAnchorPoints[1];
        this.anchor2WidthRatio = (anchor2.x - this.annotation.left) / this.annotation.width;
        this.anchor2HeightRatio = (anchor2.y - this.annotation.top) / this.annotation.height;
      }
    }

    Line2Callout.prototype.setIsDefaultAnchor = function (value) {
      Line2Callout.__super__.setIsDefaultAnchor.call(this, value);
      if (this.isDefaultAnchor === true) {
        this.anchor2WidthRatio = -0.17;
        return this.anchor2HeightRatio = 0.2;
      }
    };

    Line2Callout.prototype.calculateAnchorPoints = function () {
      var anchor2, h, l, t, w;
      Line2Callout.__super__.calculateAnchorPoints.call(this);
      l = this.annotation.left;
      t = this.annotation.top;
      w = this.annotation.width;
      h = this.annotation.height;
      anchor2 = {
        x: l + w * this.anchor2WidthRatio,
        y: t + h * this.anchor2HeightRatio
      };
      return this.annotation.additionalAnchorPoints.push(anchor2);
    };

    Line2Callout.prototype.drawAnchorLines = function (graphics) {
      var anchor, anchor1, anchor2;
      anchor1 = this.getAnchorFromList(0);
      anchor2 = this.getAnchorFromList(1);
      anchor = this.annotation.anchorPoint;
      graphics.moveTo(anchor1.x, anchor1.y);
      graphics.lineTo(anchor2.x, anchor2.y);
      return graphics.lineTo(anchor.x, anchor.y);
    };

    Line2Callout.prototype.paintOutline = function () {
      var anchor2, handle, i, shape;
      Line2Callout.__super__.paintOutline.call(this);
      anchor2 = this.getAnchorFromList(1);
      i = 11;
      handle = this.outline['handle_' + i];
      if (!handle) {
        handle = this.outline['handle_' + i] = new createjs.Shape();
        handle.name = 'handle_' + i;
        handle['cursor'] = 'move';
        this.outline.addChild(handle);
      }
      handle['center'] = {
        x: anchor2.x,
        y: anchor2.y
      };
      shape = qTestExplorer.Shape;
      return handle.graphics.clear().setStrokeStyle(1).beginStroke(shape.HANDLE_STROKE_COLOR).beginFill(shape.HANDLE_FILL_COLOR).drawCircle(anchor2.x, anchor2.y, this.getHandleSize());
    };

    Line2Callout.prototype.moveBy = function (x, y, deltaX, deltaY, handle) {
      var anchor2;
      if (!handle || handle.name !== 'handle_11') {
        return Line2Callout.__super__.moveBy.call(this, x, y, deltaX, deltaY, handle);
      } else {
        anchor2 = this.getAnchorFromList(1);
        x = anchor2.x + deltaX;
        y = anchor2.y + deltaY;
        this.setAnchorToList(1, x, y);
        this.anchor2WidthRatio = (x - this.annotation.left) / this.annotation.width;
        this.anchor2HeightRatio = (y - this.annotation.top) / this.annotation.height;
        this.repaint();
        return handle;
      }
    };

    Line2Callout.prototype.getState = function () {
      var state;
      state = Line2Callout.__super__.getState.call(this);
      state.anchor2WidthRatio = this.anchor2WidthRatio;
      state.anchor2HeightRatio = this.anchor2HeightRatio;
      return state;
    };

    Line2Callout.prototype.setState = function (state) {
      this.anchor2WidthRatio = state.anchor2WidthRatio;
      this.anchor2HeightRatio = state.anchor2HeightRatio;
      return Line2Callout.__super__.setState.call(this, state);
    };

    return Line2Callout;

  })(qTestExplorer.LineCallout);

  qTestExplorer.Line2Callout = Line2Callout;

}).call(this);

(function () {
  var Line3Callout,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Line3Callout = (function (superClass) {
    extend(Line3Callout, superClass);

    function Line3Callout(annotation, textBox, hasAccentBar) {
      this.setState = bind(this.setState, this);
      this.getState = bind(this.getState, this);
      this.moveBy = bind(this.moveBy, this);
      this.paintOutline = bind(this.paintOutline, this);
      this.drawAnchorLines = bind(this.drawAnchorLines, this);
      this.calculateAnchorPoints = bind(this.calculateAnchorPoints, this);
      this.setIsDefaultAnchor = bind(this.setIsDefaultAnchor, this);
      var anchor3, ref;
      Line3Callout.__super__.constructor.call(this, annotation, textBox, hasAccentBar);
      if (((ref = this.annotation.additionalAnchorPoints) != null ? ref.length : void 0) > 2) {
        anchor3 = this.annotation.additionalAnchorPoints[2];
        this.anchor3WidthRatio = (anchor3.x - this.annotation.left) / this.annotation.width;
        this.anchor3HeightRatio = (anchor3.y - this.annotation.top) / this.annotation.height;
      }
    }

    Line3Callout.prototype.setIsDefaultAnchor = function (value) {
      Line3Callout.__super__.setIsDefaultAnchor.call(this, value);
      if (this.isDefaultAnchor === true) {
        this.anchor3WidthRatio = -0.17;
        this.anchor3HeightRatio = 1;
        return this.anchorWidthRatio = -0.06;
      }
    };

    Line3Callout.prototype.calculateAnchorPoints = function () {
      var anchor3, h, l, t, w;
      Line3Callout.__super__.calculateAnchorPoints.call(this);
      l = this.annotation.left;
      t = this.annotation.top;
      w = this.annotation.width;
      h = this.annotation.height;
      anchor3 = {
        x: l + w * this.anchor3WidthRatio,
        y: t + h * this.anchor3HeightRatio
      };
      return this.annotation.additionalAnchorPoints.push(anchor3);
    };

    Line3Callout.prototype.drawAnchorLines = function (graphics) {
      var anchor, anchor1, anchor2, anchor3;
      anchor1 = this.getAnchorFromList(0);
      anchor2 = this.getAnchorFromList(1);
      anchor3 = this.getAnchorFromList(2);
      anchor = this.annotation.anchorPoint;
      graphics.moveTo(anchor1.x, anchor1.y);
      graphics.lineTo(anchor2.x, anchor2.y);
      graphics.lineTo(anchor3.x, anchor3.y);
      return graphics.lineTo(anchor.x, anchor.y);
    };

    Line3Callout.prototype.paintOutline = function () {
      var anchor3, handle, i, shape;
      Line3Callout.__super__.paintOutline.call(this);
      anchor3 = this.getAnchorFromList(2);
      i = 12;
      handle = this.outline['handle_' + i];
      if (!handle) {
        handle = this.outline['handle_' + i] = new createjs.Shape();
        handle.name = 'handle_' + i;
        handle['cursor'] = 'move';
        this.outline.addChild(handle);
      }
      handle['center'] = {
        x: anchor3.x,
        y: anchor3.y
      };
      shape = qTestExplorer.Shape;
      return handle.graphics.clear().setStrokeStyle(1).beginStroke(shape.HANDLE_STROKE_COLOR).beginFill(shape.HANDLE_FILL_COLOR).drawCircle(anchor3.x, anchor3.y, this.getHandleSize());
    };

    Line3Callout.prototype.moveBy = function (x, y, deltaX, deltaY, handle) {
      var anchor3;
      if (!handle || handle.name !== 'handle_12') {
        return Line3Callout.__super__.moveBy.call(this, x, y, deltaX, deltaY, handle);
      } else {
        anchor3 = this.getAnchorFromList(2);
        x = anchor3.x + deltaX;
        y = anchor3.y + deltaY;
        this.setAnchorToList(1, x, y);
        this.anchor3WidthRatio = (x - this.annotation.left) / this.annotation.width;
        this.anchor3HeightRatio = (y - this.annotation.top) / this.annotation.height;
        this.repaint();
        return handle;
      }
    };

    Line3Callout.prototype.getState = function () {
      var state;
      state = Line3Callout.__super__.getState.call(this);
      state.anchor3WidthRatio = this.anchor3WidthRatio;
      state.anchor3HeightRatio = this.anchor3HeightRatio;
      return state;
    };

    Line3Callout.prototype.setState = function (state) {
      this.anchor3WidthRatio = state.anchor3WidthRatio;
      this.anchor3HeightRatio = state.anchor3HeightRatio;
      return Line3Callout.__super__.setState.call(this, state);
    };

    return Line3Callout;

  })(qTestExplorer.Line2Callout);

  qTestExplorer.Line3Callout = Line3Callout;

}).call(this);

(function () {
  var ShapeText,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  ShapeText = (function (superClass) {
    extend(ShapeText, superClass);

    function ShapeText(annotation, textBox) {
      this.checkHit = bind(this.checkHit, this);
      this.setFontSize = bind(this.setFontSize, this);
      this.getMeasuredWidth = bind(this.getMeasuredWidth, this);
      this.getMeasuredHeight = bind(this.getMeasuredHeight, this);
      this.repaint = bind(this.repaint, this);
      this.refreshTextboxBound = bind(this.refreshTextboxBound, this);
      this.paintOutline = bind(this.paintOutline, this);
      this.select = bind(this.select, this);
      this.onTextChanged = bind(this.onTextChanged, this);
      this.recomputeBound = bind(this.recomputeBound, this);
      ShapeText.__super__.constructor.call(this, annotation, textBox, 'shape-text');
      this.recomputeBound();
    }

    ShapeText.prototype.drawTo = function (x, y) {
      this.setBound(x, y, 50, 30);
      if (this.annotation.content) {
        return this.recomputeBound();
      }
    };

    ShapeText.prototype.recomputeBound = function (x, y) {
      var h, w;
      if (x == null) {
        x = this.annotation.left;
      }
      if (y == null) {
        y = this.annotation.top;
      }
      w = this.getMeasuredWidth() + this.annotation.fontSize + 60;
      h = this.getMeasuredHeight() + this.annotation.fontSize + 10;
      return this.setBound(x, y, w, h);
    };

    ShapeText.prototype.onTextChanged = function (value) {
      ShapeText.__super__.onTextChanged.call(this, value);
      return this.recomputeBound();
    };

    ShapeText.prototype.select = function () {
      ShapeText.__super__.select.call(this);
      return this.textBox.focus();
    };

    ShapeText.prototype.paintOutline = function () { };

    ShapeText.prototype.refreshTextboxBound = function () {
      return this.setTextboxBound(this.annotation.left + 5, this.annotation.top + 5, this.annotation.width, this.annotation.height);
    };

    ShapeText.prototype.repaint = function () {
      this.refreshTextboxBound();
      this.hideText();
      if (this.annotation.content && !this.selected) {
        this.showText(this.annotation.left + 5, this.annotation.top + 5, this.annotation.width - 10);
        if (this.hitArea == null) {
          this.hitArea = new createjs.Shape();
        }
        this.hitArea.graphics.clear().beginFill("#000").drawRect(this.annotation.left, this.annotation.top, this.getMeasuredWidth(), this.getMeasuredHeight());
      }
      return ShapeText.__super__.repaint.call(this);
    };

    ShapeText.prototype.getMeasuredHeight = function () {
      var label;
      if (!this.annotation.content) {
        return 0;
      }
      label = this.createLabel(this.annotation.content);
      return label.getMeasuredHeight();
    };

    ShapeText.prototype.getMeasuredWidth = function () {
      var lines, mLine, textLabel;
      if (!this.annotation.content) {
        return 0;
      }
      lines = this.annotation.content.split(/\r\n|\r|\n/);
      mLine = null;
      _.each(lines, (function (_this) {
        return function (line) {
          if (!mLine) {
            return mLine = line;
          } else if (line.length > mLine.length) {
            return mLine = line;
          }
        };
      })(this));
      textLabel = this.createLabel(mLine);
      return textLabel.getMeasuredWidth();
    };

    ShapeText.prototype.setFontSize = function (size) {
      ShapeText.__super__.setFontSize.call(this, size);
      return this.recomputeBound();
    };

    ShapeText.prototype.checkHit = function (x, y) {
      var b, l, r, t;
      l = this.annotation.left;
      t = this.annotation.top;
      r = l + this.getMeasuredWidth();
      b = t + this.getMeasuredHeight();
      return new qTestExplorer.HitResult(x > l && x < r && y > t && y < b, "move");
    };

    return ShapeText;

  })(qTestExplorer.TextBoundedShape);

  qTestExplorer.ShapeText = ShapeText;

}).call(this);

(function () {
  var Blackout,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Blackout = (function (superClass) {
    extend(Blackout, superClass);

    function Blackout(annotation, image) {
      this.image = image;
      this.repaint = bind(this.repaint, this);
      this.createShadow = bind(this.createShadow, this);
      Blackout.__super__.constructor.call(this, new createjs.Container(), annotation);
      this.shape.addChild(this.image);
      this.image.filters = [new createjs.BlurFilter(6, 6, 3)];
    }

    Blackout.prototype.createShadow = function () {
      return null;
    };

    Blackout.prototype.repaint = function () {
      var canvas, h, maxH, maxW, stage, w, x, y;
      if (this.annotation.width > 0 && this.annotation.height > 0) {
        x = this.annotation.left;
        y = this.annotation.top;
        w = this.annotation.width;
        h = this.annotation.height;
        stage = this.getStage();
        canvas = this.getStage().canvas;
        maxW = canvas.width / stage.scaleX;
        maxH = canvas.height / stage.scaleY;
        if (x < 0) {
          w += x;
          x = 0;
        } else if (x > maxW) {
          x = maxW;
          w = 0;
        } else if ((x + w) > maxW) {
          w = maxW - x;
        }
        if (y < 0) {
          h += y;
          y = 0;
        } else if (y > maxH) {
          y = maxH;
          h = 0;
        } else if ((y + h) > maxH) {
          h = maxH - y;
        }
        if (w <= 0 || h <= 0) {
          return;
        }
        this.image.sourceRect = new createjs.Rectangle(x, y, w, h);
        this.image.x = x;
        this.image.y = y;
        this.image.cache(0, 0, w, h);
        return Blackout.__super__.repaint.call(this);
      }
    };

    return Blackout;

  })(qTestExplorer.BoundedShape);

  qTestExplorer.Blackout = Blackout;

}).call(this);

(function () {
  var Crop,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Crop = (function (superClass) {
    extend(Crop, superClass);

    function Crop(x, y, w, h) {
      this.checkHit = bind(this.checkHit, this);
      this.getBound = bind(this.getBound, this);
      this.repaint = bind(this.repaint, this);
      this.createShadow = bind(this.createShadow, this);
      Crop.__super__.constructor.call(this, new createjs.Shape(), {
        left: x != null ? x : 0,
        top: y != null ? y : 0,
        width: w != null ? w : 0,
        height: h != null ? h : 0
      });
    }

    Crop.prototype.createShadow = function () {
      return new createjs.Shadow('#FF1414', 0, 0, 10);
    };

    Crop.prototype.repaint = function () {
      this.shape.graphics.clear().setStrokeStyle(1).beginStroke("#000000").drawRect(this.annotation.left, this.annotation.top, this.annotation.width, this.annotation.height);
      if (this.hitArea == null) {
        this.hitArea = new createjs.Shape();
      }
      this.hitArea.graphics.clear().beginFill("#000").drawRect(this.annotation.left, this.annotation.top, this.annotation.width, this.annotation.height);
      return Crop.__super__.repaint.call(this);
    };

    Crop.prototype.getBound = function () {
      return {
        x: this.annotation.left,
        y: this.annotation.top,
        width: this.annotation.width,
        height: this.annotation.height
      };
    };

    Crop.prototype.checkHit = function (x, y) {
      var b, handle, l, r, t;
      handle = this.getHandleAtPoint(x, y);
      if (handle) {
        return new qTestExplorer.HitResult(true, handle.cursor, handle);
      }
      l = this.annotation.left;
      t = this.annotation.top;
      r = l + this.annotation.width;
      b = t + this.annotation.height;
      return new qTestExplorer.HitResult(x > l && x < r && y > t && y < b, "move");
    };

    return Crop;

  })(qTestExplorer.BoundedShape);

  qTestExplorer.Crop = Crop;

}).call(this);

(function () {
  var Hit, Tool,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; };

  Tool = (function () {
    function Tool(name1, editor) {
      this.name = name1;
      this.editor = editor;
      this.deselect = bind(this.deselect, this);
      this.select = bind(this.select, this);
      this.onChanged = bind(this.onChanged, this);
      this.onRemoved = bind(this.onRemoved, this);
      this.onCreated = bind(this.onCreated, this);
      this.onKeyDown = bind(this.onKeyDown, this);
      this.onKeyUp = bind(this.onKeyUp, this);
      this.onPressUp = bind(this.onPressUp, this);
      this.onMouseUp = bind(this.onMouseUp, this);
      this.onPressMove = bind(this.onPressMove, this);
      this.onMouseMove = bind(this.onMouseMove, this);
      this.onMouseDown = bind(this.onMouseDown, this);
      this.onFontNameChanged = bind(this.onFontNameChanged, this);
      this.onFontSizeChanged = bind(this.onFontSizeChanged, this);
      this.onStrokeSizeChanged = bind(this.onStrokeSizeChanged, this);
      this.onTextColorChanged = bind(this.onTextColorChanged, this);
      this.onBackgroundColorChanged = bind(this.onBackgroundColorChanged, this);
      this.onStrokeColorChanged = bind(this.onStrokeColorChanged, this);
      this.onZoomChanged = bind(this.onZoomChanged, this);
      this.onScreenChanged = bind(this.onScreenChanged, this);
      this.onScreenChanging = bind(this.onScreenChanging, this);
      this.onToolChanged = bind(this.onToolChanged, this);
      this.onToolChanging = bind(this.onToolChanging, this);
      this.checkHit = bind(this.checkHit, this);
      this.strokeColor = '#ff0000';
      this.backgroundColor = '';
      this.textColor = '#ff0000';
      this.strokeSize = 4;
      this.fontSize = 18;
      this.fontName = "Arial";
      this.isSelected = false;
    }

    Tool.prototype.checkHit = function (screen, x, y) {
      var child, cropRect, hitResult, i, j, num, p, ref, stage;
      if (!(screen != null ? screen.stage : void 0)) {
        return null;
      }
      p = this.editor.getActualPoint({
        x: x,
        y: y
      });
      cropRect = screen.cropRectangle;
      if ((cropRect != null) && (x < cropRect.x || x > (cropRect.x + cropRect.width) || y < cropRect.y || y > (cropRect.y + cropRect.height))) {
        return null;
      }
      stage = screen.stage;
      num = stage.children.length - 1;
      for (i = j = ref = num; ref <= 0 ? j <= 0 : j >= 0; i = ref <= 0 ? ++j : --j) {
        child = stage.children[i];
        if (!(child instanceof qTestExplorer.Shape)) {
          continue;
        }
        hitResult = child.checkHit(p.x, p.y);
        if (hitResult.status) {
          return new qTestExplorer.Hit(child, hitResult.cursor, hitResult.handle);
        }
      }
      return null;
    };

    Tool.prototype.onToolChanging = function (tool) {
      return this.deselect();
    };

    Tool.prototype.onToolChanged = function (tool) { };

    Tool.prototype.onScreenChanging = function (screen) {
      return this.deselect();
    };

    Tool.prototype.onScreenChanged = function (screen) { };

    Tool.prototype.onZoomChanged = function (zoom) {
      if (this.selected != null) {
        return this.selected.repaint();
      }
    };

    Tool.prototype.onStrokeColorChanged = function (color) {
      var state;
      this.strokeColor = color;
      if (this.selected && (this.selected.annotation.borderColor != null) && this.selected.annotation.borderColor !== color) {
        state = this.selected.getState();
        this.selected.setStrokeColor(color);
        return this.onChanged(this.selected, state, this.editor.currentScreen);
      }
    };

    Tool.prototype.onBackgroundColorChanged = function (color) {
      var state;
      this.backgroundColor = color;
      if (this.selected && (this.selected.annotation.backgroundColor != null) && this.selected.annotation.backgroundColor !== color) {
        state = this.selected.getState();
        this.selected.setBackgroundColor(color);
        return this.onChanged(this.selected, state, this.editor.currentScreen);
      }
    };

    Tool.prototype.onTextColorChanged = function (color) {
      var shape, state;
      this.textColor = color;
      if (!(this.selected instanceof qTestExplorer.TextBoundedShape)) {
        return;
      }
      shape = this.selected;
      if (shape.annotation.textColor !== color) {
        state = shape.getState();
        shape.setTextColor(color);
        return this.onChanged(shape, state, this.editor.currentScreen);
      }
    };

    Tool.prototype.onStrokeSizeChanged = function (size) {
      var state;
      this.strokeSize = size;
      if (this.selected && (this.selected.annotation.borderSize != null) && this.selected.annotation.borderSize !== size) {
        state = this.selected.getState();
        this.selected.setStrokeSize(size);
        return this.onChanged(this.selected, state, this.editor.currentScreen);
      }
    };

    Tool.prototype.onFontSizeChanged = function (size) {
      var shape, state;
      this.fontSize = size;
      if (!(this.selected instanceof qTestExplorer.TextBoundedShape)) {
        return;
      }
      shape = this.selected;
      if (shape.annotation.fontSize !== size) {
        state = shape.getState();
        shape.setFontSize(size);
        return this.onChanged(shape, state, this.editor.currentScreen);
      }
    };

    Tool.prototype.onFontNameChanged = function (name) {
      var shape, state;
      this.fontName = name;
      if (!(this.selected instanceof qTestExplorer.TextBoundedShape)) {
        return;
      }
      shape = this.selected;
      if (shape.annotation.fontName !== name) {
        state = shape.getState();
        shape.setFontName(name);
        return this.onChanged(shape, state, this.editor.currentScreen);
      }
    };

    Tool.prototype.onMouseDown = function (e) {
      var hitResult;
      this.startX = e.stageX;
      this.startY = e.stageY;
      this.isMouseDown = true;
      hitResult = this.checkHit(this.editor.currentScreen, this.startX, this.startY);
      if (hitResult != null) {
        this.lastX = e.stageX;
        this.lastY = e.stageY;
        this.select(hitResult.shape);
        this.state = this.selected.getState();
        return this.selectedHandle = hitResult.handle;
      } else {
        return this.deselect();
      }
    };

    Tool.prototype.onMouseMove = function (e) {
      var hitResult;
      if ((this.isMouseDown == null) || this.isMouseDown === false) {
        hitResult = this.checkHit(this.editor.currentScreen, e.stageX, e.stageY);
        return this.editor.cursor(hitResult != null ? hitResult.cursor : "default");
      }
    };

    Tool.prototype.onPressMove = function (e) {
      var currentP, lastP;
      if (this.selected) {
        lastP = this.editor.getActualPoint({
          x: this.lastX,
          y: this.lastY
        });
        currentP = this.editor.getActualPoint({
          x: e.stageX,
          y: e.stageY
        });
        this.selectedHandle = this.selected.moveBy(lastP.x, lastP.y, currentP.x - lastP.x, currentP.y - lastP.y, this.selectedHandle);
        this.lastX = e.stageX;
        this.lastY = e.stageY;
        return this.hasMoved = true;
      }
    };

    Tool.prototype.onMouseUp = function (e) {
      this.isMouseDown = false;
      return this.startX = this.startY = null;
    };

    Tool.prototype.onPressUp = function (e) {
      if (this.hasMoved) {
        this.onChanged(this.selected, this.state, this.editor.currentScreen);
      }
      this.selectedHandle = this.isMouseDown = this.hasMoved = null;
      this.isMouseDown = false;
      return this.startX = this.startY = null;
    };

    Tool.prototype.onKeyUp = function (e) {
      if ((this.selected != null) && (e.keyCode === 46 || e.keyCode === 8)) {
        return this.deselect(true);
      }
    };

    Tool.prototype.onKeyDown = function (e) { };

    Tool.prototype.onCreated = function (newShape, screen, applied) {
      var index, redoAction, undoAction;
      this.completedShape = newShape;
      index = screen.annotations.indexOf(newShape.annotation);
      newShape.annotation.id = qTestExplorer.GuidUtils.generateGuid();
      if (applied !== true) {
        this.editor.scope.$apply();
      }
      undoAction = (function (_this) {
        return function (screen, index) {
          return function () {
            if (index > -1) {
              screen.annotations.splice(index, 1);
            }
            return screen.update();
          };
        };
      })(this)(screen, index);
      redoAction = (function (_this) {
        return function (annotation, screen, index) {
          return function () {
            if (index > -1) {
              screen.annotations.splice(index, 0, annotation);
            }
            return screen.update();
          };
        };
      })(this)(newShape.annotation, screen, index);
      return this.editor.undo(undoAction, redoAction);
    };

    Tool.prototype.onRemoved = function (removedShape, screen) {
      var index, redoAction, undoAction;
      index = screen.annotations.indexOf(removedShape.annotation);
      undoAction = (function (_this) {
        return function (annotation, screen, index) {
          return function () {
            if (index > -1) {
              screen.annotations.splice(index, 0, annotation);
            }
            return screen.update();
          };
        };
      })(this)(removedShape.annotation, screen, index);
      redoAction = (function (_this) {
        return function (screen, index) {
          return function () {
            if (index > -1) {
              screen.annotations.splice(index, 1);
            }
            return screen.update();
          };
        };
      })(this)(screen, index);
      return this.editor.undo(undoAction, redoAction);
    };

    Tool.prototype.onChanged = function (changedShape, oldState, screen) {
      var redoAction, undoAction;
      screen.annotationUpdated++;
      undoAction = (function (_this) {
        return function (shape, state, screen) {
          return function () {
            shape.setState(state);
            screen.annotationUpdated++;
            return screen.update();
          };
        };
      })(this)(changedShape, oldState, screen);
      redoAction = (function (_this) {
        return function (shape, state, screen) {
          return function () {
            shape.setState(state);
            screen.annotationUpdated++;
            return screen.update();
          };
        };
      })(this)(changedShape, changedShape.getState(), screen);
      return this.editor.undo(undoAction, redoAction);
    };

    Tool.prototype.select = function (shape) {
      if (this.selected === shape) {
        return;
      }
      this.deselect();
      shape.select();
      this.selected = shape;
      return this.editor.annotationSelected(shape.annotation);
    };

    Tool.prototype.deselect = function (remove) {
      if (remove == null) {
        remove = false;
      }
      if (this.selected != null) {
        if (this.selected instanceof qTestExplorer.TextBoundedShape) {
          if ((this.state != null) && this.selected.annotation.content !== this.state.text) {
            this.onChanged(this.selected, this.state, this.editor.currentScreen);
          }
        }
        this.selected.deselect();
        if (remove === true) {
          this.onRemoved(this.selected, this.editor.currentScreen);
          this.editor.removeChild(this.selected);
          this.editor.scope.$apply();
          this.editor.repaint();
        }
        this.selected = this.state = null;
        return this.editor.annotationSelected(null);
      }
    };

    return Tool;

  })();

  Hit = (function () {
    function Hit(shape1, cursor, handle) {
      this.shape = shape1;
      this.cursor = cursor;
      this.handle = handle;
    }

    return Hit;

  })();

  qTestExplorer.Hit = Hit;

  qTestExplorer.Tool = Tool;

}).call(this);

(function () {
  var SelectTool,
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  SelectTool = (function (superClass) {
    extend(SelectTool, superClass);

    function SelectTool(editor) {
      SelectTool.__super__.constructor.call(this, 'select', editor);
    }

    return SelectTool;

  })(qTestExplorer.Tool);

  qTestExplorer.SelectTool = SelectTool;

}).call(this);

(function () {
  var RectangleTool,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  RectangleTool = (function (superClass) {
    extend(RectangleTool, superClass);

    function RectangleTool(editor) {
      this.onPressUp = bind(this.onPressUp, this);
      this.onPressMove = bind(this.onPressMove, this);
      RectangleTool.__super__.constructor.call(this, 'rectangle', editor);
    }

    RectangleTool.prototype.onPressMove = function (e) {
      var annotation, endP, startP;
      RectangleTool.__super__.onPressMove.call(this, e);
      if (this.selected) {
        return;
      }
      if (!this.drawingShape) {
        annotation = {
          annotationType: 'Rectangle',
          height: 0,
          left: 0,
          top: 0,
          width: 0,
          zindex: this.editor.currentScreen.annotations.length + 1,
          backgroundColor: this.backgroundColor,
          borderColor: this.strokeColor,
          borderSize: this.strokeSize
        };
        this.editor.currentScreen.annotations.push(annotation);
        this.drawingShape = new qTestExplorer.Rectangle(annotation);
        startP = this.editor.getActualPoint({
          x: this.startX,
          y: this.startY
        });
        this.drawingShape.startDraw(startP.x, startP.y);
        this.editor.addChild(this.drawingShape);
      }
      endP = this.editor.getActualPoint({
        x: e.stageX,
        y: e.stageY
      });
      return this.drawingShape.drawTo(endP.x, endP.y);
    };

    RectangleTool.prototype.onPressUp = function (e) {
      if (this.drawingShape) {
        this.drawingShape.endDraw();
        this.onCreated(this.drawingShape, this.editor.currentScreen);
      }
      this.drawingShape = null;
      return RectangleTool.__super__.onPressUp.call(this, e);
    };

    return RectangleTool;

  })(qTestExplorer.Tool);

  qTestExplorer.RectangleTool = RectangleTool;

}).call(this);

(function () {
  var EllipseTool,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  EllipseTool = (function (superClass) {
    extend(EllipseTool, superClass);

    function EllipseTool(editor) {
      this.onPressUp = bind(this.onPressUp, this);
      this.onPressMove = bind(this.onPressMove, this);
      EllipseTool.__super__.constructor.call(this, 'ellipse', editor);
    }

    EllipseTool.prototype.onPressMove = function (e) {
      var annotation, endP, startP;
      EllipseTool.__super__.onPressMove.call(this, e);
      if (this.selected) {
        return;
      }
      if (!this.drawingShape) {
        annotation = {
          annotationType: 'Ellipse',
          height: 0,
          left: 0,
          top: 0,
          width: 0,
          zindex: this.editor.currentScreen.annotations.length + 1,
          backgroundColor: this.backgroundColor,
          borderColor: this.strokeColor,
          borderSize: this.strokeSize
        };
        this.editor.currentScreen.annotations.push(annotation);
        this.drawingShape = new qTestExplorer.Ellipse(annotation);
        startP = this.editor.getActualPoint({
          x: this.startX,
          y: this.startY
        });
        this.drawingShape.startDraw(startP.x, startP.y);
        this.editor.addChild(this.drawingShape);
        this.editor.scope.$apply();
      }
      endP = this.editor.getActualPoint({
        x: e.stageX,
        y: e.stageY
      });
      return this.drawingShape.drawTo(endP.x, endP.y);
    };

    EllipseTool.prototype.onPressUp = function (e) {
      if (this.drawingShape) {
        this.drawingShape.endDraw();
        this.onCreated(this.drawingShape, this.editor.currentScreen);
      }
      this.drawingShape = null;
      return EllipseTool.__super__.onPressUp.call(this, e);
    };

    return EllipseTool;

  })(qTestExplorer.Tool);

  qTestExplorer.EllipseTool = EllipseTool;

}).call(this);

(function () {
  var ArrowTool,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  ArrowTool = (function (superClass) {
    extend(ArrowTool, superClass);

    function ArrowTool(editor) {
      this.onPressUp = bind(this.onPressUp, this);
      this.onPressMove = bind(this.onPressMove, this);
      ArrowTool.__super__.constructor.call(this, 'arrow', editor);
    }

    ArrowTool.prototype.onPressMove = function (e) {
      var annotation, endP, startP;
      ArrowTool.__super__.onPressMove.call(this, e);
      if (this.selected) {
        return;
      }
      if (!this.drawingShape) {
        annotation = {
          annotationType: 'Arrow',
          borderColor: this.strokeColor,
          borderSize: this.strokeSize,
          startPoint: {
            x: 0,
            y: 0
          },
          endPoint: {
            x: 0,
            y: 0
          },
          zindex: this.editor.currentScreen.annotations.length + 1
        };
        this.editor.currentScreen.annotations.push(annotation);
        this.drawingShape = new qTestExplorer.Arrow(annotation);
        startP = this.editor.getActualPoint({
          x: this.startX,
          y: this.startY
        });
        this.drawingShape.startDraw(startP.x, startP.y);
        this.editor.addChild(this.drawingShape);
      }
      endP = this.editor.getActualPoint({
        x: e.stageX,
        y: e.stageY
      });
      return this.drawingShape.drawTo(endP.x, endP.y);
    };

    ArrowTool.prototype.onPressUp = function (e) {
      if (this.drawingShape) {
        this.drawingShape.endDraw();
        this.onCreated(this.drawingShape, this.editor.currentScreen);
      }
      this.drawingShape = null;
      return ArrowTool.__super__.onPressUp.call(this, e);
    };

    return ArrowTool;

  })(qTestExplorer.Tool);

  qTestExplorer.ArrowTool = ArrowTool;

}).call(this);

(function () {
  var TextTool,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  TextTool = (function (superClass) {
    extend(TextTool, superClass);

    function TextTool(editor) {
      this.onPressUp = bind(this.onPressUp, this);
      TextTool.__super__.constructor.call(this, 'text', editor);
    }

    TextTool.prototype.onPressUp = function (e) {
      var annotation, endP;
      TextTool.__super__.onPressUp.call(this, e);
      if (this.selected) {
        return;
      }
      annotation = {
        annotationType: "TextBox",
        height: 0,
        left: 0,
        top: 0,
        width: 0,
        backgroundColor: "",
        borderColor: this.strokeColor,
        borderSize: this.strokeSize,
        content: "New text",
        fontName: this.fontName,
        fontSize: this.fontSize,
        textColor: this.textColor,
        dropShadow: false,
        zindex: this.editor.currentScreen.annotations.length + 1
      };
      this.editor.currentScreen.annotations.push(annotation);
      this.drawingShape = new qTestExplorer.ShapeText(annotation, this.editor.textBox);
      this.editor.addChild(this.drawingShape);
      endP = this.editor.getActualPoint({
        x: e.stageX,
        y: e.stageY
      });
      this.drawingShape.drawTo(endP.x, endP.y);
      this.drawingShape.endDraw();
      this.onCreated(this.drawingShape, this.editor.currentScreen);
      this.drawingShape = null;
      return TextTool.__super__.onPressUp.call(this, e);
    };

    return TextTool;

  })(qTestExplorer.Tool);

  qTestExplorer.TextTool = TextTool;

}).call(this);

(function () {
  var CalloutBaseTool,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  CalloutBaseTool = (function (superClass) {
    extend(CalloutBaseTool, superClass);

    function CalloutBaseTool(name, type, editor) {
      this.type = type;
      this.onPressUp = bind(this.onPressUp, this);
      this.onPressMove = bind(this.onPressMove, this);
      this.createCalloutShape = bind(this.createCalloutShape, this);
      this.createCallout = bind(this.createCallout, this);
      CalloutBaseTool.__super__.constructor.call(this, name, editor);
    }

    CalloutBaseTool.prototype.createCallout = function () {
      var annotation;
      annotation = {
        annotationType: 'Callout',
        type: this.type,
        height: 0,
        left: 0,
        top: 0,
        width: 0,
        anchorPoint: {
          x: 0,
          y: 0
        },
        additionalAnchorPoints: [],
        zindex: this.editor.currentScreen.annotations.length + 1,
        backgroundColor: this.backgroundColor,
        borderColor: this.strokeColor,
        borderSize: this.strokeSize,
        content: "New callout",
        fontName: this.fontName,
        fontSize: this.fontSize,
        textColor: this.textColor
      };
      return annotation;
    };

    CalloutBaseTool.prototype.createCalloutShape = function (annotation, textBox) { };

    CalloutBaseTool.prototype.onPressMove = function (e) {
      var annotation, endP, startP;
      CalloutBaseTool.__super__.onPressMove.call(this, e);
      if (this.selected) {
        return;
      }
      if (!this.drawingShape) {
        annotation = this.createCallout();
        this.editor.currentScreen.annotations.push(annotation);
        this.drawingShape = this.createCalloutShape(annotation, this.editor.textBox);
        this.drawingShape.setIsDefaultAnchor(true);
        startP = this.editor.getActualPoint({
          x: this.startX,
          y: this.startY
        });
        this.drawingShape.startDraw(startP.x, startP.y);
        this.editor.addChild(this.drawingShape);
      }
      endP = this.editor.getActualPoint({
        x: e.stageX,
        y: e.stageY
      });
      return this.drawingShape.drawTo(endP.x, endP.y);
    };

    CalloutBaseTool.prototype.onPressUp = function (e) {
      if (this.drawingShape) {
        this.drawingShape.endDraw();
        this.onCreated(this.drawingShape, this.editor.currentScreen);
      }
      this.drawingShape = null;
      return CalloutBaseTool.__super__.onPressUp.call(this, e);
    };

    return CalloutBaseTool;

  })(qTestExplorer.Tool);

  qTestExplorer.CalloutBaseTool = CalloutBaseTool;

}).call(this);

(function () {
  var CalloutTool,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  CalloutTool = (function (superClass) {
    extend(CalloutTool, superClass);

    function CalloutTool(editor) {
      this.createCalloutShape = bind(this.createCalloutShape, this);
      CalloutTool.__super__.constructor.call(this, 'callout', 'round', editor);
    }

    CalloutTool.prototype.createCalloutShape = function (annotation, textBox) {
      return new qTestExplorer.RoundedRectangularCallout(annotation, textBox);
    };

    return CalloutTool;

  })(qTestExplorer.CalloutBaseTool);

  qTestExplorer.CalloutTool = CalloutTool;

}).call(this);

(function () {
  var SquareCalloutTool,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  SquareCalloutTool = (function (superClass) {
    extend(SquareCalloutTool, superClass);

    function SquareCalloutTool(editor) {
      this.createCalloutShape = bind(this.createCalloutShape, this);
      SquareCalloutTool.__super__.constructor.call(this, 'squareCallout', 'square', editor);
    }

    SquareCalloutTool.prototype.createCalloutShape = function (annotation, textBox) {
      return new qTestExplorer.RectangularCallout(annotation, textBox);
    };

    return SquareCalloutTool;

  })(qTestExplorer.CalloutBaseTool);

  qTestExplorer.SquareCalloutTool = SquareCalloutTool;

}).call(this);

(function () {
  var OvalCalloutTool,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  OvalCalloutTool = (function (superClass) {
    extend(OvalCalloutTool, superClass);

    function OvalCalloutTool(editor) {
      this.createCalloutShape = bind(this.createCalloutShape, this);
      OvalCalloutTool.__super__.constructor.call(this, 'ovalCallout', 'oval', editor);
    }

    OvalCalloutTool.prototype.createCalloutShape = function (annotation, textBox) {
      return new qTestExplorer.OvalCallout(annotation, textBox);
    };

    return OvalCalloutTool;

  })(qTestExplorer.CalloutBaseTool);

  qTestExplorer.OvalCalloutTool = OvalCalloutTool;

}).call(this);

(function () {
  var CloudCalloutTool,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  CloudCalloutTool = (function (superClass) {
    extend(CloudCalloutTool, superClass);

    function CloudCalloutTool(editor) {
      this.createCalloutShape = bind(this.createCalloutShape, this);
      CloudCalloutTool.__super__.constructor.call(this, 'cloudCallout', 'cloud', editor);
    }

    CloudCalloutTool.prototype.createCalloutShape = function (annotation, textBox) {
      return new qTestExplorer.CloudCallout(annotation, textBox);
    };

    return CloudCalloutTool;

  })(qTestExplorer.CalloutBaseTool);

  qTestExplorer.CloudCalloutTool = CloudCalloutTool;

}).call(this);

(function () {
  var Line1CalloutTool,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Line1CalloutTool = (function (superClass) {
    extend(Line1CalloutTool, superClass);

    function Line1CalloutTool(editor) {
      this.createCalloutShape = bind(this.createCalloutShape, this);
      Line1CalloutTool.__super__.constructor.call(this, 'line1Callout', 'line1', editor);
    }

    Line1CalloutTool.prototype.createCalloutShape = function (annotation, textBox) {
      return new qTestExplorer.Line1Callout(annotation, textBox, false);
    };

    return Line1CalloutTool;

  })(qTestExplorer.CalloutBaseTool);

  qTestExplorer.Line1CalloutTool = Line1CalloutTool;

}).call(this);

(function () {
  var Line2CalloutTool,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Line2CalloutTool = (function (superClass) {
    extend(Line2CalloutTool, superClass);

    function Line2CalloutTool(editor) {
      this.createCalloutShape = bind(this.createCalloutShape, this);
      Line2CalloutTool.__super__.constructor.call(this, 'line2Callout', 'line2', editor);
    }

    Line2CalloutTool.prototype.createCalloutShape = function (annotation, textBox) {
      return new qTestExplorer.Line2Callout(annotation, textBox, false);
    };

    return Line2CalloutTool;

  })(qTestExplorer.CalloutBaseTool);

  qTestExplorer.Line2CalloutTool = Line2CalloutTool;

}).call(this);

(function () {
  var Line3CalloutTool,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Line3CalloutTool = (function (superClass) {
    extend(Line3CalloutTool, superClass);

    function Line3CalloutTool(editor) {
      this.createCalloutShape = bind(this.createCalloutShape, this);
      Line3CalloutTool.__super__.constructor.call(this, 'line3Callout', 'line3', editor);
    }

    Line3CalloutTool.prototype.createCalloutShape = function (annotation, textBox) {
      return new qTestExplorer.Line3Callout(annotation, textBox, false);
    };

    return Line3CalloutTool;

  })(qTestExplorer.CalloutBaseTool);

  qTestExplorer.Line3CalloutTool = Line3CalloutTool;

}).call(this);

(function () {
  var Line1AccentBarCalloutTool,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Line1AccentBarCalloutTool = (function (superClass) {
    extend(Line1AccentBarCalloutTool, superClass);

    function Line1AccentBarCalloutTool(editor) {
      this.createCalloutShape = bind(this.createCalloutShape, this);
      Line1AccentBarCalloutTool.__super__.constructor.call(this, 'line1AccentBarCallout', 'line1AccentBar', editor);
    }

    Line1AccentBarCalloutTool.prototype.createCalloutShape = function (annotation, textBox) {
      return new qTestExplorer.Line1Callout(annotation, textBox, true);
    };

    return Line1AccentBarCalloutTool;

  })(qTestExplorer.CalloutBaseTool);

  qTestExplorer.Line1AccentBarCalloutTool = Line1AccentBarCalloutTool;

}).call(this);

(function () {
  var Line2AccentBarCalloutTool,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Line2AccentBarCalloutTool = (function (superClass) {
    extend(Line2AccentBarCalloutTool, superClass);

    function Line2AccentBarCalloutTool(editor) {
      this.createCalloutShape = bind(this.createCalloutShape, this);
      Line2AccentBarCalloutTool.__super__.constructor.call(this, 'line2AccentBarCallout', 'line2AccentBar', editor);
    }

    Line2AccentBarCalloutTool.prototype.createCalloutShape = function (annotation, textBox) {
      return new qTestExplorer.Line2Callout(annotation, textBox, true);
    };

    return Line2AccentBarCalloutTool;

  })(qTestExplorer.CalloutBaseTool);

  qTestExplorer.Line2AccentBarCalloutTool = Line2AccentBarCalloutTool;

}).call(this);

(function () {
  var Line3AccentBarCalloutTool,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  Line3AccentBarCalloutTool = (function (superClass) {
    extend(Line3AccentBarCalloutTool, superClass);

    function Line3AccentBarCalloutTool(editor) {
      this.createCalloutShape = bind(this.createCalloutShape, this);
      Line3AccentBarCalloutTool.__super__.constructor.call(this, 'line3AccentBarCallout', 'line3AccentBar', editor);
    }

    Line3AccentBarCalloutTool.prototype.createCalloutShape = function (annotation, textBox) {
      return new qTestExplorer.Line3Callout(annotation, textBox, true);
    };

    return Line3AccentBarCalloutTool;

  })(qTestExplorer.CalloutBaseTool);

  qTestExplorer.Line3AccentBarCalloutTool = Line3AccentBarCalloutTool;

}).call(this);

(function () {
  var PencilTool,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  PencilTool = (function (superClass) {
    extend(PencilTool, superClass);

    function PencilTool(editor) {
      this.onPressUp = bind(this.onPressUp, this);
      this.onPressMove = bind(this.onPressMove, this);
      PencilTool.__super__.constructor.call(this, 'pencil', editor);
    }

    PencilTool.prototype.onPressMove = function (e) {
      var endP, startP;
      PencilTool.__super__.onPressMove.call(this, e);
      if (this.selected) {
        return;
      }
      if (!this.drawingShape) {
        this.annotation = {
          annotationType: "Pencil",
          borderColor: this.strokeColor,
          borderSize: this.strokeSize,
          points: [],
          zindex: this.editor.currentScreen.annotations.length + 1
        };
        this.drawingShape = new qTestExplorer.Pencil(this.annotation);
        this.editor.currentScreen.annotations.push(this.drawingShape.annotation);
        startP = this.editor.getActualPoint({
          x: this.startX,
          y: this.startY
        });
        this.drawingShape.startDraw(startP.x, startP.y);
        this.editor.addChild(this.drawingShape);
      }
      endP = this.editor.getActualPoint({
        x: e.stageX,
        y: e.stageY
      });
      return this.drawingShape.drawTo(endP.x, endP.y);
    };

    PencilTool.prototype.onPressUp = function (e) {
      if (this.drawingShape) {
        this.drawingShape.endDraw();
        this.onCreated(this.drawingShape, this.editor.currentScreen);
      }
      this.drawingShape = null;
      return PencilTool.__super__.onPressUp.call(this, e);
    };

    return PencilTool;

  })(qTestExplorer.Tool);

  qTestExplorer.PencilTool = PencilTool;

}).call(this);

(function () {
  var BlackoutTool,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  BlackoutTool = (function (superClass) {
    extend(BlackoutTool, superClass);

    function BlackoutTool(editor) {
      this.onPressUp = bind(this.onPressUp, this);
      this.onPressMove = bind(this.onPressMove, this);
      BlackoutTool.__super__.constructor.call(this, 'blackout', editor);
    }

    BlackoutTool.prototype.onPressMove = function (e) {
      var annotation, endP, startP;
      BlackoutTool.__super__.onPressMove.call(this, e);
      if (this.selected) {
        return;
      }
      if (!this.drawingShape) {
        annotation = {
          annotationType: 'Blackout',
          height: 0,
          left: 0,
          top: 0,
          width: 0,
          zindex: 0
        };
        this.editor.currentScreen.annotations.push(annotation);
        this.drawingShape = new qTestExplorer.Blackout(annotation, new createjs.Bitmap(this.editor.currentScreen.backgroundImage));
        startP = this.editor.getActualPoint({
          x: this.startX,
          y: this.startY
        });
        this.drawingShape.startDraw(startP.x, startP.y);
        this.editor.currentScreen.stage.addChildAt(this.drawingShape, 1);
      }
      endP = this.editor.getActualPoint({
        x: e.stageX,
        y: e.stageY
      });
      return this.drawingShape.drawTo(endP.x, endP.y);
    };

    BlackoutTool.prototype.onPressUp = function (e) {
      if (this.drawingShape) {
        this.drawingShape.endDraw();
        this.onCreated(this.drawingShape, this.editor.currentScreen);
      }
      this.drawingShape = null;
      return BlackoutTool.__super__.onPressUp.call(this, e);
    };

    return BlackoutTool;

  })(qTestExplorer.Tool);

  qTestExplorer.BlackoutTool = BlackoutTool;

}).call(this);

(function () {
  var CropTool,
    bind = function (fn, me) { return function () { return fn.apply(me, arguments); }; },
    extend = function (child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    hasProp = {}.hasOwnProperty;

  CropTool = (function (superClass) {
    var checkHit;

    extend(CropTool, superClass);

    function CropTool(editor) {
      this.AddUndoRedo = bind(this.AddUndoRedo, this);
      this.doCrop = bind(this.doCrop, this);
      this.addCrop = bind(this.addCrop, this);
      this.removeCrop = bind(this.removeCrop, this);
      this.onScreenChanged = bind(this.onScreenChanged, this);
      this.onScreenChanging = bind(this.onScreenChanging, this);
      this.onToolChanged = bind(this.onToolChanged, this);
      this.onPressUp = bind(this.onPressUp, this);
      this.onPressMove = bind(this.onPressMove, this);
      this.onMouseDown = bind(this.onMouseDown, this);
      this.onMouseMove = bind(this.onMouseMove, this);
      CropTool.__super__.constructor.call(this, 'crop', editor);
    }

    CropTool.prototype.onMouseMove = function (e) {
      var hitResult, p, x, y;
      p = this.editor.getActualPoint({
        x: e.stageX,
        y: e.stageY
      });
      x = p.x;
      y = p.y;
      if (this.cropShape == null) {
        return this.editor.cursor("crosshair");
      } else {
        if ((this.isMouseDown == null) || this.isMouseDown === false) {
          hitResult = checkHit(this.editor.currentScreen.stage, this.cropShape, x, y);
          return this.editor.cursor(hitResult != null ? hitResult.cursor : "default");
        }
      }
    };

    CropTool.prototype.onMouseDown = function (e) {
      var lastP, lastX, lastY;
      this.startX = e.stageX;
      this.startY = e.stageY;
      this.isMouseDown = true;
      this.lastX = e.stageX;
      this.lastY = e.stageY;
      lastP = this.editor.getActualPoint({
        x: this.lastX,
        y: this.lastY
      });
      lastX = lastP.x;
      lastY = lastP.y;
      if (this.cropShape != null) {
        this.hitResult = checkHit(this.editor.currentScreen.stage, this.cropShape, lastX, lastY);
        if (this.hitResult != null) {
          return this.selectedHandle = this.hitResult.handle;
        }
      }
    };

    CropTool.prototype.onPressMove = function (e) {
      var lastP, lastX, lastY, p, rect, sourceRect, startP, startX, startY, x, y;
      p = this.editor.getActualPoint({
        x: e.stageX,
        y: e.stageY
      });
      x = p.x;
      y = p.y;
      startP = this.editor.getActualPoint({
        x: this.startX,
        y: this.startY
      });
      startX = startP.x;
      startY = startP.y;
      lastP = this.editor.getActualPoint({
        x: this.lastX,
        y: this.lastY
      });
      lastX = lastP.x;
      lastY = lastP.y;
      if (!this.cropShape) {
        this.isDrawing = true;
        this.cropShape = new qTestExplorer.Crop();
        this.cropShape.startDraw(startX, startY);
        this.editor.addChild(this.cropShape);
        return this.editor.currentScreen.selectCrop = true;
      } else {
        if (this.isDrawing) {
          this.cropShape.drawTo(x, y);
          return this.doCrop(e);
        } else {
          if (this.hitResult) {
            this.selectedHandle = this.cropShape.moveBy(lastX, lastY, x - lastX, y - lastY, this.selectedHandle);
            rect = this.cropShape.getBound();
            if (!this.hasMoved) {
              sourceRect = this.editor.currentScreen.cropRectangle;
              if ((sourceRect != null) && sourceRect.x > 0 && sourceRect.y > 0 && sourceRect.width > 0 && sourceRect.height > 0) {
                this.startSourceRect = new createjs.Rectangle(sourceRect.x, sourceRect.y, sourceRect.width, sourceRect.height);
              } else {
                this.startSourceRect = null;
              }
              this.hasMoved = true;
            }
            this.editor.currentScreen.cropRectangle = new createjs.Rectangle(rect.x, rect.y, rect.width, rect.height);
            this.editor.currentScreen.stage.update();
            this.lastX = e.stageX;
            return this.lastY = e.stageY;
          }
        }
      }
    };

    CropTool.prototype.onPressUp = function (e) {
      var rect;
      if (this.cropShape && this.isDrawing) {
        this.doCrop(e, true);
        this.cropShape.endDraw();
        this.cropShape.select();
        this.editor.currentScreen.annotationUpdated++;
        this.editor.scope.$apply();
      } else {
        if (this.hasMoved === true) {
          rect = this.startSourceRect;
          this.AddUndoRedo((rect != null ? new createjs.Rectangle(rect.x, rect.y, rect.width, rect.height) : null), this.editor.currentScreen.cropRectangle);
          this.editor.currentScreen.annotationUpdated++;
          this.editor.scope.$apply();
        }
      }
      this.hasMoved = false;
      this.isDrawing = false;
      this.hitResult = null;
      this.selectedHandle = null;
      this.isMouseDown = false;
      return this.startX = this.startY = null;
    };

    CropTool.prototype.onToolChanged = function (tool) {
      if (this.editor.currentScreen == null) {
        return;
      }
      if (tool.name !== 'crop') {
        this.isSelected = false;
        return this.removeCrop();
      } else {
        this.isSelected = true;
        return this.addCrop();
      }
    };

    CropTool.prototype.onScreenChanging = function (screen) {
      return this.removeCrop();
    };

    CropTool.prototype.onScreenChanged = function (screen) {
      if (this.isSelected && screen.cropRectangle) {
        return this.addCrop();
      }
    };

    CropTool.prototype.removeCrop = function () {
      if (this.cropShape) {
        this.cropShape.deselect();
        if (this.editor.currentScreen.stage != null) {
          this.editor.currentScreen.stage.removeChild(this.cropShape);
        }
        this.editor.currentScreen.selectCrop = false;
        if (this.editor.currentScreen.stage != null) {
          this.editor.currentScreen.stage.update();
        }
        this.cropShape = this.startSourceRect = null;
        return this.isDrawing = false;
      }
    };

    CropTool.prototype.addCrop = function () {
      var rect;
      this.removeCrop();
      if (this.isSelected && this.editor.currentScreen.cropRectangle && this.editor.currentScreen.cropRectangle.width > 0 && this.editor.currentScreen.cropRectangle.height > 0) {
        this.editor.currentScreen.selectCrop = true;
        rect = this.editor.currentScreen.cropRectangle;
        this.cropShape = new qTestExplorer.Crop(rect.x, rect.y, rect.width, rect.height);
        this.editor.addChild(this.cropShape);
        return this.cropShape.select();
      }
    };

    CropTool.prototype.doCrop = function (e, save) {
      var h, newSourceRect, rect, screen, w, x, y;
      x = Math.min(this.startX, e.stageX);
      y = Math.min(this.startY, e.stageY);
      w = Math.abs(this.startX - e.stageX);
      h = Math.abs(this.startY - e.stageY);
      rect = this.editor.getActualRect({
        x: x,
        y: y,
        w: w,
        h: h
      });
      screen = this.editor.currentScreen;
      newSourceRect = new createjs.Rectangle(rect.x, rect.y, rect.w, rect.h);
      if (w <= 0 || h <= 0) {
        return;
      }
      screen.cropRectangle = newSourceRect;
      screen.stage.update();
      if (save === true) {
        rect = this.startSourceRect;
        return this.AddUndoRedo((rect != null ? new createjs.Rectangle(rect.x, rect.y, rect.width, rect.height) : null), newSourceRect);
      }
    };

    CropTool.prototype.AddUndoRedo = function (startSourceRect, newSourceRect) {
      var redoAction, undoAction;
      undoAction = (function (_this) {
        return function (screen, rect) {
          return function () {
            if (_this.cropShape) {
              _this.cropShape.deselect();
            }
            if (rect == null) {
              screen.cropRectangle = null;
              _this.removeCrop();
            } else {
              screen.cropRectangle = rect;
              _this.addCrop();
            }
            _this.isDrawing = false;
            screen.annotationUpdated++;
            return screen.stage.update();
          };
        };
      })(this)(this.editor.currentScreen, startSourceRect);
      redoAction = (function (_this) {
        return function (screen, rect) {
          return function () {
            if (_this.cropShape) {
              _this.cropShape.deselect();
            }
            if (rect == null) {
              screen.cropRectangle = null;
              _this.removeCrop();
            } else {
              screen.cropRectangle = rect;
              if (_this.isSelected === true && rect) {
                _this.addCrop();
              }
            }
            _this.isDrawing = false;
            screen.annotationUpdated++;
            return screen.stage.update();
          };
        };
      })(this)(this.editor.currentScreen, newSourceRect);
      return this.editor.undo(undoAction, redoAction);
    };

    checkHit = function (stage, shape, x, y) {
      var child, hitResult;
      if (shape == null) {
        return null;
      }
      child = shape;
      hitResult = child.checkHit(x, y);
      if (hitResult.status) {
        return new qTestExplorer.Hit(child, hitResult.cursor, hitResult.handle);
      }
    };

    return CropTool;

  })(qTestExplorer.Tool);

  qTestExplorer.CropTool = CropTool;

}).call(this);

(function () {


}).call(this);
